#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "bill.h"
#include "merge.h"
#include "sum.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset(
    "(bill)(sum)(save)(counter):(upto):(type):(merge)(formatted)"
    "(month):(year):(format):(accumulate):(mail)") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="listgen.log";
    logf.setlogfile(logfile);
   }

  if(cmdline.isset("bill"))
    dobill(cmdline);
  else if(cmdline.isset("sum"))
    dosum(cmdline);
  else if(cmdline.isset("merge"))
   {
    if(cmdline.argcount!=2)
      help();
    else
      merge(cmdline);
   }
  else
    help();

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * BILLING - DBOX Billing Module - Version " DBOXVERSIONNR
      " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " billing [-?] [-h] [--help]   display help\n"
    " billing --bill               bill given users (stdin)\n"
    " billing --sum                bill given users (stdin)\n"
    " billing --merge file1 file2  merge transactions\n"
    "\n"
    "Additional options for --sum:\n"
    " --formatted                  format the figures\n"
    " --month month                sum up a month\n"
    " --year  year                 sum up a year\n"
    "\n"
    "Additional options for --bill:\n"
    " --save                       store new counter value\n"
    " --counter nr.                set counter which is to be used\n"
    " --upto nr.                   bill up to given entry number\n"
    " --month month                bill up to given month\n"
    " --year  year                 bill up to given year\n"
    " --format F                   output format: e=export, t=text, l=LaTex\n"
    " --accumulate file            accumulate entries given in the file\n"
    " --type 1                     generate account statement\n"
    " --type 2                     generate invoice\n"
    " --type 3                     generate invoice including payments\n"
    " --mail                       mail bill instead of displaying it\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
