#include <unistd.h>
#include <stdio.h>

#include <account.h>
#include "merge.h"

#define MAXLEN 10000

bool get_line(char *line, buchungt &trans, FILE *infile)
 {
  char *tptr;
  if(fgets(line, MAXLEN-1, infile)==NULL) return TRUE;
  tptr=strchr(line, '\r'); if(tptr!=NULL) *tptr=0;
  tptr=strchr(line, '\n'); if(tptr!=NULL) *tptr=0;
  if(line[0]==0) return TRUE;

  tptr=strdup(line);
  trans.parse(tptr);
  free(tptr);

  return FALSE;
 }

void write_line(FILE *out, char *line, buchungt &trans, dword &line_nr)
 {
  if(line_nr==trans.number)
    fprintf(out, "%s\n", line);
  else
   {
    trans.number=line_nr;
    trans.write(out);
   }

  line_nr++;
 }

void merge(FILE *in1, FILE *in2, FILE *out)
 {
  char *line1, *line2;
  buchungt trans1, trans2;
  dword line_nr=0;

  line1=(char *)malloc(MAXLEN);
  line2=(char *)malloc(MAXLEN);
  if(line1==NULL || line2==NULL) abort();

  line1[0]=line2[0]=0;

  while(TRUE)
   {
    if(line1[0]==0)
     {
      if(get_line(line1, trans1, in1))
       {
        if(line2[0]!=0)
          write_line(out, line2, trans2, line_nr);

        while(!get_line(line2, trans2, in2))
          write_line(out, line2, trans2, line_nr);

        free(line1);
        free(line2);
        return;
       }
     }

    if(line2[0]==0)
     {
      if(get_line(line2, trans2, in2))
       {
        if(line1[0]!=0)
          write_line(out, line1, trans1, line_nr);

        while(!get_line(line1, trans1, in1))
          write_line(out, line1, trans1, line_nr);

        free(line1);
        free(line2);
        return;
       }
     }

    if(trans1.datum==trans2.datum &&
       trans1.amount==trans2.amount &&
       trans1.haben==trans2.haben &&
       strcmp(trans1.verwendungszweck, trans2.verwendungszweck)==0)
     {
      write_line(out, line1, trans1, line_nr);
      line1[0]=line2[0]=0;
     }
    else if(trans1.datum<trans2.datum)
     {
      write_line(out, line1, trans1, line_nr);
      line1[0]=0;
     }
    else
     {
      write_line(out, line2, trans2, line_nr);
      line2[0]=0;
     }
   }
 }

void merge(cmdlinet &cmdline)
 {
  FILE *in1, *in2;

  chdir(config.cwd);

  in1=fopen(cmdline.args[0], "rt");
  if(in1==NULL)
   {
    cerr << "failed to open " << cmdline.args[0] << "\n";
    return;
   }
  
  in2=fopen(cmdline.args[1], "rt");
  if(in2==NULL)
   {
    cerr << "failed to open " << cmdline.args[1] << "\n";
    fclose(in1);
    return;
   }

  merge(in1, in2, stdout);
 
  fclose(in1);
  fclose(in2);
 }
