/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <userdb.h>
#include <tools.h>
#include "checkalias.h"

void checkalias()
 {
  userpt up, up2;
  char username[TEXTLEN];
  char *tptr;

  while(fgets(username, TEXTLEN-1, stdin)!=NULL)
    if(username[0]!=0 && username[0]!='.' && username[0]!='_')
     {
      tptr=strchr(username, '\r'); if(tptr!=NULL) *tptr=0;
      tptr=strchr(username, '\n'); if(tptr!=NULL) *tptr=0;

      tptr=strrchr(username, '/');
      if(tptr!=NULL) *tptr=0;

      up.setname(username);
      if(up.read())
        cerr << "Not found: " << up.name << "\n";
      else
       {
        string alias;
        up.get("alias", alias);
        if(alias=="")
         {
          string filename=up.getpath();
          filename+="alias";
          const char *alias_list=readtextconfigfile(filename.c_str());
          if(alias_list!=(const char *)NULL)
           {
            const char *a=alias_list;
            while(a[0]!=0)
             {
              up2.setname(a);
              if(up2.read())
                cerr << up.name << ": alias " << up2.name << " does not exist\n";
              else if(strcmp(up2.get("alias"), up.name)!=0)
                cerr << up.name << ": alias " << up2.name << " has wrong owner\n";
 
              a+=strlen(a)+1;
             }
            free((void *)alias_list);
           }
         }
        else
         {
          up2.setname(alias);
          if(up2.read())
            cerr << up.name << ": owner " << up2.name << " does not exist\n";
          else
           {
            if((up2|"alias")[0]!=0)
              cerr << up.name << ": owner " << up2.name << " is an alias\n";
            else
             {
              string filename=up2.getpath();
              filename+="alias";
              const char *alias_list=readtextconfigfile(filename.c_str());
              if(alias_list!=(const char *)NULL)
               {
                const char *a=alias_list;
                while(a[0]!=0)
                 {
                  if(stricmp(a, up.name)==0) break;
                  a+=strlen(a)+1;
                 }
        
                if(a[0]==0)
                  cerr << up.name << ": not in alias list of " << up2.name << "\n";
                 
                free((void *)alias_list);
               }
             }
           }
         }
       }
     }
 }
