/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "dboxdb.h"
#include "checkalias.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("u:(set):(print):(path)"
    "(checkalias)") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="dboxdb.log";
    logf.setlogfile(logfile);
   }

  userpt up;

  if(cmdline.isset('u'))
    up.setname(cmdline.getval('u'));

  if(up.name[0]!=0)
   {
    if(up.read())
     {
      fprintf(stderr, "User %s not found\n", up.name);
      return FALSE;
     }
   }

  if(cmdline.isset("path") && up.name[0]!=0)
    cout << up.getpath() << "\n";
  else if(cmdline.isset("print") && up.name[0]!=0)
    cout << up.get(cmdline.getval("print")) << "\n";
  else if(cmdline.isset("set") && up.name[0]!=0)
    doset(up, cmdline.getval("set"));
  else if(cmdline.isset("checkalias"))
    checkalias();
  else
    help();

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * DBOXDB - DBOX Module for Database Access - Version " DBOXVERSIONNR
      " * *\n"
    "\n"
    "Usage:\n"
    "\n"
    " dboxdb [-?] [-h] [--help]    display help\n"
    " dboxdb -u name --set id=val  set profile values\n"
    " dboxdb -u name --print id    print value of id of a given user\n"
    " dboxdb -u user --path        print user path\n"
    " dboxdb --checkalias          check alias consistency (stdin)\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
