#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <getopt.h>

#include <dboxpath.h>
#include <logf.h>
#include <folder.h>
#include <flags.h>
#include <oldtools.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <account.h>
#include <portinfo.h>
#include <logins.h>
#include "dboxftpd.h"

static bool parseoptions(int argc, char **argv)
 {
  char *tptr;
  char boxname[TEXTLEN]="";

  tptr=strrchr(argv[0], DIRCHAR[0]);
  if(tptr==NULL) tptr=argv[0]; else tptr++;

  switch(getopt(argc, argv, "?hb:"))
   {
   case '?':
   case 'h':
    goto help;

   case 'b':
    strmaxcpy(boxname, optarg, TEXTLEN-1);
    break;

   case -1:
    break;

   case ':':
    printf("\n\nParameter fehlt! - ");
    goto aufruf;

   default:
    goto aufruf;
   }

  if(config.read(boxname))
    return TRUE;

   { 
    char logfile[DIRLEN];
    snprintf(logfile, DIRLEN, BOXLOGDIR "dboxftpd.log", config.boxdir);
    logf.setlogfile(logfile);
   }

  dboxftpd();
 
  return FALSE;

 aufruf:
  printf("Falscher Aufruf!\n");

 help:
  printf(
    "\n"
    "* * WEBONLINE - DBox Modul fr Onlineverbindungen - "
    "Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Aufruf:                      Aktion:\r\n"
    "\n"
    " dboxftpd                     DBOX ftpd\r\n"
    "\r\n"
    "Weitere Optionen:\r\n"
    " -bboxname\r\n"
    "\r\n"
   );

  return TRUE;
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptions(argc, argv);

  return 0;
 }
