/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include <fstream.h>

#include <stringtools.h>
#include <dboxpath.h>
#include <lock.h>
#include "mod-utf7.h"
#include "dboximap4.h"

void dboximap4t::docreate()
 {
  if(arguments.size()!=1)
   {
    cout << tag << " NO give a mailbox name\r\n";
    command_ok=FALSE;
    return;
   }

  string mailbox_name;
  mailbox_name=decode_mod_utf7(arguments[0].data);

  if(mailbox_name=="")
   {
    cout << tag << " NO give a non-empty mailbox name\r\n";
    command_ok=FALSE;
    return;
   }
  
  if(mailbox_name[mailbox_name.size()-1]=='/')
   {
    cout << tag << " OK ignored\r\n";
    command_ok=FALSE;
    return;
   }

  if(stringcasecmp(mailbox_name, "INBOX")==0)
   {
    cout << tag << " NO mailbox already exists\r\n";
    command_ok=FALSE;
    return;
   }

  if(check_mailbox_name(mailbox_name))
   {
    cout << tag << " NO mailbox name is not valid\r\n";
    command_ok=FALSE;
    return;
   }

  if(lock("folders", up.name, config.boxname))
   {
    cout << tag << " NO folder list is locked\r\n";
    command_ok=FALSE;
    return;
   }

  get_folder_list();

  unsigned i;
  for(i=0; i<folders.size(); i++)
    if(mailbox_name==folders[i].name)
     {
      unlock("folders", up.name, config.boxname);
      cout << tag << " NO mailbox already exists\r\n";
      command_ok=FALSE;
      return;
     }

  for(i=0; i<folders.size(); i++)
    if(folders[i].name=="")
      break;

  folder_et folder_e;

  folder_e.name=mailbox_name;
  //folder_e.subscribed=TRUE;

  if(i==folders.size())
    folders.push_back(folder_e);
  else
    folders[i]=folder_e;

  string subfolder=i2string(i);

   {
    char outfilename[DIRLEN];
    snprintf(outfilename, DIRLEN, "%sfolders", up.getpath());
    ofstream out(outfilename, ios::out);

    for(i=0; i<folders.size(); i++)
      out << folders[i].name << "\n";
   }

  unlock("folders", up.name, config.boxname);

   {
    string foldersdir;
    getboxusermaildir(foldersdir, config.boxdir, up.name, "");
    mkdir(foldersdir.c_str(), 0700);
    string subfolderdir;
    getboxusermaildir(foldersdir, config.boxdir, up.name, subfolder);
    mkdir(foldersdir.c_str(), 0700);
   }

   {
    folderpt fp;
    string foldername;

    if(subfolder=="")
      foldername=up.name;
    else
     {
      foldername=subfolder;
      foldername+="@";
      foldername+=up.name;
     }
  
    fp.setname(foldername);

    if(!fp.lock())
     {
      fp.set("imap.uidvalidity", time(NULL));
      fp.set("nextid", 1);
      fp.write();
      fp.unlock();
     }
   }
 }
