/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include <fstream.h>

#include <dboxpath.h>
#include <tools.h>
#include <lock.h>
#include <stringtools.h>
#include "mod-utf7.h"
#include "dboximap4.h"

void dboximap4t::dodelete()
 {
  unsigned i;

  if(arguments.size()!=1)
   {
    cout << tag << " NO give a mailbox name\r\n";
    command_ok=FALSE;
    return;
   }

  if(arguments[0].data[arguments[0].data.size()-1]=='/')
   {
    cout << tag << " OK ignored\r\n";
    command_ok=FALSE;
    return;
   }

  string mailbox_name=decode_mod_utf7(arguments[0].data);

  if(mailbox_name=="")
   {
    cout << tag << " NO give a non-empty mailbox name\r\n";
    command_ok=FALSE;
    return;
   }
  
  if(stringcasecmp(mailbox_name, "INBOX")==0)
   {
    cout << tag << " NO cannot delete INBOX\r\n";
    command_ok=FALSE;
    return;
   }
  
  if(lock("folders", up.name, config.boxname))
   {
    cout << tag << " NO folder list is locked\r\n";
    command_ok=FALSE;
    return;
   }

  get_folder_list();

  for(i=0; i<folders.size(); i++)
    if(mailbox_name==folders[i].name)
      break;

  if(i==folders.size())
   {
    unlock("folders", up.name, config.boxname);
    cout << tag << " NO no such mailbox\r\n";
    command_ok=FALSE;
    return;
   }

  string subfolder=i2string(i);
  folders[i].name="";

   {
    string outfilename=up.getpath();
    outfilename+="folders";
    ofstream out(outfilename.c_str(), ios::out|ios::trunc);

    for(i=0; i<folders.size(); i++)
      out << folders[i].name << "\n";
   }

  unlock("folders", up.name, config.boxname);

   {
    folderpt fp;
    string foldername;

    if(subfolder=="")
      foldername=up.name;
    else
     {
      foldername=subfolder;
      foldername+="@";
      foldername+=up.name;
     }
  
    fp.setname(foldername);

    if(!fp.lock())
     {
      string foldersdir;
      getboxusermaildir(foldersdir, config.boxdir, up.name, "");
      renamedirectory(foldersdir.c_str(), subfolder.c_str()); 
      fp.unlock();
     }
   }

 }
