/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <strstream.h>
#include <fstream.h>

#include <tools.h>
#include <sfolderrfc.h>
#include <stringtools.h>
#include "dboximap4.h"

static
bool move_data_in_file(int file, off_t source, off_t dest, dword size)
 {
  dword buffersize, bytestocopy, bytestocopy2;
  void *buffer;

  if(source==dest) return FALSE;

  buffersize=64000l;
  if((buffer=malloc(buffersize))==NULL) return TRUE;
  bytestocopy=size;

  if(source>dest)
   {
    while(bytestocopy!=0)
     {
      bytestocopy2=bytestocopy>buffersize?buffersize:bytestocopy;

      lseek(file, source, SEEK_SET);

      if(read(file, buffer, bytestocopy2)!=(ssize_t)bytestocopy2)
       {
        free(buffer);
        return TRUE;
       }

      lseek(file, dest, SEEK_SET);

      if(write(file, buffer, bytestocopy2)!=(ssize_t)bytestocopy2)
       {
        free(buffer);
        return TRUE;
       }

      source+=bytestocopy2;
      dest+=bytestocopy2;

      bytestocopy-=bytestocopy2;
     }
   }
  else // source<dest 
   {
   }

  free(buffer);
  return FALSE;
 }

void dboximap4t::doexpunge()
 {
  folder_grantst grants;
  ::get_folder_grants(folder_owner, subfolder, up, gp, grants);
  if(!grants.del)
   {
    cout << tag << " NO permission denied\r\n";
    command_ok=FALSE;
    return;
   }

  if(fp.lock())
   {
    cout << tag << " NO Sorry, failed to lock folder.\r\n";
    command_ok=FALSE;
    return;
   }

  dword read_nr=1, write_nr=1;
  off_t header_off=0;

  while(TRUE)
   {
    lseek(index, (read_nr-1)*sizeof fi, SEEK_SET);
    if(read(index, &fi, sizeof fi)!=sizeof fi) break;

    if(fi.check_version())
     {
      fp.unlock();
      cout << tag << " NO Sorry, folder data error.\r\n";
      command_ok=FALSE;
      return;
     }

    if(fi.flags.deleted)
     {
      cout << "* " << write_nr << " EXPUNGE\r\n";
      if(fi.flags.bodyextern)
       {
        string datafilename=fp.getpath();
        datafilename+=fi.file;
        remove(datafilename.c_str());
       }
     }
    else
     {
      dword header_size=fi.headerlen;
      if(!fi.flags.bodyextern) header_size+=fi.len;

      if(read_nr!=write_nr)
       {
        move_data_in_file(header, fi.headeroffs, 
                          header_off, header_size);

        fi.headeroffs=header_off;
        lseek(index, (write_nr-1)*sizeof fi, SEEK_SET);
        write(index, &fi, sizeof fi);
       }

      header_off+=header_size;
      write_nr++;
     }

    read_nr++;
   }

  if(read_nr!=write_nr)
   {
    ftruncate(index, (write_nr-1)*sizeof fi);
    ftruncate(header, header_off);
   }

  fp.unlock();
 }

