/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <time.h>

#include "imap4set.h"

dword set_commandt::getmsgnr_from_uid(dword uid)
 {
  folderindext fi;
  dword msgnr;

  if(getmsgnr_uid==uid)
    return getmsgnr_msgnr;

  if(getmsgnr_uid<uid &&
     getmsgnr_uid!=0 &&
     getmsgnr_msgnr!=0)
    msgnr=getmsgnr_msgnr;
  else
    msgnr=1;

  lseek(dboximap4.index, (msgnr-1)*sizeof fi, SEEK_SET);

  while(read(dboximap4.index, &fi, sizeof fi)==sizeof fi)
   {
    if(fi.id==uid)
     {
      getmsgnr_uid=fi.id;
      getmsgnr_msgnr=msgnr;
      return msgnr;
     }
    msgnr++;
   }

  // not found!

  return 0;
 }

bool set_commandt::do_set_command2()
 {
  if(uid)
    nr=getmsgnr_from_uid(nr);

  if(nr>dboximap4.messages || nr<1) return FALSE;

  return msg();
 }

void set_commandt::do_set_command(bool _uid)
 {
  uid=_uid;

  if(dboximap4.arguments.size()<unsigned(uid?2:1))
   {
    cout << dboximap4.tag << " NO provide more arguments\r\n";
    dboximap4.command_ok=FALSE;
    return;
   }

  argnr=uid?1:0;

  const char *message_set=dboximap4.arguments[argnr++].data.c_str();
  dword number=0, nr1=0, nr2=0;
  bool sequence=FALSE;
  dword max_value=uid?dboximap4.largest_id:dboximap4.messages;

  getmsgnr_uid=0;
  getmsgnr_msgnr=0;

  if(start())
    return;

  while(message_set[0]!=0)
   {
    if(isdigit(message_set[0]))
     {
      number=atol(message_set);
      while(isdigit(message_set[0])) message_set++;
     }
    else if(message_set[0]=='*')
     {
      number=max_value;
      message_set++;
     }

    if(message_set[0]==':')
     {
      nr1=number;
      sequence=TRUE;
     }
    else if(sequence)
     {
      nr2=number;
      sequence=FALSE;

      if(nr2>max_value) nr2=max_value;

      for(number=nr1; number<=nr2; number++)
       {
        nr=number;
        if(do_set_command2())
         {
          end();
          return;
         }
       }
     }
    else
     {
      nr=number;
      if(do_set_command2())
       {
        end();
        return;
       }
     }

    if(message_set[0]!=0)
      message_set++;
   }

  end();
 }

