#include        "dboxradius.h"

int
user_find(req_name, auth_name, request_pairs, check_pairs, reply_pairs, user_desc, rejecterror, pm) 
char		*req_name;
char		*auth_name;
VALUE_PAIR	*request_pairs;
VALUE_PAIR	**check_pairs;
VALUE_PAIR	**reply_pairs;
USER_DESC	*user_desc;
char            **rejecterror;
char            *pm;
{
	char		buffer[MAXBUF];
	char		*ptr;
	int		req_namelen;
	int		mode;
	int		user_auth_name();
	VALUE_PAIR	*check_first;
	VALUE_PAIR	*reply_first;
        VALUE_PAIR	*get_attribute(), *get_pair;
	datum		named;
	datum		contentd;

        /* DK */
        struct userinfot userinfo;

	/* 
	 * Check for valid input, zero length names not permitted 
	 */

	mode = FIND_MODE_NAME;

	ptr=req_name;
	while (*ptr != '\0') {
		if (*ptr == ' ' || *ptr == '\t') {
#ifdef SPACECHOP
			*ptr = '\0';
#else
                        *rejecterror="space in username";
			log_err("user_find: space in username <%s> rejected\n",req_name);
			return(-1);
#endif
		} else {
			ptr++;
		}
	}

	req_namelen=strlen(req_name);

	if (req_namelen < 1) {
		log_err("user_find: zero length username rejected\n");
		return(-1);
	}

	check_first = (VALUE_PAIR *)NULL;
	reply_first = (VALUE_PAIR *)NULL;

        strncpy(userinfo.username, req_name, 99);
        userinfo.username[99]=0;
        userinfo.pair=request_pairs;
        strncpy(auth_name, userinfo.username, AUTH_STRING_LEN);
        auth_name[AUTH_STRING_LEN]=0;

        if(!dboxuser(&userinfo, rejecterror, pm))
         {
	  get_pair=get_attribute(request_pairs, 32);
          if(get_pair!=NULL)
           {
            sprintf(buffer, "NAS-Identifier=\"%s\"\n", get_pair->strvalue);
            userparse(buffer, &reply_first);
           }

          sprintf(buffer, "Password=\"%s\"\n", userinfo.password);
          userparse(buffer, &check_first);

          sprintf(buffer, "Service-Type=%s\n", userinfo.service_type);
          userparse(buffer, &reply_first);

          if(userinfo.session_timeout[0]!=0)
           {
            sprintf(buffer, "Session-Timeout=%s\n", userinfo.session_timeout);
            userparse(buffer, &reply_first);
           }

          if(userinfo.framed_protocol[0]!=0)
           {
            sprintf(buffer, "Framed-Protocol=%s\n", userinfo.framed_protocol);
            userparse(buffer, &reply_first);

            sprintf(buffer, "Framed-Address=255.255.255.254\n");
            userparse(buffer, &reply_first);

            sprintf(buffer, "Framed-Netmask=255.255.255.255\n");
            userparse(buffer, &reply_first);

            sprintf(buffer, "Framed-Routing=None\n");
            userparse(buffer, &reply_first);
           }

          sprintf(buffer, "Idle-Timeout=600\n");
          userparse(buffer, &reply_first);

          if(userinfo.message[0]!=0)
           {
            sprintf(buffer, "Reply-Message=\"%s\"\n", userinfo.message);
            userparse(buffer, &reply_first);
           }

          if(userinfo.framed_compression[0]!=0)
           {
            sprintf(buffer, "Framed-Compression=%s\n", userinfo.framed_compression);
            userparse(buffer, &reply_first);
           }

          sprintf(buffer, "Port-Limit=4\n");
          userparse(buffer, &reply_first);

          *check_pairs = check_first;
          *reply_pairs = reply_first;

          return 0;
         }

#if 0       
	if (radius_dbm != 0) {
		for (;;) {
			if (db_index == -1) {
				named.dptr = req_name;
				named.dsize = strlen(req_name);
			} else if (db_index == 0) {
				sprintf(buffer, "DEFAULT");
				named.dptr = buffer;
				named.dsize = strlen(buffer);
			} else {
				sprintf(buffer, "DEFAULT%d", db_index);
				named.dptr = buffer;
				named.dsize = strlen(buffer);
			}
			db_index++;

#ifdef NDBM
			contentd = dbm_fetch(user_desc, named);
#else /* not NDBM */
			contentd = fetch(named);
#endif /* NDBM */
			if(contentd.dsize == 0) {
				if (db_index == 0) {
					/*
					 * the request id failed
					 * lets try the defaults
					 */
					continue;
				}
				return(-1);
			}

			/*
			 * Parse the check values
			 */
			if (contentd.dsize > MAXBUF) {
				log_err("user_find: user record for user %s is too big, %d exceeds %d\n", req_name,contentd.dsize,MAXBUF);
				return(-1);
			}
			memcpy(buffer,contentd.dptr,contentd.dsize);
			buffer[contentd.dsize] = '\0';
			ptr = buffer;

			if(userparse(ptr, &check_first) != 0) {
				log_err("user_find: unable to parse check-items in dbm entry for user %s\n", req_name);
				pairfree(check_first);
				return(-1);
			}

			/*
			 * set authentication name
			 */
			if (user_auth_name( req_name,
					auth_name,
					check_first) != 0) {
				pairfree(check_first);
				check_first = (VALUE_PAIR *)NULL;
				continue;
			}
			break;
		}

		while(*ptr != '\n' && *ptr != '\0') {
			ptr++;
		}
		if(*ptr == '\0') {	/* no reply-items */
			*check_pairs = check_first;
			*reply_pairs = (VALUE_PAIR *)NULL;
			return(0);
		}
		ptr++;
		/*
		 * Parse the reply values
		 */
		if(userparse(ptr, &reply_first) != 0) {
			log_err("user_find: unable to parse reply-items in dbm entry for user %s\n", req_name);
			pairfree(check_first);
			pairfree(reply_first);
			return(-1);
		}
	} else {
	while(fgets(buffer, sizeof(buffer),
				(FILE *)user_desc) != (char *)NULL) {
		if(mode == FIND_MODE_NAME) {
			/*
			 * Find the entry starting with the users name
			 */
			if((strncmp(buffer, req_name, req_namelen) == 0
					&& (buffer[req_namelen] == ' '
					|| buffer[req_namelen] == '\t'))
					|| strncmp(buffer, "DEFAULT", 7) == 0) {
				if(strncmp(buffer, "DEFAULT", 7) == 0) {
					ptr = &buffer[7];
					/*
					 * advance pointer to next white space
					 */
					while (isspace(*ptr) == 0) {
						ptr++;
					}
				}
				else {
					ptr = &buffer[req_namelen];
				}
				/*
				 * Parse the check values
				 */
				if(userparse(ptr, &check_first) != 0) {
					log_err("user_find: unable to parse check-items for user %s\n", req_name);
					pairfree(check_first);
					return(-1);
				}
				/*
				 * set authentication name
				 */
				if (user_auth_name( req_name,
						auth_name,
						check_first) != 0) {
					pairfree(check_first);
					check_first = (VALUE_PAIR *)NULL;
					continue;
				}
				mode = FIND_MODE_REPLY;
			}
		}
		else {
			if(*buffer == ' ' || *buffer == '\t') {
				/*
				 * Parse the reply values
				 */
				if(userparse(buffer, &reply_first) != 0) {
					log_err("user_find: unable to parse reply-items for user %s\n", req_name);
					pairfree(check_first);
					pairfree(reply_first);
					return(-1);
				}
			}
			else {
				/* We are done */
				*check_pairs = check_first;
				*reply_pairs = reply_first;
				return(0);
			}
		}
	}
	}
#endif

	/* Update the callers pointers */
	if(reply_first != (VALUE_PAIR *)NULL) {
		*check_pairs = check_first;
		*reply_pairs = reply_first;
		return(0);
	}
	return(-1);
}
