/***********************************************************************

RADIUS
Remote Authentication Dial In User Service

Lucent Technologies Remote Access
4464 Willow Road
Pleasanton, CA   94588

Copyright 1992-1999 Lucent Technologies Inc.  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

   * Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

   * Redistributions in binary form must reproduce the above
     copyright notice, this list of conditions and the following
     disclaimer in the documentation and/or other materials provided
     with the distribution.

   * All advertising materials mentioning features or use of this
     software must display the following acknowledgement:

	  This product includes software developed by Lucent
	  Technologies and its contributors.

   * Neither the name of the copyright holder nor the names of its
     contributors may be used to endorse or promote products derived
     from this software without specific prior written permission.

This software is provided by the copyright holders and contributors
``as is'' and any express or implied warranties, including, but not
limited to, the implied warranties of merchantability and fitness for a
particular purpose are disclaimed. In no event shall the copyright
holder or contributors be liable for any direct, indirect, incidental,
special, exemplary, or consequential damages (including, but not
limited to, procurement of substitute goods or services; loss of use,
data, or profits; or business interruption) however caused and on any
theory of liability, whether in contract, strict liability, or tort
(including negligence or otherwise) arising in any way out of the use
of this software, even if advised of the possibility of such damage.

************************************************************************/


/*
 *	$Id: users.h,v 1.7 1999/06/23 23:40:44 cdr Exp $ %Y%
 */

# ifdef NDBM
#	include	<fcntl.h>
#	include	<ndbm.h>
# else /* not NDBM */
#	include	<dbm.h>
# endif /* NDBM */
# define USER_DESC	DBM

extern USER_DESC 	*user_open (	void);
extern void		user_close (	USER_DESC *user_desc);
#ifdef DBOXRADIUS
extern int		user_find (	char *req_name,
					char *auth_name,
					VALUE_PAIR *request_pairs,
					VALUE_PAIR **check_pairs,
					VALUE_PAIR **reply_pairs,
					USER_DESC *userfd,
					char **rejecterror,
                                        char *pm);
#else
extern int		user_find (	char *req_name,
					char *auth_name,
					VALUE_PAIR **check_pairs,
					VALUE_PAIR **reply_pairs,
					USER_DESC *userfd);
#endif