/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose:

*/

#include <fstream.h>
#include <sysexits.h>
#include <unistd.h>

#include <dboxpath.h>
#include <logf.h>
#include <config.h>
#include <stringtools.h>
#include <tools.h>
#include "deliver.h"

int do_deliver(cmdlinet &cmdline)
 {
  string tmpfilename;

  getdboxtempdir(tmpfilename, config.dboxdir);
  tmpfilename+="deliver."+i2string(getpid())+"."+
               i2string((unsigned)time(NULL))+".tmp";

  ofstream tmpoutfile(tmpfilename.c_str(),
    ios::out|ios::noreplace|ios::binary);

  if(!tmpoutfile)
   {
    cerr << "failed to create temp file \""
         << tmpfilename << "\"\n";
    return EX_TEMPFAIL;
   }

  for(int i=0; i<cmdline.argcount; i++)
    tmpoutfile << "RCPT: " << cmdline.args[i] << "\n";

  streampos msg_len_pos=tmpoutfile.tellp();
  tmpoutfile.form("LEN: %20lu\n", 0L);

  tmpoutfile << "\n";

  streampos msg_start_pos=tmpoutfile.tellp();

  if(filecopy(fileno(stdin), tmpoutfile) || !tmpoutfile)
   {
    cerr << "failed to store message in temp file\n";
    unlink(tmpfilename.c_str());
    return EX_TEMPFAIL;
   }

  return EX_OK;
 }
