/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: main program

*/

#include <sysexits.h>

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "deliver.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset(
    "(file):(deliver)(offs):(format):u:") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="deliver.log";
    logf.setlogfile(logfile);
   }

  if(cmdline.argcount!=0)
    return do_deliver(cmdline);
  else
   {
    usage_error();
    return EX_USAGE;
   }

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * DELIVER - DBOX Module for E-Mail Delivery - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " deliver [-?] [-h]            show help\n"
    " deliver --deliver            deliver mail\n"
    "\n"
    "Additonal options:\n"
    " --file                       input file\n"
    " --offs                       input offset\n"
    " --format ZC                  message format zconnect\n"
    " --format RFC                 message format rfc\n"
    " -b                           set bbs name\n"
    " -u                           set user name\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return EX_CONFIG;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
