#ifndef DBOX_ACCOUNT_H

#define DBOX_ACCOUNT_H

#include <userdb.h>

struct amountt
 {
 public:
  signed long amount;
  byte scale;
  
  friend bool operator<(amountt a, amountt b);
  friend bool operator>(amountt a, amountt b);
  friend bool operator<=(amountt a, amountt b);
  friend bool operator>=(amountt a, amountt b);
  friend bool operator!=(amountt a, amountt b);
  friend bool operator==(amountt a, amountt b);
  friend amountt operator+(amountt a, amountt b);
  friend amountt operator-(amountt a, amountt b);
  amountt operator+=(amountt a);
  amountt operator-=(amountt a);
 };

class bankpt:public pt
 {
 public:
  virtual void setfilename();
  virtual bool add();
  virtual bool del();

  bankpt():pt() { }
  bankpt(const char *_name):pt(_name) { }
 };

class chargeinfopt:public pt
 {
 public:
  char group[TEXTLEN];

  virtual void setfilename();
  virtual bool add();
  virtual bool del();

  chargeinfopt():pt() { group[0]=0; }
  chargeinfopt(const char *_name):pt(_name) { group[0]=0; }
 };
 
class buchungt
 {
 public:
  char bearbeiter[TEXTLEN];
  char alias[TEXTLEN];
  char verwendungszweck[TEXTLEN*2];
  char buchungstyp[TEXTLEN];  
   
  dword number;
  dword mwstsatz; // in Promill
  bool haben;
  time_t datum;
  amountt amount;

  virtual char parse(char **b, char *s);
  virtual bool parse(char *line);
  virtual void clear();
  virtual bool read(FILE *infile);
  virtual bool write(FILE *outfile);
  virtual void format(FILE *outfile, 
                      char format,
                      bool crlf,
                      charsett charset);
   
  buchungt()
   {
    clear();
   }
 };

bool checkcredit(userpt *up, grouppt *gp);

signed long power10(int n);
amountt rescale(amountt amount, byte newscale);

amountt abs(amountt a);

amountt parse_currency_string(const char *string);

void currency_string(char *string, amountt amount,
                     bool add_currency_symbol);

long int getfreedata(userpt *up, const char *type, const char *name);

// Rueckgabewert: Restzeit/Restvolumen (zu zahlen)
long int chargefreedata(userpt *up, const char *type, const char *name,
                        long int value);

void getfreealias(const char *type, const char *name, char *alias);

void chargemenu(userpt *up, const char *menu, const char *zweck, 
                time_t start, time_t ende);
                
bool checkchargemenu(userpt *up, grouppt *gp, 
                     const char *menu, char *error);

bool dobuchung(userpt *up, buchungt *buchung);

amountt getbalance(userpt *up);

long int gethostchargeinfo(grouppt *group, const char *host, dword size);

extern const char *formatkonto_start1;
extern const char *formatkonto_start2;
extern const char *formatkonto_ende;

void formatkonto(FILE *infile, FILE *outfile, 
                 char format, bool crlf, charsett charset);

#endif
