#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#include <general.h>
#include <dbox.h>
#include <dboxpath.h>

#include <config.h>
#include <logf.h>
#include <tools.h>
#include <blzdb.h>

blzdbt blzdb;

void blzdbt::lookup(dword blz, char *name)
 {
  dword i;

  if(!data_read) read_data();

  name[0]=0;

  for(i=0; i<number_of_blz; i++)
    if(blzdata[i].blz==blz)
     {
      strcpy(name, blzdata[i].name); // name is assumed to be big enough
      return;
     }
 }

void blzdbt::read_data()
 {
  FILE *infile;
  char id[1000], text[1000];
  char filename[DIRLEN];
  dword i;

  if(data_read) return;

  sprintf(filename, DBOXSYSTEMDIR "blz.txt", config.dboxdir);
  infile=fopen(filename, "rt");

  number_of_blz=0;

  while(readconfigline(infile, id, text, 900)==0)
    if(atol(id)!=0) number_of_blz++;

  blzdata=(blzentryt *)malloc(number_of_blz*sizeof(blzentryt));
  if(blzdata==NULL) abort();

  rewind(infile);
  
  i=0;

  while(readconfigline(infile, id, text, 900)==0 && i<number_of_blz)
   {
    blzdata[i].blz=atol(id);

    if(blzdata[i].blz!=0)
     {
      strmaxcpy(blzdata[i].name, text, MAXBLZLEN-1);
      i++;
     }
   }

  fclose(infile);

  data_read=TRUE;
 }
