#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#include <fstream.h>

#include <dboxpath.h>
#include <config.h>
#include <logf.h>
#include <tools.h>

configt config;

#if 0
const char *formatkonto_start1=
  " Nr.    Datum      Betrag   MwSt              Verwendungszweck";

const char *formatkonto_start2=
  "";

const char *formatkonto_ende=
  "";

bool usercharisok(char ch)
 {
  if(!isascii(ch)) return FALSE;
  if(isdigit(ch) || isalpha(ch) || ch=='.' || ch=='-' || ch=='_')
    return TRUE;
  return FALSE;
 }

bool checkusername(const char *username)
 { 
  const char *tptr;

  tptr=username; 
 
  while(*tptr!=0)
   {
    if(!usercharisok(*tptr)) return TRUE;
    tptr++;
   } 

  if(username[0]==0 || username[0]=='.' ||
     username[0]=='_' || isdigit(username[0])) return TRUE;

  return FALSE;
 }

bool netzcharisok(char ch)
 {
  if(!isascii(ch)) return FALSE;
  if(isdigit(ch) || isalpha(ch) || ch=='-')
    return TRUE;
  return FALSE;
 }

bool brettcharisok(char ch)
 {
  if(!isascii(ch)) return FALSE;
  if(isdigit(ch) || isalpha(ch) || ch=='/' || ch=='_' || ch=='-')
    return TRUE;
  return FALSE;
 }
#endif

// **********************************************************************
// *                                                                    *
// *                             Config                                 *
// *                                                                    *
// **********************************************************************

#if 0
int configt::getinternalflag(const char *flag)
 {
  int i;

  i=0;
  while(internalflags[i]!=NULL)
   {
    if(stricmp(internalflags[i], flag)==0)
      return i;
    i++;
   }
  return -1;
 }

int configt::getuserflag(const char *flag)
 {
  int i;

  i=0;
  while(userflags[i]!=NULL)
   {
    if(stricmp(userflags[i], flag)==0)
      return i;
    i++;
   }
  return -1;
 }
#endif

#if 0
int configt::getnetztyp(const char *netztyp)
 {
  for(int erg=0; netztypen[erg]!=NULL; erg++)
    if(stricmp(netztypen[erg], netztyp)==0) return erg;
  return -1;
 }

int configt::getpacker(const char *packer)
 {
  for(int erg=0; netzpacker[erg]!=NULL; erg++)
    if(stricmp(netzpacker[erg], packer)==0) return erg;
  return -1;
 }

int configt::getprotokoll(const char *protokoll)
 {
  for(int erg=0; netzprotokolle[erg]!=NULL; erg++)
    if(stricmp(netzprotokolle[erg], protokoll)==0) return erg;
  return -1;
 }

int configt::getgruppe(const char *gruppe)
 {
  for(int erg=0; gruppen[erg]!=NULL; erg++)
    if(stricmp(gruppen[erg], gruppe)==0) return erg;
  return -1;
 }
#endif

bool configt::doread(istream &in, bool global)
 {
  bool fatal=FALSE;

  while(TRUE)
   {
    char text[1000], id[1000], *tptr;

    switch(readconfigline(in, id, text, 900))
     {
     case 0:
      if(stricmp(id, "boxname")==0)
       {
        if(global)
         {
          if(strlen(text)>8)
           {
            logf.printf("configt::doread", "fatal: boxname %s too long", text);
            fatal=TRUE;
           }
          else
           {
            tptr=text;
            while(*tptr!=0)
             {
              if(*tptr>0 && !isalpha(*tptr) && !isdigit(*tptr) && *tptr!='-')
               {
                logf.printf("configt::doread",
                  "fatal: boxname \"%s\" contains invalid characters", text);
                fatal=TRUE;
               }
              tptr++;
             }
            dnstring(text);

            if(stricmp(boxname, text)==0)
              mainsystem=TRUE;
           }
         }
       }
      else if(stricmp(id, "organisation")==0 || stricmp(id, "organization")==0)
       {
        strmaxcpy(organization, text, TEXTLEN-1);
       }
      else if(stricmp(id, "domain")==0)
       {
        if(strlen(text)>50)
         {
          logf.printf("configt::doread",
            "fatal: domain %s too long", text);
          fatal=TRUE;
         }
        else
         {
          tptr=text;
          while(*tptr!=0)
           {
            if(*tptr>0 && !isalpha(*tptr) && !isdigit(*tptr) && *tptr!='-' && *tptr!='.')
             {
              logf.printf("configt::doread",
                "fatal: domain %s contains invalid characters", text);
              fatal=TRUE;
             }
            tptr++;
           }
          dnstring(text);
          tptr=text;
          if(*tptr=='.') tptr++;
          strmaxcpy(domain, tptr, TEXTLEN-1);
         }
       }
      else if(stricmp(id, "abs_host")==0)
       {
        if(strlen(text)>50)
         {
          logf.printf("configt::doread",
            "fatal: abs_host %s too long", text);
          fatal=TRUE;
         }
        else
         {
          tptr=text;
          while(*tptr!=0)
           {
            if(*tptr>0 && !isalpha(*tptr) && !isdigit(*tptr) && *tptr!='-' && *tptr!='.')
             {
              logf.printf("configt::doread",
                "fatal: abs_host %s contains invalid characters", text);
              fatal=TRUE;
             }
            tptr++;
           }
          dnstring(text);
          strmaxcpy(abs_host, text, TEXTLEN-1);
         }
       }
      else if(stricmp(id, "antrag.gruppe")==0 ||
              stricmp(id, "antrag_gruppe")==0)
        strmaxcpy(antrag_gruppe, text, TEXTLEN-1);
      else if(stricmp(id, "antrag.mail")==0 ||
              stricmp(id, "antrag_mail")==0)
        strmaxcpy(antrag_mail, text, TEXTLEN-1);
      else if(stricmp(id, "prvunzustellbar")==0 && global)
        strmaxcpy(prvunzustellbar, text, 39);
      else if(stricmp(id, "brtunzustellbar")==0 && global)
        strmaxcpy(brtunzustellbar, text, 39);
      else if(stricmp(id, "unzustellbar.prv")==0 && global)
        strmaxcpy(prvunzustellbar, text, 39);
      else if(stricmp(id, "unzustellbar.brt")==0 && global)
        strmaxcpy(brtunzustellbar, text, 39);
      else if(stricmp(id, "currency.symbol")==0)
        strmaxcpy(currency_symbol, text, TEXTLEN-1);
      else if(stricmp(id, "mwstsatz")==0)
        mwstsatz=atol(text);
      else if(stricmp(id, "currency.scale")==0)
        currency_scale=atol(text);
      else if(stricmp(id, "archieserver")==0)
        strmaxcpy(archieserver, text, TEXTLEN-1);
      else if(stricmp(id, "defaulturl")==0)
        strmaxcpy(defaulturl, text, TEXTLEN-1);
      else if(stricmp(id, "homepagemaxfilesize")==0 ||
              stricmp(id, "homepage.maxfilesize")==0)
        homepagemaxfilesize=atol(text);
      else if(stricmp(id, "homepage.quota.size")==0)
        homepage_quota_size=atol(text);
      else if(stricmp(id, "homepage.quota.files")==0)
        homepage_quota_files=atol(text);
      else if(stricmp(id, "homepagedir")==0 || 
              stricmp(id, "homepage.dir")==0)
       {
        strmaxcpy(homepagedir, text, TEXTLEN-1);
        if(homepagedir[0]!=0)
          if(homepagedir[strlen(homepagedir)-1]!=DIRCHAR[0])
            strcat(homepagedir, DIRCHAR);
       }   
      else if(stricmp(id, "homepageurl")==0 ||
              stricmp(id, "homepage.url")==0)
       {
        strmaxcpy(homepageurl, text, TEXTLEN-1);
        if(homepageurl[0]!=0)
          if(homepageurl[strlen(homepageurl)-1]!='/')
            strcat(homepageurl, "/");
       }   
      else if(stricmp(id, "homepage.domainsuffix")==0)
       {
        strmaxcpy(homepagedomainsuffix, text, TEXTLEN-1);
        if(homepagedomainsuffix[0]!=0)
          if(homepagedomainsuffix[strlen(homepagedomainsuffix)-1]!='/')
            strcat(homepagedomainsuffix, "/");
       }   
      else if(stricmp(id, "homepage.domainprefix")==0)
       {
        strmaxcpy(homepagedomainprefix, text, TEXTLEN-1);
        if(homepagedomainprefix[0]!=0)
          if(homepagedomainprefix[strlen(homepagedomainprefix)-1]=='.')
            homepagedomainprefix[strlen(homepagedomainprefix)-1]=0;
       }   
      else if(stricmp(id, "webonline.bgcolor")==0)
        strmaxcpy(webonline_bgcolor, text, TEXTLEN-1);
      else if(stricmp(id, "webonline.thbgcolor")==0)
        strmaxcpy(webonline_thbgcolor, text, TEXTLEN-1);
      else if(stricmp(id, "webonline.thfcolor")==0)
        strmaxcpy(webonline_thfcolor, text, TEXTLEN-1);
      else if(stricmp(id, "webonline.tablebgcolor1")==0)
        strmaxcpy(webonline_tablebgcolor1, text, TEXTLEN-1);
      else if(stricmp(id, "webonline.tablebgcolor2")==0)
        strmaxcpy(webonline_tablebgcolor2, text, TEXTLEN-1);
      else if(stricmp(id, "radius_auth_server")==0 ||
              stricmp(id, "radius.auth_server")==0)
        radius_auth_server=getinternetaddress(text);
      else if(stricmp(id, "radius_acct_server")==0 ||
              stricmp(id, "radius.acct_server")==0)
        radius_acct_server=getinternetaddress(text);
      else if(stricmp(id, "radius_secret")==0 ||
              stricmp(id, "radius.secret")==0)
        strmaxcpy(radius_secret, text, TEXTLEN-1);
      else if(stricmp(id, "radius_ip_address")==0)
        radius_ip_address=getinternetaddress(text);
      else if(stricmp(id, "zeitzone")==0 && global)
       {

       }
      else if(stricmp(id, "sommerzeit")==0 && global)
        sommerzeit=atoi(text);
      else if(stricmp(id, "color.1v")==0)
        col1v=atoi(text);
      else if(stricmp(id, "color.1h")==0)
        col1h=atoi(text);
      else if(stricmp(id, "color.2v")==0)
        col2v=atoi(text);
      else if(stricmp(id, "color.2h")==0)
        col2h=atoi(text);
      else if(stricmp(id, "color.3v")==0)
        col3v=atoi(text);
      else if(stricmp(id, "color.3h")==0)
        col3h=atoi(text);
      else if(stricmp(id, "comport")==0)
        strmaxcpy(comport, text, TEXTLEN-1);
      else if(stricmp(id, "console")==0)
        strmaxcpy(console, text, TEXTLEN-1);
      else if(stricmp(id, "dte")==0)
        dte=atol(text);
      else if(stricmp(id, "public_terminal")==0)
        public_terminal=atol(text);
      else if(stricmp(id, "console_charset")==0)
        console_charset=(charsett)atoi(text);
      else if(stricmp(id, "telefon")==0)
        strmaxcpy(telefon, text, TEXTLEN-1);
      else if(stricmp(id, "slipaddr")==0)
        slipaddr=getinternetaddress(text);
      else if(stricmp(id, "prearc.maxsize1")==0)
        prearc_maxsize1=atol(text);
      else if(stricmp(id, "prearc.maxsize2")==0)
        prearc_maxsize2=atol(text);
      else if(stricmp(id, "spoolzcm.checkabs")==0)
        spoolzcm_checkabs=atol(text);
      else if(stricmp(id, "spoolzcn.checkabs")==0)
        spoolzcn_checkabs=atol(text);
      break;

     case 1:
      return fatal;

     default:
      logf.printf("configt::doread",
        "Warnung: Fehler in der Konfigurationsdatei!");
      return fatal;
     }
   }
 }

bool configt::getboxname(const char *filename)
 {
  ifstream infile(filename);

  if(!infile) return FALSE;

  while(TRUE)
   {
    char text[1000], id[1000], *tptr;

    switch(readconfigline(infile, id, text, 900))
     {
     case 0:
      if(stricmp(id, "boxname")==0)
       {
        if(strlen(text)>8)
         {
          logf.printf("configt::read", "fatal: boxname %s too long", text);
          return TRUE;
         }

        tptr=text;
        while(*tptr!=0)
         {
          if(*tptr>0 && !isalpha(*tptr) && !isdigit(*tptr) && *tptr!='-')
           {
            logf.printf("configt::read",
              "fatal: boxname \"%s\" contains invalid characters", text);
            return TRUE;
           }
          tptr++;
         }

        dnstring(text);

        strmaxcpy(boxname, text, TEXTLEN-1);
        return FALSE;
       }
      break;

     case 1: // EOF
      return FALSE;

     default:
      logf.printf("configt::read", 
        "Warnung: Fehler in der Konfigurationsdatei!");
      return FALSE;
     }
   }
 }

#if 0
static int cmpstring(const void *a, const void *b)
 {
  return stricmp(*(const char **)a, *(const char **)b);
 }

void configt::readgruppen()
 {
  DIR *dir;
  struct dirent *ent;
  char tempstr[DIRLEN];
  dword i;

  sprintf(tempstr, BOXGRUPPENDIR ".", boxdir, ".");
  if((dir=opendir(tempstr))!=NULL)
   {
    i=0;
    while((ent=readdir(dir))!=NULL && i<MAXGRUPPEN)
     {
      if(ent->d_name[0]!='.' && ent->d_name[0]!='_')
       {
        gruppen[i]=(char *)malloc(strlen(ent->d_name)+1);
        strmaxcpy(gruppen[i], ent->d_name, TEXTLEN-1);
        i++;
       }
     }
    closedir(dir);

    qsort(gruppen, i, sizeof(char *), cmpstring);
   }
 }

void configt::readflags()
 {
  dword i;
  char tempstr[DIRLEN], *tptr;
  FILE *infile;

  i=0;
  snprintf(tempstr, DIRLEN, BOXSYSTEMDIR "flags", boxdir);
  if((infile=fopen(tempstr, "rt"))==NULL)
   {
    snprintf(tempstr, DIRLEN, DBOXSYSTEMDIR "flags", dboxdir);
    infile=fopen(tempstr, "rt");
   }

  if(infile!=NULL)
   {
    while(fgets(tempstr, 900, infile)!=NULL)
     {
      tptr=strchr(tempstr, '\r');
      if(tptr!=NULL) *tptr=0;
      tptr=strchr(tempstr, '\n');
      if(tptr!=NULL) *tptr=0;

      userflags[i]=(char *)malloc(strlen(tempstr)+1);
      strmaxcpy(userflags[i], tempstr, TEXTLEN-1);
      i++;
     }

    fclose(infile);
   }

  userflags[i]=NULL;
 }
#endif

bool configt::dboxcd()
 {
  if(chdir(dboxdir)!=0) return TRUE;
  return FALSE;
 }

bool configt::getdboxdir()
 {
  const char *dboxdir_env;

  dboxdir_env=getenv("DBOXDIR");

  if(dboxdir_env==NULL || dboxdir_env[0]==0)
    strmaxcpy(dboxdir, "/home/dbox/", TEXTLEN-1);
  else
    snprintf(dboxdir, DIRLEN, "%s" DIRCHAR, dboxdir_env);

  return FALSE;
 }

bool configt::read(const char *forcedboxname)
 {
  bool fatal=FALSE;

  if(getcwd(cwd, DIRLEN-1)==NULL)
    logf.internalerror("configt::read", "getcwd failed");

  if(dboxcd())
    logf.internalerror("configt::read", "chdir failed");

  // internalflags=internalflagnames;

  // 1. Schritt: Boxnamen aus Portprofile holen

  if(forcedboxname==NULL || forcedboxname[0]==0)
   {
     {
      char filename[DIRLEN];
      snprintf(filename, DIRLEN, DBOXPORTDIR "profile", dboxdir, port);
      if(getboxname(filename)) return TRUE;
     }

    if(boxname[0]==0)
     {
      char filename[DIRLEN];
      snprintf(filename, DIRLEN, DBOXSYSTEMDIR "profile", dboxdir);
      if(getboxname(filename)) return TRUE;
     }

    if(boxname[0]==0)
     {
      logf.printf("configt::read", "FATAL: Kein Boxname!");
      return TRUE;
     }
   }
  else
   {
    strmaxcpy(boxname, forcedboxname, TEXTLEN-1);
    dnstring(boxname);
   }

  mkboxdir(boxdir, boxname);

  // 2. Schritt: nettypedb, netpackerdb, netprotocoldb

  nettypedb.read(this);
  netpackerdb.read(this);
  netprotocoldb.read(this);
  grouptypedb.read(this);

  // 3. Schritt: Globale Konfiguration lesen

   {
    char filename[DIRLEN];
    snprintf(filename, DIRLEN, DBOXSYSTEMDIR "profile", dboxdir);
    ifstream infile(filename);
    if(infile)
     {
      fatal=doread(infile, TRUE);
      if(fatal) return TRUE;
     }
    else
      return TRUE;
   }

  // 4. Schritt: Boxkonfiguration lesen

   {
    char filename[DIRLEN];
    snprintf(filename, DIRLEN, BOXSYSTEMDIR "profile", boxdir);
    ifstream infile(filename);
    if(infile)
     {
      fatal=doread(infile, FALSE);
      if(fatal) return TRUE;
     }
    else
      return TRUE;
   }

  // 5. Schritt: Portkonfiguration lesen

   {
    char filename[DIRLEN];
    snprintf(filename, DIRLEN, DBOXPORTDIR "profile", dboxdir, port);
    ifstream infile(filename);
    if(infile)
     {
      fatal=doread(infile, FALSE);
      if(fatal) return TRUE;
     }
   }

  // 6. Schritt: user flags/internal flags

  internalflagdb.read(this);
  userflagdb.read(this);

  // 7. Schritt: Gruppen

  groupdb.read(this);

  return fatal;
 }

void configt::initialize()
 {
  mainsystem=FALSE;
  public_terminal=FALSE;
  console_charset=IBM;
  boxname[0]=organization[0]=domain[0]=abs_host[0]=0;
  strmaxcpy(prvunzustellbar, "/SYS/UNZUSTELLBAR/PRV", TEXTLEN-1);
  strmaxcpy(brtunzustellbar, "/SYS/UNZUSTELLBAR/BRT", TEXTLEN-1);
  strmaxcpy(currency_symbol, "DM", TEXTLEN-1);
  mwstsatz=0;
  currency_scale=2;
  zeitzonemin=0;
  zeitzonestd=0;
  zeitzoneplus=TRUE;
  sommerzeit=TRUE;
  antrag_gruppe[0]=0;
  antrag_mail[0]=0;
  col1v=16;
  col1h=16;
  col2v=7;
  col2h=4;
  col3v=7+8;
  col3h=1;
  midcount=0;
  archieserver[0]=0;
  homepageurl[0]=homepagedir[0]=0;
  homepagedomainprefix[0]=homepagedomainsuffix[0]=0;
  homepagemaxfilesize=2000000; // 2 MB
  strmaxcpy(defaulturl, "http://www.web.de", TEXTLEN-1);
  strmaxcpy(webonline_bgcolor, "#c0c0c0", TEXTLEN-1);
  strmaxcpy(webonline_thbgcolor, "#ff0000", TEXTLEN-1);
  strmaxcpy(webonline_thfcolor, "#ffffff", TEXTLEN-1);
  strmaxcpy(webonline_tablebgcolor1, "#efefef", TEXTLEN-1);
  strmaxcpy(webonline_tablebgcolor2, "#c9c9c9", TEXTLEN-1);
  radius_ip_address=radius_auth_server=radius_acct_server=0;
  radius_secret[0]=0;
  port=0;
  boxdir[0]=0;
  telefon[0]=0;
  console[0]=comport[0]=0;
  slipaddr=0;
  dte=0;
  prearc_maxsize1=5000000;
  prearc_maxsize2=500000;
  spoolzcm_checkabs=1;
  spoolzcn_checkabs=1;

  if(getdboxdir())
   {
    fprintf(stderr, "failed to get dbox dir\r\n");
    abort();
   }

  nettypedb.initialize();
  grouptypedb.initialize();
  netprotocoldb.initialize();
  netpackerdb.initialize();
  groupdb.initialize();
  userflagdb.initialize();
  internalflagdb.initialize();
 }

configt::~configt()
 {
  #if 0
  int i;

  for(i=0; i<USERFLAGS; i++)
    if(userflags[i]!=NULL)
      free(userflags[i]);

  for(i=0; i<MAXGRUPPEN; i++)
    if(gruppen[i]!=NULL)
      free(gruppen[i]);
  #endif
 }

