#ifndef DBOX_CONFIG_H

#define DBOX_CONFIG_H

#include <stream.h>

#include <dbox.h>
#include <interlib.h> // for internetaddresst
#include <charsett.h> // for charsett
#include <dboxdb.h>   // for groubdbt, etc.
#include <iflags.h>   // for internalflagdbt

class configt
 {
 public:
  // Global
 
  groupdbt groupdb;
  userflagdbt userflagdb;
  internalflagdbt internalflagdb;

  char cwd[DIRLEN];
 
  char boxname[TEXTLEN],
       organization[TEXTLEN],
       domain[TEXTLEN],      // Kleinbuchstaben
       abs_host[TEXTLEN];    // mit Domain

  nettypedbt nettypedb;
  grouptypedbt grouptypedb;
  netprotocoldbt netprotocoldb;
  netpackerdbt netpackerdb;
  
  // UNZUSTELLBAR

  char brtunzustellbar[TEXTLEN],
       prvunzustellbar[TEXTLEN];

  // FIBU
  
  char currency_symbol[TEXTLEN];
  dword mwstsatz; // in Promill
  byte currency_scale; // Anzahl Nachkommastellen

  // ZCONNECT

  byte zeitzonestd, zeitzonemin;
  bool zeitzoneplus, sommerzeit;
  dword midcount;

  // BILDSCHIRM

  byte col1v, col1h, col2v, col2h, col3v, col3h;

  // USERANTRAG

  char antrag_gruppe[TEXTLEN];
  char antrag_mail[TEXTLEN];

  // INTERNET ONLINE

  char archieserver[TEXTLEN];
  char defaulturl[TEXTLEN];
  internetaddresst radius_auth_server, radius_acct_server,
                   radius_ip_address;
  char radius_secret[TEXTLEN];
  
  // Webonline
  
  char homepagedir[DIRLEN], homepageurl[TEXTLEN], 
       homepagedomainsuffix[TEXTLEN], homepagedomainprefix[TEXTLEN];
  dword homepagemaxfilesize, homepage_quota_files, homepage_quota_size;
  char webonline_bgcolor[TEXTLEN];
  char webonline_thbgcolor[TEXTLEN];
  char webonline_thfcolor[TEXTLEN];
  char webonline_tablebgcolor1[TEXTLEN];
  char webonline_tablebgcolor2[TEXTLEN];

  // PORTDATEN

  byte port;
  char boxdir[DIRLEN], dboxdir[DIRLEN];
  char telefon[TEXTLEN];

  char console[TEXTLEN], comport[TEXTLEN];
  dword dte;
  bool public_terminal;
  charsett console_charset;
  internetaddresst slipaddr;

  bool mainsystem;
  
  // prearc
  
  dword prearc_maxsize1, prearc_maxsize2;

  // SONST
  
  bool spoolzcm_checkabs, spoolzcn_checkabs;

  bool read(const char *forcedboxname);
  
  bool dboxcd();
  bool getdboxdir();
  
  void initialize();

  configt() { initialize(); }
  ~configt();

 private:
  bool getboxname(const char *filename);
  bool doread(istream &in, bool global);
 };

extern configt config; 

#endif