#ifndef DBOX_DBOXDB_H

#define DBOX_DBOXDB_H

#define MAXSTRINGARRAY 2000

//#define INTERNALFLAGS 100
#define MAXUSERFLAGS MAXSTRINGARRAY
#define MAXGRUPPEN MAXSTRINGARRAY

class stringarrayt
 {
 public:
  int index(const char *string);

  const char *operator[](int nr)
   {
    return nr<0?"":strings[nr];
   }

  const char *get(int nr)
   {
    return nr<0?"":strings[nr];
   }
   
  virtual bool read()=0;

  void initialize()
   {
    strings[0]=(char *)NULL;
    number_of_elements=0;
   }
   
  unsigned size()
   {
    return number_of_elements;
   }

  stringarrayt()
   {
    initialize();
   }
   
  virtual ~stringarrayt() 
   {
   }

 protected:
  const char *strings[MAXSTRINGARRAY];
  unsigned number_of_elements;
 };
 
class userflagdbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
  virtual ~userflagdbt();
 };
 
typedef byte userflagst[MAXSTRINGARRAY];

void clear(userflagst *userflags);

class groupdbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
  virtual ~groupdbt();
 };

class netpackerdbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
 };

class netprotocoldbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
 };

class nettypedbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
 };

class grouptypedbt:public stringarrayt
 {
 public:
  virtual bool read(class configt *config);
  virtual bool read();
 };

#endif