#include <string.h>
#include <stdio.h>

#include <config.h>
#include <dboxpath.h>

void mkboxdir(char *boxdir, const char *boxname)
 {
  if(boxname==NULL || boxname[0]==0)
    boxname=config.boxname;

  snprintf(boxdir, DIRLEN, DBOXBOXDIR, config.dboxdir, boxname);
 }

void getdboxtempdir(string &dest, const string &dboxdir)
 {
  dest=dboxdir+"tmp"+DIRCHAR;
 }

void getdboxportdir(string &dest, const string &dboxdir, unsigned port)
 {
  char nr[TEXTLEN];
  snprintf(nr, TEXTLEN, "%u", port);
  dest=dboxdir+"port"+DIRCHAR+nr+DIRCHAR;
 }

void getdboxporttempdir(string &dest, const string &dboxdir, unsigned port)
 {
  getdboxportdir(dest, dboxdir, port);
  dest+="tmp";
  dest+=DIRCHAR;
 }

void getdboxsystemdir(string &dest, const string &dboxdir)
 {
  dest=dboxdir+"system"+DIRCHAR;
 }

void getdboxhtmldir(string &dest, const string &dboxdir)
 {
  dest=dboxdir+"html"+DIRCHAR;
 }

void getboxlockdir(string &dest, const string &boxdir)
 {
  dest=boxdir+"lock"+DIRCHAR;
 }

void getboxsystemdir(string &dest, const string &boxdir)
 {
  dest=boxdir+"system"+DIRCHAR;
 }

void getboxuserdir(string &dest, const string &boxdir, const string &user)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR;
 }

void getboxuserdocdir(string &dest, const string &boxdir, 
                      const string &user, const string &folder)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR+"doc"+DIRCHAR+folder+DIRCHAR;
 }

void getboxusermaildir(string &dest, const string &boxdir, 
                       const string &user, const string &folder)
 {
  dest=boxdir+"user"+DIRCHAR+user+DIRCHAR+"mfolders"+DIRCHAR+folder+DIRCHAR;
 }

void getboxhtmldir(string &dest, const string &boxdir)
 {
  dest=boxdir+"html"+DIRCHAR;
 }

void getboxlogdir(string &dest, const string &boxdir)
 {
  dest=boxdir+"log"+DIRCHAR;
 }

void getboxticketdir(string &dest, const string &boxdir)
 {
  dest=boxdir+"ticket"+DIRCHAR;
 }
