#ifndef DBOX_PATH_H

#define DBOX_PATH_H

#include <string>

#include <libdbox.h>

#ifdef __MSDOS__
#define DIRCHAR "\\"
#else
#define DIRCHAR "/"
#endif

#define TEMPDIR "/tmp/"

//
// Use of #defines is depreciated; use get* instead
//

#define DBOXSYSTEMDIR "%s" "system" DIRCHAR
#define DBOXCLIENTDIR DBOXSYSTEMDIR "clients" DIRCHAR "%s" DIRCHAR
#define DBOXPORTDIR "%s" "port" DIRCHAR "%u" DIRCHAR
#define DBOXTEMPDIR "%s" "tmp" DIRCHAR
#define DBOXSPOOLTEMPDIR "%s" "port" DIRCHAR "0" DIRCHAR
#define DBOXPORTTEMPDIR "%s" "port" DIRCHAR "%u" DIRCHAR "tmp" DIRCHAR
#define DBOXBOXDIR "%s" "%s" DIRCHAR
#define DBOXCHATDIR "%s" "chat" DIRCHAR
#define DBOXBINDIR "%s" "bin" DIRCHAR
#define DBOXHTMLDIR "%s" "html" DIRCHAR

#define BOXSYSTEMDIR "%s" "system" DIRCHAR
#define BOXLOGDIR "%s" "log" DIRCHAR
#define BOXLOCKDIR "%s" "lock" DIRCHAR
#define BOXUSERDIR "%s" "user" DIRCHAR "%s" DIRCHAR
#define BOXUSERMAILDIR "%s" "user" DIRCHAR "%s" DIRCHAR "mfolders" DIRCHAR "%s" DIRCHAR
#define BOXTICKETDIR "%s" "ticket" DIRCHAR 
#define BOXSPOOLDIR "%s" "user" DIRCHAR "%s" DIRCHAR
#define BOXSPOOLINZCMAILDIR "%s" "spool" DIRCHAR "zcmail" DIRCHAR
#define BOXSPOOLINZCNEWSDIR "%s" "spool" DIRCHAR "zcnews" DIRCHAR
#define BOXSPOOLINRFCMAILDIR "%s" "spool" DIRCHAR "rfcmail" DIRCHAR
#define BOXSPOOLINRFCNEWSDIR "%s" "spool" DIRCHAR "rfcnews" DIRCHAR
#define BOXBADDIR "%s" "bad" DIRCHAR
#define BOXBRETTERDIR "%s" "bretter" DIRCHAR
#define BOXGRUPPENDIR "%s" "gruppen" DIRCHAR "%s" DIRCHAR
#define BOXTODODIR "%s" "todo" DIRCHAR
#define BOXHTMLDIR "%s" "html" DIRCHAR

void mkboxdir(char *boxdir, const char *boxname);

void getdboxsystemdir(string &dest, const string &dboxdir);
void getdboxclientdir(string &dest, const string &dboxdir, const string &client);
void getdboxportdir(string &dest, const string &dboxdir, unsigned port);
void getdboxtempdir(string &dest, const string &dboxdir);
void getdboxspooltempdir(string &dest, const string &dboxdir);
void getdboxporttempdir(string &dest, const string &dboxdir, unsigned port);
void getdboxboxdir(string &dest, const string &dboxdir, const string &box);
void getdboxchatdir(string &dest, const string &dboxdir);
void getdboxbindir(string &dest, const string &dboxdir);
void getdboxhtmldir(string &dest, const string &dboxdir);

void getboxsystemdir(string &dest, const string &boxdir);
void getboxlogdir(string &dest, const string &boxdir);
void getboxlockdir(string &dest, const string &boxdir);
void getboxuserdir(string &dest, const string &boxdir, const string &user);
void getboxuserdocdir(string &dest, const string &boxdir, const string &user);
void getboxusermaildir(string &dest, const string &boxdir,
                       const string &user, const string &folder);
void getboxticketdir(string &dest, const string &boxdir);
void getboxspooldir(string &dest, const string &boxdir, const string &user);
void getboxspoolinzcmaildir(string &dest, const string &boxdir);
void getboxspoolinzcnewsdir(string &dest, const string &boxdir);
void getboxbaddir(string &dest, const string &boxdir);
void getboxbretterdir(string &dest, const string &boxdir);
void getboxgruppendir(string &dest, const string &boxdir, const string &group);
void getboxtododir(string &dest, const string &boxdir);
void getboxhtmldir(string &dest, const string &boxdir);

#endif
