#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>

#include <fstream.h>

#include <tools.h>
#include <folder.h>
#include <logf.h>
#include <mtoolrfc.h>
#include "zc2rfc.h"
#include "getrfczc.h"

bool getrfczct::get_header(dword nr)
 {
  check_cache(nr);
  
  if(get_folderindex(nr))
    return TRUE;

  if(fi.flags.rfc)
    return getrfct::get_header(nr);

  if(!cached_header)
   {
    char *data;
    zcmessaget zcm;

    data=new char[fi.headerlen];
    if(data==(char *)NULL)
      logf.internalerror("getrfct::getheader", "out of memory");

    lseek(header, fi.headeroffs, SEEK_SET);

    if(read(header, data, fi.headerlen)!=fi.headerlen)
     {
      delete data;
      return TRUE;
     }

    zcm.data=data;
    zcm.endofmail=zcm.endoffile=data+fi.headerlen;
    zcm.parse();
    zc2rfc(zcm, rfcm, TRUE, allow_zconnect_charset);
    delete zcm.data;

    cached_header=TRUE;
   }

  return FALSE;
 }

bool getrfczct::get_body(dword nr)
 {
  check_cache(nr);
  get_folderindex(nr);

  if(fi.flags.rfc)
    return getrfct::get_body(nr);

  if(!cached_body)
   {
    char *data;
    zcmessaget zcm;

    data=new char[fi.len+fi.headerlen];
    if(data==(char *)NULL)
      logf.internalerror("getrfct::getbody", "out of memory");

    lseek(header, fi.headeroffs, SEEK_SET);

    zcm.data=data;
    zcm.endoffile=zcm.data+fi.len+fi.headerlen;

    if(!fi.flags.bodyextern)
      read(header, data, fi.len+fi.headerlen);
    else
     {
      char filename[DIRLEN];

      read(header, data, fi.headerlen);
      snprintf(filename, DIRLEN, "%s%s", fp.getpath(), fi.file);
      ifstream bodyfile(filename, ios::binary|ios::in);

      if(bodyfile)
        bodyfile.read(data+fi.headerlen, fi.len);
      else
       {
        delete data;
        return TRUE;
       }
     }

    zcm.parse();  
    zc2rfc(zcm, rfcm, FALSE, allow_zconnect_charset);
    delete zcm.data;

    cached_body=TRUE;
    cached_header=TRUE;
   }

  return FALSE;
 }

