#include <fstream.h>

#include <stringtools.h>
#include <grants.h>
#include <dboxpath.h>
#include <textprofile.h>

bool match_grants(textprofilet &profile, 
                  propertyt &object_properties,
                  userpt &who_up, grouppt &who_gp)
 {
  string mask;

  for(unsigned i=0; i<profile.size(); i++)
   {
    if(strncasecmp(profile.data[i].id, "user.", 5)==0)
     {
      if(!checkjoker(profile.data[i].data, 
                     who_up.get(profile.data[i].id+5)))
        return FALSE;
     }
    else if(strncasecmp(profile.data[i].id, "group.", 6)==0)
     {
      if(!checkjoker(profile.data[i].data, 
                     who_gp.get(profile.data[i].id+6)))
        return FALSE;
     }
    else
     {
      if(!check_joker(profile.data[i].data, 
                     object_properties.get(profile.data[i].id)))
        return FALSE;
     }
   }

  return TRUE;
 }

string get_grants(propertyt &properties,
                  vector<string> files,
                  userpt &who_up, grouppt &who_gp)
 {
  for(vector<string>::const_iterator it=files.begin();
      it!=files.end(); it++)
   {
    textprofilet profile;
    ifstream in(it->c_str());
    while(in && !in.eof())
      if(!profile.readline(in))
        if(match_grants(profile, properties, who_up, who_gp))
          return profile.get("grants");
   }

  return "";
 }

string get_grants(const string &type,
                  propertyt &properties,
                  userpt &who_up, grouppt &who_gp,
                  const string &filename)
 {
  vector<string> files;

  if(filename!="")
    files.push_back(filename);

  string file;

  file=who_up.getpath();
  file+="grants."+type;
  files.push_back(file);

  file=who_gp.getpath();
  file+="grants."+type;
  files.push_back(file);

  getboxsystemdir(file, config.boxdir);
  file+="grants."+type;
  files.push_back(file);

  getdboxsystemdir(file, config.dboxdir);
  file+="grants."+type;
  files.push_back(file);

  return get_grants(properties, files, who_up, who_gp);
 }

bool check_grant(const string &grants, const string &grant)
 {
  for(unsigned i=0; i<grants.size();)
   {
    string mask;

    string::size_type pos=grants.find_first_of(",; ", i);
    if(pos==string::npos)
     {
      mask=grants;
      i=grants.size();
     }
    else
     {
      mask.assign(grants, i, pos-i);
      i=pos+1;
     }

    if(check_joker(mask, grant, TRUE))
      return TRUE;
   }

  return FALSE;
 }
