#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#ifdef __MSDOS__
#include <dir.h>
#include <share.h>
#endif

#include <dbox.h>
#include <libmain.h>

#include <config.h>
#include <interlib.h>
#include <logf.h>
#include <libdboxversion.h>
#include <blzdb.h>
#include <portinfo.h>
#include <nls.h>
#include <asyncio.h>

char libdbox_version[]=LIBDBOXVERSION;
char libdbox_versionnr[]=LIBDBOXVERSIONNR;

bool init_libdbox(const char *version, const char *versionnr)
 {
  if(strcmp(version, LIBDBOXVERSION)!=0 ||
     strcmp(versionnr, LIBDBOXVERSIONNR)!=0)
   {
    fprintf(stderr, "Fatal: wrong libdbox version!\n"
                    "\n"
                    "libdbox version: %s/%s\n"
                    "programm requires: %s/%s\n",
                    LIBDBOXVERSIONNR, LIBDBOXVERSION,
                    versionnr, version);
    return TRUE;
   }

  asyncio.initialize();
  nls.initialize();
  config.initialize();
  logf.initialize();
  blzdb.initialize();
  portinfo.initialize();

  return FALSE;
 }

