#include <time.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <dboxpath.h>
#include <config.h>
#include <logfile.h>
#include <logf.h>

logft logf;

void logft::timefprintf(FILE *outfile)
 {
  ::timefprintf(outfile);
 }

int logft::fileprintf(const char *filename, const char *module, const char *format, ...)
 {
  FILE *logfile;

  if((logfile=fopen(filename, "at"))==NULL)
   {
    fprintf(stderr, "FATAL: Logfile %s konnte nicht geffnet werden!\r\n", filename);
    return 0;
   }

  va_list arglist;
  timefprintf(logfile);
  fprintf(logfile, "%s: ", module);
  va_start(arglist, format);
  vfprintf(logfile, format, arglist);
  va_end(arglist);
  fprintf(logfile, "\n");

  fclose(logfile);

  return 1;
 }

int logft::printf(const char *module, const char *format, ...)
 {
  char filename[DIRLEN];
  FILE *logfile;

  if(port==0)
   {
    if(logfilename[0]!=0)
      strmaxcpy(filename, logfilename, DIRLEN-1);
    else if(config.dboxdir[0]!=0)
      snprintf(filename, DIRLEN, DBOXSYSTEMDIR "logfile", config.dboxdir);
    else
      snprintf(filename, DIRLEN, DIRCHAR "logfile");
   }
  else
    snprintf(filename, DIRLEN, DBOXPORTDIR "logfile", config.dboxdir, port);

  if((logfile=fopen(filename, "at"))==NULL)
   {
    fprintf(stderr, "FATAL: Logfile %s konnte nicht geffnet werden!\r\n", filename);
    return 0;
   }

  va_list arglist;
  timefprintf(logfile);
  fprintf(logfile, "%s: ", module);
  va_start(arglist, format);
  vfprintf(logfile, format, arglist);
  va_end(arglist);
  fprintf(logfile, "\n");

  fclose(logfile);

  return 1;
 }

void logft::internalerror(const char *module, const char *error)
 {
  fprintf(stderr, "Interner Fehler: %s: %s\r\n", module, error);
  logf.printf(module, "Interner Fehler: %s", error);
  abort();
 }
