#ifndef DBOX_LOGF_H

#define DBOX_LOGF_H

#include <string>
#include <dbox.h>

class logft
 {
 public:
  int printf(const char *module, const char *format, ...);
  int fileprintf(const char *filename, const char *module, const char *format, ...);
  void setport(word p) { port=p; }
  void setlogfile(const char *filename) { strmaxcpy(logfilename, filename, DIRLEN-1); }
  void setlogfile(const string &filename) { setlogfile(filename.c_str()); }
  void internalerror(const char *module, const char *error);
  void timefprintf(FILE *outfile);

  void initialize()
   {
    port=0;
    logfilename[0]=0;
   }
   
  logft()
   {
    initialize();
   }

 private:
  word port;
  char logfilename[DIRLEN];
 };

extern logft logf; // logf.C

#endif
