#include <time.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <logfile.h>

void timefprintf(FILE *outfile)
 {
  struct tm *t;
  time_t ct;

  time(&ct);
  t=localtime(&ct);

  fprintf(outfile, "%02u.%02u.%04u, %02u:%02u:%02u: ",
    t->tm_mday, t->tm_mon+1, t->tm_year+1900, t->tm_hour, t->tm_min, t->tm_sec);
 }

int logfileprintf(const char *filename, 
                  const char *module, 
                  const char *format, ...)
 {
  FILE *logfile;

  if((logfile=fopen(filename, "at"))==NULL)
   {
    fprintf(stderr, "FATAL: Logfile %s konnte nicht geffnet werden!\r\n", filename);
    return 0;
   }

  va_list arglist;
  timefprintf(logfile);
  fprintf(logfile, "%s: ", module);
  va_start(arglist, format);
  vfprintf(logfile, format, arglist);
  va_end(arglist);
  fprintf(logfile, "\n");

  fclose(logfile);

  return 1;
 }

