#ifndef DBOX_LOGINS_H

#define DBOX_LOGINS_H

#include <profile.h>
#include <userdb.h>

class clientpt:public pt
 {
 public:
  virtual void setfilename();
  virtual bool add();
  virtual bool del();

  clientpt():pt() { }  
  clientpt(const char *_name):pt(_name) { }
 };

#define MAX_CHECKS 100
 
class check_login_baset
 {
 public:
  char errormsg[TEXTLEN];
  const char *protocol;
  
  virtual bool do_check(FILE *infile);
  
 protected:
  char protocol_check[TEXTLEN];
  unsigned number_of_radius_checks;

  struct radius_checkt
   {
    char mask[TEXTLEN], item[TEXTLEN];
   } radius_checks[MAX_CHECKS];
                     
  virtual bool do_line(const char *id, const char *text);
  virtual bool do_checks();
  bool do_protocol_check();
  bool do_radius_check();
  virtual void init();
  virtual bool radius_check(const char *item, const char *mask);
 };

class check_login1t:public check_login_baset
 {
 public:
  const char *login;
 
  virtual bool check_login1(FILE *infile);

  char username[TEXTLEN], boxname[TEXTLEN];
  char protocol_set[TEXTLEN];
 
  char radius_auth_server[TEXTLEN];
  char radius_auth_secret[TEXTLEN];
  char radius_acct_server[TEXTLEN];
  char radius_acct_secret[TEXTLEN];
  char radius_login[TEXTLEN];
  bool radius_autoadd;
  
  char forwardto_host[TEXTLEN];
  char forwardto_login[TEXTLEN];

 protected:
  char login_check[TEXTLEN];
  
  virtual void init();
  virtual bool do_line(const char *id, const char *text);
  virtual bool do_login_check();
  virtual bool do_checks();
 };

class check_login2t:public check_login_baset
 {
 public:
  virtual bool check_login2(FILE *infile);
    
  char errormsg[TEXTLEN];
  char charge_menu[TEXTLEN]; // charge session to menu
  dword session_timeout;     // max session time in seconds
  userpt *up;
 
 protected:
  struct user_checkt
   {
    char mask[TEXTLEN], item[TEXTLEN];
   } user_checks[MAX_CHECKS];
   
  unsigned number_of_user_checks;
  char username_check[TEXTLEN];
  long int time_check_min, time_check_max, 
           second_of_day, time_logout;
  time_t now;
  struct tm *tm;
                     
  virtual bool user_check(const char *item, const char *mask);
  virtual void init();
  virtual bool do_username_check();
  virtual bool do_user_check();
  virtual bool do_time_check();
  virtual bool do_line(const char *id, const char *text);
  virtual bool do_checks();
 };

#endif
