#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <mtoolzc.h>
#include <dbox.h>

void zcmessaget::copyheadertext(char *dest, const char *text, 
                                size_t maxlen) const
 {
  while(maxlen!=0 && *text!=0 && *text!='\r' &&
        *text!='\n' && text<endoffile)
   {
    *dest=*text;
    dest++;
    text++;
    maxlen--;
   }

  *dest=0;
 }

void zcmessaget::copyheadertext(string &dest, const char *text) const
 {
  while(*text!=0 && *text!='\r' && 
        *text!='\n' && text<endoffile)
    dest+=*(text++);
 }

void zcmessaget::copyheaderid(char *dest, const char *id, 
                              size_t maxlen) const
 {
  while(maxlen!=0 && *id!=0 && *id!=':' && id<endoffile)
   {
    *dest=*id;
    dest++;
    id++;
    maxlen--;
   }

  *dest=0;
 }

void zcmessaget::copyheaderid(string &dest, const char *id) const
 {
  while(*id!=0 && *id!=':' && id<endoffile)
    dest+=*(id++);
 }

void zcmessaget::processline(const char *id, const char *text)
 {
  char tempstr[200], tempstr2[200];

  copyheaderid(tempstr, id, 199);

  if(stricmp(tempstr, "ABS")==0)
    abs=text;
  else if(stricmp(tempstr, "BET")==0)
    bet=text;
  else if(stricmp(tempstr, "EDA")==0)
    eda=text;
  else if(stricmp(tempstr, "MID")==0)
    mid=text;
  else if(stricmp(tempstr, "LEN")==0)
    len=atol(text);
  else if(stricmp(tempstr, "ROT")==0)
    rot=text;
  else if(stricmp(tempstr, "WAB")==0)
    wab=text;
  else if(stricmp(tempstr, "STAT")==0)
   {
    copyheadertext(tempstr2, text, 199);

    if(stricmp(tempstr2, "NOKOP")==0)
      stat_nokop=TRUE;
   }
  else if(stricmp(tempstr, "TYP")==0)
    typ=text;
 }

bool zcmessaget::parseline(const char **start, 
                           const char **id,
                           const char **text) const
 {
  const char *d=*start;
  byte status=0;

  do
   {
    if(d==endoffile) return TRUE;

    switch(status)
     {
     case 0: // Start der Kennung
      if(*d=='\r')
        status=5;
      else
       {
        if(*d==':' || *d==' ') return TRUE;
        *id=d;
        status=1;
       }
      break;

     case 1: // Kennung
      if(*d==':') status=2;
      if(*d=='\r' || *d=='\n' || *d==' ') return TRUE;
      break;

     case 2: // Leerraum zwischen Kennung und Inhalt
      if(*d!=' ' && *d!='\t')
       {
        *text=d;
        if(*d=='\r')
          status=4;
        else
          status=3;
       }
      break;

     case 3: // Inhalt
      if(*d=='\r')
        status=4;
      break;

     case 4: // \r
      if(*d!='\n') return TRUE;
      status=0xff;
      break;

     case 5: // \r vom Ende
      if(*d!='\n') return TRUE;
      *id=*text=(char *)NULL;
      status=0xff;
      break;
     }

    d++;
   }
  while(status!=0xff);

  *start=d;

  return FALSE;
 }

bool zcmessaget::parse()
 {
  const char *d=data, *id, *text;

  abs=bet=eda=mid=rot=wab=typ=(char *)NULL;
  len=0xffffffff;
  stat_nokop=FALSE;

  while(TRUE)
   {
    if(parseline(&d, &id, &text)) return TRUE;
    if(id==NULL)
     {
      headerlen=d-data;
      if(len==0xffffffff) return TRUE;
      d+=len;
      if(d>endoffile) return TRUE;
      endofmail=d;
      return FALSE;
     }
    else
      processline(id, text);
   }
 }

bool zcmessaget::copyheader_special(FILE *outfile, byte *emps,
                                    const char *rot, 
                                    bool delete_internal_headers) const
 {
  const char *d=data, *id, *text;
  dword empnr=0;
  char tempstr[200];

  while(TRUE)
   {
    if(parseline(&d, &id, &text)) return TRUE;
    if(id==NULL)
     {
      fprintf(outfile, "\r\n");
      return FALSE;
     }

    copyheaderid(tempstr, id, 199);
    if(stricmp(tempstr, "EMP")==0)
     {
      switch(emps[empnr++])
       {
       case 0:
        goto docopy;

       case 1:
        fprintf(outfile, "KOP:\t");
        fwrite(text, 1, d-text, outfile);
        break;

       case 2:
        break;
       }
     }
    else if(strnicmp(tempstr, "_" X_DBOX, strlen("_" X_DBOX))==0)
     {
      if(!delete_internal_headers) goto docopy;
     }
    else if(stricmp(tempstr, "ROT")==0 && rot!=NULL && rot[0]!=0)
     {
      fprintf(outfile, "ROT:\t%s", rot);
      if(text[0]=='\r')
        fprintf(outfile, "\r\n");
      else
       {
        fprintf(outfile, "!");
        fwrite(text, 1, d-text, outfile);
       }
     }
    else
     {
     docopy:
      fwrite(id, 1, d-id, outfile);
     }
   }
 }

bool zcmessaget::getbodyline(char *line, const char **pptr,
                             dword maxlen) const
 {
  if(*pptr>=endofmail || *pptr<(data+headerlen) || maxlen<1)
    return TRUE;

  *line=0;

  while(TRUE)
   {
    if(*pptr>=endofmail)
      return FALSE;

    if(**pptr=='\n')
     {
      (*pptr)++;
      return FALSE;
     }

    if(**pptr!='\r' && strlen(line)<(maxlen-1))
     {
      *line=**pptr;
      line++;
      *line=0;
     }

    (*pptr)++;
   }
 }

bool isnewsemp(const char *emp)
 {
  if(strchr(emp, '@')!=NULL) return FALSE;

  if(strchr(emp, '/')==NULL)
    return FALSE;

  return TRUE;
 }

#if 0
string make_eda(const time_t &t)
 {
  tm *s;
  string eda;

  s=localtime(&t);
  s=gmtime(&t);

  char tempstr[TEXTLEN];
  snprintf(tempstr, TEXTLEN, "%04u%02u%02u%02u%02u%02u%c%c%lu",
    s->tm_year+1900, s->tm_mon+1, s->tm_mday,
    s->tm_hour, s->tm_min, s->tm_sec,
    (s->tm_isdst>0)?'S':'W',
    (timezone>=0)?'+':'-',
    labs(timezone)/60/60);

  eda=tempstr;

  unsigned minutes=(labs(timezone)/60)%60;
  if(minutes)
   {
    snprintf(tempstr, TEXTLEN, ":%02u", minutes);
    eda+=tempstr;
   }

  return eda;
 }
#endif
