#include <string.h>

#include <dboxpath.h>
#include <config.h>
#include "nls.h"

nlst nls;

const char *nlst::get(const char *id)
 {
  const char *result;

  open();

  result=nlsp_pref->get(id);
  if(result[0]!=0) return result;

  return nlsp_def->get(id);
 }

const char *nlst::get(const string &id)
 {
  return get(id.c_str());
 }

void nlst::set_language(const char *_language)
 {
  if(strcmp(language, _language)==0) return;
  isopen=FALSE;
  strmaxcpy(language, _language, TEXTLEN-1);
 }

void nlst::initialize()
 {
  isopen=FALSE;
  language[0]=0;
  nlsp_def=nlsp_pref=NULL;
 }

void nlst::open()
 {
  if(isopen) return;
  isopen=TRUE;

  if(nlsp_def==NULL) nlsp_def=new nlspt("default");
  if(nlsp_pref==NULL) nlsp_pref=new nlspt(language);

  nlsp_def->read();
  if(language[0]!=0) nlsp_pref->read();
 }

nlst::~nlst()
 {
  if(nlsp_def!=NULL) delete nlsp_def;
  if(nlsp_def!=NULL) delete nlsp_pref;
 }

const char *nlst::operator[](const char *id)
 {
  return get(id);
 }

const char *nlst::operator[](const string &id)
 {
  return get(id.c_str());
 }

void nlspt::setfilename()
 {
  snprintf(path, DIRLEN, DBOXSYSTEMDIR, config.dboxdir);
  strmaxcpy(locktype, "nls", TEXTLEN-1);
  snprintf(filename, DIRLEN, "%s%s.nls", path, name);
 }
