#ifndef DBOX_OLDTOOLS_H

#define DBOX_OLDTOOLS_H

#include <oldterm.h>

#include <charsett.h> // for charsett

#define STRINGLIST_MAXSTRINGS 100

class stringlistt
 {
 public:
  char *strings[STRINGLIST_MAXSTRINGS];
  
  void parsestring(const char *s);
  
  stringlistt() 
   {
    for(int i=0; i<STRINGLIST_MAXSTRINGS; i++)
      strings[i]=(char *)NULL;
   }
   
  ~stringlistt();
 };

#define noyes1(val) (val?"Ja":"Nein")
#define noyes2(val) (val?" Ja":"Nein")

#define MENU_HELP -3

bool readline(screent *screen, char *line, bool pw, bool special, 
              bool preserve_case, bool hide);

void drawtitle(screent *screen, const char *title);
void printtextfile(screent *screen, FILE *file);
void viewtextfile(screent *screen, FILE *file, const char *title, charsett charset, bool useattr);
void printattrstr(screent *screen, const char *text, byte sizex, byte layer);
bool viewarchive(char *infilename, char *outfilename);

void drawscreen(screent *screen, const char *title, const char *version);
void clearworkscreen(screent *screen);

void formatdate(char *s, time_t t);

void errorbox(screent *screen, const char *error);
void infobox(screent *screen, const char *text);

void deldir(const char *directory);

#endif
