#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include <general.h>
#include <parsetime.h>

long int parsetime(const char *time)
 {
  const char *tptr=time;
  int hour=0, min=0, sec=0;

  while(isspace(*tptr)) tptr++;

  hour=atoi(tptr);
  tptr=strchr(tptr, ':');

  if(tptr==NULL) return -1;

  tptr++;
  min=atoi(tptr);
  tptr=strchr(tptr, ':');
  if(tptr!=NULL)
   {
    tptr++;
    sec=atoi(tptr);
   }
  
  return hour*3600+min*60+sec;
 }

bool time_check(long int second_of_day, long int time_check_min,
                long int time_check_max)
 {
  if(time_check_min==-1 && time_check_max==-1) return FALSE;

  // printf("DK %ld %ld %ld\n", second_of_day, time_check_min, time_check_max);

  if(time_check_min<=time_check_max ||
     time_check_min==-1 || time_check_max==-1)
   {
    return !((time_check_min==-1 || second_of_day>=time_check_min) &&
             (time_check_max==-1 || second_of_day<=time_check_max));
   }

  return !(second_of_day>=time_check_min ||
           second_of_day<=time_check_max);
 }

