#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

#include <config.h>
#include <dboxpath.h>
#include <logf.h>
#include <tools.h>
#include <portinfo.h>

portinfot portinfo;

// **********************************************************************
// *                                                                    *
// *                            Portinfo                                *
// *                                                                    *
// **********************************************************************

portinfot::~portinfot()
 {
  if(opened) 
   {
    ::close(handle);
    opened=FALSE; 
   }
 }

void portinfot::write(byte port)
 {
  if(!opened) open();
  lseek(handle, port*(sizeof info), SEEK_SET);
  ::write(handle, &owninfo, sizeof info);
 }

void portinfot::read(byte port)
 {
  if(!opened) open();
  lseek(handle, port*(sizeof info), SEEK_SET);
  ::read(handle, &info, sizeof info);
 }

void portinfot::getstatusstring(char *s)
 {
  switch(info.status)
   {
   case infot::WORKING:
    strmaxcpy(s, "- DBOX -", TEXTLEN-1);
    break;

   case infot::FREE:
    strmaxcpy(s, "- frei -", TEXTLEN-1);
    break;

   case infot::RING:
   case infot::LOGIN:
    strmaxcpy(s, "- Anruf -", TEXTLEN-1);
    break;

   case infot::ONLINE:
   case infot::CHATTING:
    strmaxcpy(s, info.username, TEXTLEN-1);
    break;

   case infot::NETCALL:
    snprintf(s, TEXTLEN, "Box %s", info.username);
    break;

   case infot::SLIP:
    snprintf(s, TEXTLEN, "IP %s", info.username);
    break;

   case infot::ERROR:
    strmaxcpy(s, "- Error -", TEXTLEN-1);
    break;

   default:
    s[0]=0;
   }
 }

bool portinfot::open()
 {
  if(filename[0]==0)
    snprintf(filename, DIRLEN, 
             DBOXSYSTEMDIR "clients" DIRCHAR "localhost.dbox" DIRCHAR "portinfo",
             config.dboxdir);

  handle=::open(filename,
    O_RDWR|O_CREAT|O_BINARY, S_IREAD|S_IWRITE);

  if(handle<0)
   {
    char tempstr[DIRLEN];

    snprintf(tempstr, DIRLEN, 
      "FATAL: Portinfo %s konnte nicht geffnet werden!", 
      filename);

    logf.internalerror("portinfot::open", tempstr);
    return TRUE;
   }

  opened=TRUE;

  if(filelength(handle)!=MAXPORTS*(sizeof info))
   {
    int i;

    logf.printf("portinfot::open", "Warnung: Erstelle neue Portinfo.");

    ::close(handle);

    handle=::open(filename,
      O_RDWR|O_CREAT|O_TRUNC|O_BINARY, S_IREAD|S_IWRITE);

    for(i=0; i<MAXPORTS; i++)
     {
      info.status=infot::OFFLINE;
      ::write(handle, &info, sizeof info);
     }
   }

  owninfo.status=infot::WORKING;
  owninfo.lastcall=0;
  strmaxcpy(owninfo.modemname, "Console", TEXTLEN-1);
  owninfo.telefon[0]=0;
  strmaxcpy(owninfo.username, DBOXUSER, TEXTLEN-1);
  owninfo.versteckt=FALSE;

  return FALSE;
 }

