#ifndef DBOX_PORTINFO_H

#define DBOX_PORTINFO_H

#include <dbox.h>
#include <interlib.h>

class portinfot
 {
 public:
  struct infot
   {
    enum statust
     {
      OFFLINE,   // Port offline
      WORKING,   // Box schafft
      FREE,      // Warte auf Anruf
      RING,      // Warte auf Connect
      LOGIN,     // Warte auf Username/Passwort
      ONLINE,    // User eingeloggt
      CHATTING,  // User chattet
      NETCALL,   // Netcall
      SLIP,      // SLIP/PPP
      ERROR      // Port offline wg. Hardwarefehler
     } status;

    char modemname[TEXTLEN],
         telefon[TEXTLEN],
         username[TEXTLEN],
         from[TEXTLEN],
         boxname[TEXTLEN],
         sessionid[TEXTLEN];
         
    time_t lastcall;
    bool versteckt;
    internetaddresst slipaddr;
    pid_t pid;

   } info, owninfo;

  void read(byte port);         // liest info und command
  void write(byte port);        // schreibt owninfo

  void initialize() { opened=FALSE; filename[0]=0; }
  portinfot() { initialize(); }
  ~portinfot();
  void getstatusstring(char *s);

  char filename[DIRLEN];
  
 private:
  int handle;
  bool opened;

  bool open();
 };

extern portinfot portinfo;

#endif
