#ifndef DBOX_RADIUS_H

#define DBOX_RADIUS_H

#define RADIUS_MAXATTRIBUTES 100

#include <interlib.h>

class radiust
 {
 public:
  internetaddresst radius_auth_server, radius_acct_server, nas_ip_address;
  char secret[TEXTLEN];
  
  char username[TEXTLEN], calling_station_id[TEXTLEN], session_id[TEXTLEN];
  internetaddresst ip_address;
  word port;
  byte identifier;
 
  int authenticate(const char *password, char *message);
  int log_start();
  int log_stop(dword dauer);
  
  // Fehlercodes: 0 OK
  //              1 Username/Passwort falsch
  //              2 Transmission-Timeout
  //              3 sonstiger Fehler
  //              4 Antwort falsch
  
  radiust()
   {
    identifier=1;
    anzattributes=0;
    secret[0]=0;
    nas_ip_address=0;
    calling_station_id[0]=secret[0]=username[0]=session_id[0]=0;
    port=0;
    ip_address=0;
   }
  
 private:
  struct attributet
   {
    union
     {
      char string[TEXTLEN];
      dword integer;
     } data;
     
    byte type, length;
    
   } attributes[RADIUS_MAXATTRIBUTES];

  word anzattributes;   
  byte code;
  
  int sendserver(internetaddresst server_address, word udp_port);
 };

void radius_test();

#endif
