#ifndef DBOX_SPOOLF_T

#define DBOX_SPOOLF_T

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>

template <class Mt>
class spoolft
 {
 public:
  Mt m;
  
  spoolft();
  
  virtual bool spoolf(const char *filename, bool do_remove=TRUE);
  virtual void spoolf3()=0;
  
  virtual ~spoolft() { }

 protected:
  virtual bool spoolf2();
  
  int handle;
  dword input_file_length;
  bool mapped, error;
  char *posting;
 };

#include <dbox.h>
#include <tools.h>
#include <mtoolzc.h>
#include <logf.h>

template <class Mt>
spoolft<Mt>::spoolft()
 {
  posting=(char *)NULL;
  error=FALSE;
  mapped=FALSE;
 }

template <class Mt>
bool spoolft<Mt>::spoolf2()
 {
  if(input_file_length>60000)
   {
    posting=(char *)mmap(NULL, input_file_length,
            PROT_READ, MAP_FILE|MAP_PRIVATE, handle, 0);
    mapped=TRUE;

    if(posting==NULL)
      logf.internalerror("spoolft::spoolf2", "fatal: mmap failed");
   }
  else
   {
    posting=(char *)malloc(input_file_length);
    if(posting==NULL) 
      logf.internalerror("spoolft::spoolf2", "fatal: malloc failed");

    if(read(handle, posting, input_file_length)!=(signed long)input_file_length)
      logf.internalerror("spoolft::spoolf2", "fatal: read failed");
   }

  m.data=posting;
  m.endoffile=posting+input_file_length;

  while(!m.eof() && !error)
   {
    if(m.parse())
      error=TRUE;
    else
     {
      spoolf3();
      m.data=m.endofmail;
     }
   }

  if(mapped)
    munmap(posting, input_file_length);
  else
    free(posting);

  if(error)
    logf.printf("spoolft::spoolf2", "error in input file");

  return error;
 }

template <class Mt>
bool spoolft<Mt>::spoolf(const char *filename, bool do_remove)
 {
  bool result;  

  handle=open(filename, O_RDONLY|O_BINARY);
  if(handle<0) return TRUE;

  input_file_length=filelength(handle);

  if(input_file_length!=0)
    result=spoolf2();
  else
    result=FALSE;

  close(handle);

  if(do_remove)
    remove(filename);

  return result;
 }
 
#endif
