#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dbox.h>
#include <stool.h>

bool checkdomain(const char *domain, const char *domains)
 {
  const char *tptr, *tptr2;

  if(*domain=='.') domain++;

  tptr=domains;
  while(*tptr!=0)
   {
    tptr2=tptr;
    while(*tptr2!=0 && *tptr2!=' ' && *tptr2!='\t' && 
          *tptr2!=';' && *tptr2!=',')
      tptr2++;

    if(*tptr=='.') tptr++;

    if(strnicmp(domain, tptr, tptr2-tptr)==0) return FALSE;

    tptr=tptr2;
    if(*tptr!=0)
      while(*tptr==' ' || *tptr=='\t' ||
            *tptr==';' || *tptr==',')
        tptr++;
   }

  return TRUE;
 }

bool checkmid(const char *mid, bool relaxed)
 {
  if(!relaxed)
   {
    if(strchr(mid, '@')==NULL) return TRUE;

    while(*mid!=0)
     {
      if(*mid>=0 && *mid<=' ') return TRUE;
      if(*mid<0) return TRUE;
      mid++;
     }

    return FALSE;
   }

  if(mid[0]==0) return TRUE;

  return FALSE;
 }

bool checkabscharset(const char *s, bool relaxed)
 {
  if(relaxed)
   {
    while(*s!=0)
     {
      if(isascii(*s) && iscntrl(*s))
        return TRUE;

      s++;
     }

    return FALSE;
   }

  byte status=0;
  char ch;

  /* 0=localpart
     1=domainpart
     2=Realname */

  while(TRUE)
   {
    ch=*(s++);

    switch(status)
     {
     case 0:
      if(ch=='@')
        status++;
      else if(ch<=' ' || ch>126 ||
              ch=='<' || ch=='>' || ch=='/' || ch=='\\' ||
              ch=='(' || ch==')' || ch=='[' || ch==']' ||
              ch=='"')
        return TRUE;

      break;

     case 1:
      if(ch==0)
        return FALSE;
      else if(ch==' ')
       {
        ch=*(s++);
        if(ch==0) return FALSE;

        if(ch=='(')
          status++;
        else
          return TRUE;
       }
      else
       {
        if(!isascii(ch)) return TRUE;
        if(!isalnum(ch) && ch!='.' && ch!='-') return TRUE;
       }
      break;

     case 2:
      if(ch==')')
       {
        ch=*(s++);
        if(ch!=0) return TRUE;
        return FALSE;
       }
      else if(ch==0)
        return TRUE;
      break;

     default:
      return TRUE;
     }
   }
 }

