#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>

#include <dbox.h>
#include <stoolzc.h>
#include <config.h>
#include <dboxpath.h>
#include <logf.h>

void movetobad(const char *oldfilename, const char *boxdir)
 {
  const char *filename;
  char newfilename[DIRLEN];
  dword count=1;

  filename=strrchr(oldfilename, DIRCHAR[0]);
  if(filename==NULL)
    filename=oldfilename;
  else
    filename++;

  do
   {
    snprintf(newfilename, DIRLEN, 
      BOXBADDIR "%lu%s", boxdir, count, filename);
    count++;
   }
  while(access(newfilename, 00)==0);

  if(rename(oldfilename, newfilename)==0)
   {
    logf.printf("movetobad", "File %s saved as %s", oldfilename, newfilename);
   }
  else
   {
    remove(oldfilename);
    logf.printf("movetobad", "Fatal: rename(\"%s\", \"%s\"); failed!",
      oldfilename, newfilename);
   }
 }

void movetobad(bool mail, const char *filename, const char *boxdir)
 {
  char newfilename[DIRLEN], oldfilename[DIRLEN];
  dword count=1;

  if(mail)
    snprintf(oldfilename, DIRLEN, 
      BOXSPOOLINZCMAILDIR "%s", boxdir, filename);
  else
    snprintf(oldfilename, DIRLEN,
      BOXSPOOLINZCNEWSDIR "%s", boxdir, filename);

  do
   {
    snprintf(newfilename, DIRLEN,
      BOXBADDIR "%lu%s", boxdir, count, filename);
    count++;
   }
  while(access(newfilename, 00)==0);

  if(rename(oldfilename, newfilename)==0)
   {
    logf.printf("movetobad", "File %s saved as %s", filename, newfilename);
   }
  else
   {
    remove(oldfilename);
    logf.printf("movetobad", "Fatal: rename(\"%s\", \"%s\"); failed!",
      filename, newfilename);
   }
 }

void checkmailnews(zcmessaget *m, 
                   bool *mail, bool *news,
                   dword *count)
 {
  const char *tptr, *inhalt;
  char tempstr[1000];

  *mail=FALSE;
  *news=FALSE;
  *count=0;

  tptr=m->data;
  while(!m->findheader(&tptr, "EMP", &inhalt))
   {
    (*count)++;

    m->copyheadertext(tempstr, inhalt, 999);

    if(isnewsemp(tempstr))
      *news=TRUE;
    else
      *mail=TRUE;
   }
 }

