#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
//#include <gdbm.h>

#include <general.h>
#include <dbox.h>
#include <config.h>
#include <dboxpath.h>
#include <logf.h>
#include <profile.h>
#include <ticket.h>
#include <lock.h>
#include <grants.h>

void ticketpt::setfilename()
 {
  int i, len; 

  snprintf(path, DIRLEN, BOXTICKETDIR "tickets" DIRCHAR, pconfig->boxdir);

  name[50]=0;
  len=strlen(name);

  for(i=0; i<len; i++)
    sprintf(path+strlen(path), "%c" DIRCHAR, name[i]);

  strmaxcpy(locktype, "ticket", TEXTLEN-1);
  snprintf(filename, DIRLEN, "%sprofile", path);
 }
 
bool ticketpt::add()
 {
  char filename[DIRLEN];
  int i, len;

  len=strlen(name);

  snprintf(filename, DIRLEN, BOXTICKETDIR "tickets" DIRCHAR, pconfig->boxdir);

  for(i=0; i<len; i++)
   {
    if(i!=0) sprintf(filename+strlen(filename), "%c", DIRCHAR[0]);
    sprintf(filename+strlen(filename), "%c", name[i]);
    if(access(filename, 00)!=0)
     {
      if(mkdir(filename, S_IRWXU)!=0)
       {
        char errormsg[DIRLEN*2];
        sprintf(errormsg, "failed to mkdir %s", filename);
        logf.internalerror("ticketpt::add", errormsg);
       }
     }
   }

  return FALSE;
 }

bool ticketpt::del()
 {
  return TRUE;
 }

ticketpt::ticketpt():pt()
 {
  strmaxcpy(locktype, "ticket", TEXTLEN-1);
 }

bool ticketdispenser(char *name)
 {
  char filename[DIRLEN];
  char line[TEXTLEN];
  int handle, result;
  dword nr;

  snprintf(filename, DIRLEN, BOXTICKETDIR "ticket.dat", config.boxdir);

  if(lock("ticketdispenser", "ticket.dat", "")) return TRUE;

  handle=open(filename, O_CREAT|O_RDWR|O_BINARY, S_IREAD|S_IWRITE);

  result=read(handle, line, TEXTLEN-1);
  if(result<0 || result>(TEXTLEN-1))
    line[0]=0;
  else
    line[result]=0;

  if(line[0]==0)
    nr=10;
  else
    nr=atol(line);

  lseek(handle, 0, SEEK_SET);
  snprintf(line, TEXTLEN, "%lu\n", nr+1);
  write(handle, line, strlen(line));
  close(handle);

  unlock("ticketdispenser", "ticket.dat", "");

  snprintf(name, TEXTLEN, "%lu", nr);

  return FALSE;
 }

string get_grants(ticketpt &ticketp,
                  userpt &who_up, grouppt &who_gp)
 {
  string filename=ticketp.getpath();
  filename+="grants";

  propertyt properties;

  for(unsigned i=0; i<ticketp.size(); i++)
    properties.set(string("ticket.")+ticketp.data[i].id,
                   ticketp.data[i].data);

  return get_grants("ticket", properties, who_up, who_gp, filename);
 }




#if 0                     
void ticketdbt::reset()
 {
  GDBM_FILE dbf;

  mkfilename();
  dbf=gdbm_open(filename, 512, GDBM_NEWDB, S_IREAD|S_IWRITE, 0);
  if(dbf==NULL)
    logf.internalerror("ticketdbt::reset", "gdbm_open failed");

  gdbm_close(dbf);
 }

void ticketdbt::store(ticketpt *ticket)
 {
  GDBM_FILE dbf;
  int i;

  mkfilename();
  dbf=gdbm_open(filename, 512, GDBM_WRITER, 0, 0);
  if(dbf==NULL)
    logf.internalerror("ticketdbt::store", "gdbm_open failed");

  for(i=0; i<ticket->data_elements; i++)
   {
    datum key, content;
    char keytext[TEXTLEN*2];
    dword ticketnr;

    key.dptr=keytext;
    key.dptr=strlen(keytext)+1;

    content=gdbm_fetch(dbf, key);
    if(content.dptr==NULL)
     {
     }
    else
     {
     }
   }

  gdbm_close(dbf);
 }

bool ticketdbt::find(ticketpt *ticket, ticketpt *mask)
 {
  GDBM_FILE dbf;

  mkfilename();
  dbf=gdbm_open(filename, 512, GDBM_READER, 0, 0);
  if(dbf==NULL)
    logf.internalerror("ticketdbt::find", "gdbm_open failed");

  gdbm_close(dbf);

  return TRUE;
 }
#endif
