#ifndef DBOX_USERDB_H

#define DBOX_USERDB_H

#include <vector.h>

#include <profile.h>

#define MAXSECURITY 9

class userpt:public pt
 {
 public:
  virtual void setfilename();
  virtual bool add();
  virtual bool del();

  userpt():pt() { }  
  userpt(const char *_name):pt(_name) { }
 };
 
bool usercharisok(char ch); // returns TRUE if the char ch is not a valid
                            // character in an user name

bool checkusername(const char *username);

class grouppt:public pt
 {
 public:
  virtual void setfilename();
  virtual bool add();
  virtual bool del();

  grouppt():pt() { }  
  grouppt(const char *_name):pt(_name) { }
 };
 
bool getpermissions(const char *permissionline, char *empmask,
  bool *read, bool *write, bool *sysop, userflagst *userflags);

// userflags: 0 egal
//            1 muss vorhanden sein
//            2 darf nicht vorhanden sein

bool getinternalflag(userpt *up, grouppt *gp, int flag);
bool getuserflag(userpt *up, grouppt *gp, int flag);
bool getuserflag(userpt *up, grouppt *gp, const char *flag);
bool checkuserflags(userpt *up, grouppt *gp, userflagst *userflags);
void getuser(userpt *up, grouppt *gp, const char *id, char *text);

void getplaintextpassword(pt *up, char *pw);
bool verifylogin(userpt *up, const char *pw);
void cryptpassword(const char *source, char *dest);
void uncryptpassword(const char *source, char *dest);

void getuserlist(vector<string> &user, const string &mask);

bool get_internalflag(userpt &up, userpt &up2, grouppt &gp, int flag);
bool get_userflag(userpt &up, userpt &up2, grouppt &gp, const char *flag);

void get_profiles(userpt &up, userpt &up2, grouppt &gp);

#endif
