#include <stdio.h>

#include <dbox.h>
#include <uuencode.h>

/* ENC is the basic 1 character encoding function to make a char printing */
#define ENC_old_compat(c) (((c) & 077) + ' ')
#define ENC_new(c) ((((c) & 077)==0)?'`':(((c) & 077) + ' '))

void encode_outdec(char *p, FILE *f, byte old_compat)
 {
  int c1, c2, c3, c4;

  c1=*p>>2;
  c2=(*p<<4)&060|(p[1]>>4)&017;
  c3=(p[1]<<2)&074|(p[2]>>6)&03;
  c4=p[2]&077;

  if(old_compat)
   {  
    putc(ENC_old_compat(c1), f);
    putc(ENC_old_compat(c2), f);
    putc(ENC_old_compat(c3), f);
    putc(ENC_old_compat(c4), f);
   }
  else
   {
    putc(ENC_new(c1), f);
    putc(ENC_new(c2), f);
    putc(ENC_new(c3), f);
    putc(ENC_new(c4), f);
   }
 }

int encode_fr(FILE *fd, char *buf, size_t cnt, size_t *len)
 {
  int c;
  size_t i;

  if(cnt>*len) cnt=*len;

  for (i=0; i<cnt; i++)
   {
    (*len)--;
    c=getc(fd);
    if(c==EOF) return i;
    buf[i] = c;
   }
  return (cnt);
 }

void uuencode(FILE *infile, FILE *outfile, size_t binlen, 
              const char *filename, byte old_compat)
 {
  char buf[80];
  int i, n;

  fprintf(outfile, "begin 644 %s\n", filename);

  for(;;)
   {
    n=encode_fr(infile, buf, 45, &binlen);

    if(old_compat)
      putc(ENC_old_compat(n), outfile);
    else
      putc(ENC_new(n), outfile);
        
    for (i=0; i<n; i += 3) encode_outdec(&buf[i], outfile, old_compat);
    putc('\n', outfile);
    if(n<=0) break;
   }

  fprintf(outfile, "end\n");
 }
