#include <stdio.h>

#include <stream.h>

#include <dbox.h>
#include <uuencode_str.h>

/* ENC is the basic 1 character encoding function to make a char printing */
#define ENC_old_compat(c) (((c) & 077) + ' ')
#define ENC_new(c) ((((c) & 077)==0)?'`':(((c) & 077) + ' '))

void encode_outdec(char *p, ostream &out, byte old_compat)
 {
  int c1, c2, c3, c4;

  c1=*p>>2;
  c2=(*p<<4)&060|(p[1]>>4)&017;
  c3=(p[1]<<2)&074|(p[2]>>6)&03;
  c4=p[2]&077;

  if(old_compat)
   {  
    out << char(ENC_old_compat(c1));
    out << char(ENC_old_compat(c2));
    out << char(ENC_old_compat(c3));
    out << char(ENC_old_compat(c4));
   }
  else
   {
    out << char(ENC_new(c1));
    out << char(ENC_new(c2));
    out << char(ENC_new(c3));
    out << char(ENC_new(c4));
   }
 }

int encode_fr(istream &in, char *buf, size_t cnt, size_t *len)
 {
  char c;
  size_t i;

  if(cnt>*len) cnt=*len;

  for (i=0; i<cnt; i++)
   {
    (*len)--;
    if(!in.read(&c, 1)) return i;
    buf[i] = c;
   }
  return (cnt);
 }

void uuencode(istream &in, ostream &out, size_t binlen, 
              const char *filename, byte old_compat)
 {
  char buf[80];
  int i, n;

  out << "begin 644 " << filename << "\n";

  for(;;)
   {
    n=encode_fr(in, buf, 45, &binlen);

    if(old_compat)
      out << char(ENC_old_compat(n));
    else
      out << char(ENC_new(n));
        
    for (i=0; i<n; i += 3) encode_outdec(&buf[i], out, old_compat);
    out << "\n";
    if(n<=0) break;
   }

  out << "end\n";
 }
