#include <stdio.h>
#include <string.h>

#ifdef OS_WIN32

#include <logf.h>

#include "winport.h"

int snprintf(char *str, size_t n, const char *format, ...)
 {
  va_list args;
  int chars; 

  va_start(args, format);

  chars=vsnprintf(str, n, format, args);

  va_end(args);

  return chars;
 }

int vsnprintf(char *str, size_t n, const char *format, va_list ap)
 {
  int chars;
  char *buffer;
  
  if(n==0) return 0;

  buffer=(char *)malloc(100000); // large enough, hopefully
  if(buffer==(char *)NULL) logf.internalerror("vsnprintf", "malloc failed");

  chars=vsprintf(buffer, format, ap);

  strmaxcpy(str, buffer, n-1);

  free(buffer);

  return chars;
 }

#endif
