/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <logf.h>
#include <dboxpath.h>
#include <oldtools.h>
#include <zconnect.h>
#include <account.h>
#include <parsetime.h>
#include "chargemenu.h"

time_t gettime(const char *desc)
 {
  char input[TEXTLEN], ch;
  struct tm tm;
  time_t now, t;

  time(&now);

  tm=*localtime(&now);

  tm.tm_sec=0;
  tm.tm_min=0;
  tm.tm_hour=0;
  tm.tm_isdst=0;

  cout << desc << " date (dd.mm.yyyy): ";
  
  cin.get(input, TEXTLEN-1);
  cin.get(ch);
  if(isdigit(input[0]))
   {
    sscanf(input, "%d.%d.%d", &tm.tm_mday, &tm.tm_mon, &tm.tm_year);
    tm.tm_mon--;

    if(tm.tm_year>100) 
      tm.tm_year-=1900;
    else if(tm.tm_year<90)
      tm.tm_year+=100;
   }

  cout << desc << " time (hh:mm:ss): ";
  
  cin.get(input, TEXTLEN-1);
  cin.get(ch);
  if(!isdigit(input[0])) return 0;

  tm.tm_sec=parsetime(input);
  if(tm.tm_sec==-1) return 0;
  t=mktime(&tm);

  cout << "\n" << desc << " time: " << tm.tm_mday << "." << tm.tm_mon+1 << "."
       << tm.tm_year+1900 << " " 
       << tm.tm_hour << ":" << tm.tm_min << ":" << tm.tm_sec << "\n\n";

  return t;
 }

void chargemenu()
 {
  time_t start, end;
  char menu[TEXTLEN], ch;
  userpt up;

  start=gettime("Start");
  if(start==0) return;

  end=gettime("End");
  if(end==0) return;
  
  cout << "Menu: ";
  cin.get(menu, TEXTLEN-1);
  cin.get(ch);
  if(menu[0]==0) return;

  cout << "User: ";
  cin.get(up.name, TEXTLEN-1);
  cin.get(ch);
  if(up.name[0]==0) return;

  dnstring(up.name);
  if(up.read()) return;

  chargemenu(&up, menu, "TEST", start, end);

  cout << "OK\n";
 }
