/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <logf.h>
#include <dboxpath.h>
#include <oldtools.h>
#include <account.h>
#include "checkkonto.h"

void docheckkonto(userpt &up, bool fixit)
 {
  char filename[DIRLEN];
  buchungt buchung;
  FILE *infile;
  amountt balance, up_balance;
  dword number=0;
  bool ok=TRUE;

  balance.amount=0;
  balance.scale=0;

  printf("%s: ", up.name);

  snprintf(filename, DIRLEN, "%skonto", up.getpath());
  infile=fopen(filename, "rt");
  if(infile==NULL) 
   {
    printf(" no file\n");
    return;
   }

  while(!buchung.read(infile))
   {
    if(buchung.haben)
      balance+=buchung.amount;
    else
      balance-=buchung.amount;

    if(number!=buchung.number)
      printf("Warning: %lu!=%lu\n", number, buchung.number);

    number++;
   }

  fclose(infile);

  up_balance=getbalance(&up);

  if(balance!=up_balance)
   {
    char balance_s[TEXTLEN];

    currency_string(balance_s, balance, TRUE);
    printf(" balance verification failed: %s!=", balance_s);
    currency_string(balance_s, up_balance, TRUE);
    printf("%s\n", balance_s);
    ok=FALSE;
   }

  if(number!=(dword)atol(up|"buchungsnummer"))
   {
    printf(" number verification failed: %lu!=%lu\n",
      number, (dword)atol(up|"buchungsnummer"));

    ok=FALSE;
   }

  if(ok) 
    printf("Ok\n");
  else if(fixit)
   {
    if(!up.lock())
     {
      up.set("buchungsnummer", number);
      up.set("konto", balance.amount);
      up.set("konto.scale", (int)balance.scale);
      up.write();
      up.unlock();
      printf(" FIXED\n");
     }
    else
      printf(" failed to fix it\n");
   }
  else
    printf(" not fixing it\n");
 }

void docheckkonto(bool fixit)
 {
  char username[TEXTLEN], *tptr;

  while(fgets(username, TEXTLEN-1, stdin)!=NULL)
    if(username[0]!=0 && username[0]!='.' && username[0]!='_')
     {
      tptr=strchr(username, '\r'); if(tptr!=NULL) *tptr=0;
      tptr=strchr(username, '\n'); if(tptr!=NULL) *tptr=0;

      username[TEXTLEN-1]=0;
      tptr=strrchr(username, '/');
      if(tptr!=NULL) *tptr=0;
      userpt up(username);
      if(up.read())
        fprintf(stderr, "Not found: %s\n", username);
      else
        docheckkonto(up, fixit);
     }
 }
