/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <account.h>
#include <charsettools.h>
#include "environ.h"

void dosetenv(const char *env, const char *text, charsett charset)
 {
  char tempstr[1000];

  if(charset!=IBM)
   {
    strmaxcpy(tempstr, text, 999);
    ibm2iso(tempstr, strlen(tempstr));
    setenv(env, tempstr, TRUE);
   }
  else
    setenv(env, text, TRUE);
 }

void setenviron(userpt &up, charsett charset)
 {
  bankpt bp(up.name);
  char tempstr[DIRLEN], anrede[TEXTLEN*2], anrede2[TEXTLEN*2];
  int i;

  bp.read();

  if((up|"nachname")[0]==0)
    up.set("anrede", 2);

  switch(atoi(up|"anrede"))
   {
   case 0:
    sprintf(anrede, "Sehr geehrter Herr %s", up|"nachname");
    sprintf(anrede2, "Herr %s", up|"nachname");
    break;

   case 1:
    sprintf(anrede, "Sehr geehrte Frau %s", up|"nachname");
    sprintf(anrede2, "Frau %s", up|"nachname");
    break;

   case 2:
    sprintf(anrede, "Sehr geehrte Damen und Herren");
    strcpy(anrede2, "");
    break;
   }

  dosetenv("dbox_username", up.name, charset);

  if(anrede[0]!=0)
    dosetenv("dbox_anrede", anrede, charset);

  getplaintextpassword(&up, tempstr);
  dosetenv("dbox_user_password", tempstr, charset);

  if((up|"firma")[0]==0)
   {
    sprintf(tempstr, "%s %s", up|"vorname", up|"nachname");
    anrede2[0]=0;
   }
  else
    strmaxcpy(tempstr, up|"firma", TEXTLEN-1);

  dosetenv("dbox_adresse1", tempstr, charset);

  if(anrede2[0]!=0)          
    dosetenv("dbox_adresse2", anrede2, charset);

  currency_string(tempstr, getbalance(&up), TRUE);
  dosetenv("dbox_kontostand", tempstr, charset);

  amountt rechnungsbetrag=getbalance(&up);
  rechnungsbetrag.amount*=-1;
  currency_string(tempstr, rechnungsbetrag, TRUE);
  dosetenv("dbox_rechnungsbetrag", tempstr, charset);

  for(i=0; i<up.size(); i++)
   {
    snprintf(tempstr, DIRLEN, "dbox_user_%s", up.data[i].id);
    dnstring(tempstr);
    char *tptr=tempstr;
    while(*tptr!=0) 
     {
      if(*tptr=='.') *tptr='_'; 
      tptr++; 
     }

    dosetenv(tempstr, up.data[i].data, charset);
   }

  for(i=0; i<bp.size(); i++)
   {
    snprintf(tempstr, DIRLEN, "dbox_bank_%s", bp.data[i].id);
    dnstring(tempstr);
    char *tptr=tempstr;
    while(*tptr!=0) 
     {
      if(*tptr=='.') *tptr='_'; 
      tptr++; 
     }

    dosetenv(tempstr, bp.data[i].data, charset);
   }

  dword abbuchungs_betrag=atol(bp|"abbuchungs_betrag");
  sprintf(tempstr, "%lu,%02lu", abbuchungs_betrag/100, abbuchungs_betrag%100);
  dosetenv("dbox_bank_abbuchungs_betrag", tempstr, charset);
 }

void unsetenviron(userpt &up)
 {
  int i;
  char tempstr[DIRLEN];
  bankpt bp(up.name);

  bp.read();

  unsetenv("dbox_username");

  unsetenv("dbox_anrede");

  for(i=0; i<up.size(); i++)
   {
    sprintf(tempstr, "dbox_user_%s", up.data[i].id);
    dnstring(tempstr);
    char *tptr=tempstr;
    while(*tptr!=0) 
     {
      if(*tptr=='.') *tptr='_'; 
      tptr++; 
     }

    unsetenv(tempstr);
   }

  for(i=0; i<bp.size(); i++)
   {
    snprintf(tempstr, DIRLEN, "dbox_bank_%s", bp.data[i].id);
    dnstring(tempstr);
    char *tptr=tempstr;
    while(*tptr!=0) 
     {
      if(*tptr=='.') *tptr='_'; 
      tptr++; 
     }

    unsetenv(tempstr);
   }

 }
