/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>

#include <dbox.h>
#include <config.h>
#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include "maps.h"
#include "mapslist.h"

static bool parseoptions(int argc, char **argv)
 {
  int i;
  char boxname[TEXTLEN]="";
  bool mapslist=FALSE;

  for(i=1; i<argc; i++)
   {
    if(argv[i][0]!='-') goto aufruf;

    switch(tolower(argv[i][1]))
     {
     case '?':
     case 'h':
      goto help;

     case 'b':
      strmaxcpy(boxname, argv[i]+2, TEXTLEN-1);
      break;

     case 'l':
      mapslist=TRUE;
      break;

     default:
      goto aufruf;
     }
   }

  if(config.read(boxname)) return TRUE;

  if(mapslist)
    domapslist();
  else
   {
     {
      char logfilename[DIRLEN];
      sprintf(logfilename, BOXLOGDIR "maps.log", config.boxdir);
      logf.setlogfile(logfilename);
     }

    cout << "Lese Permissions...\n";

    getpermissions();
    maps();
    freepermissions();
   }

  return FALSE;

 aufruf:
  cerr << "Falscher Aufruf!\n";

 help:
  cerr <<
    "\n"
    "* * MAPS - DBOX Module - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Aufruf:                      Aktion:\n"
    "\n"
    " maps [-?] [-h]               Hilfe ausgeben\n"
    " maps -l                      ZC-Brettliste aus active erzeugen\n"
    " maps                         Befehle verarbeiten\n"
    "\n"
    "Weitere Optionen:\n"
    //"  -i   IBM Zeichensatz\n"
    //"  -d   Debugging on\n"
    "\n";

  return TRUE;
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR)) return 1;

  parseoptions(argc, argv);

  return 0;
 }
