/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>

#include <stream.h>

void writestr(int fd, const char *str)
 {
  write(fd, str, strlen(str));
 }

static void sig(int arg)
 {
  exit(3);
 }

int main(int argc, char **argv)
 {
  if(argc==4)
   {
    #ifdef OS_UNIX
    FILE *fp;
    struct in_addr defaddr;
    int c;
    struct hostent *hp, def;
    struct sockaddr_in sn;
    int s;
    char *alist[1];

    signal(SIGALRM, sig);
    alarm(6);

    hp=gethostbyname(argv[2]);
    if(!hp)
     {
      if(!inet_aton(argv[2], &defaddr))
       {
	cerr << "unknown host: " << argv[2] << "\n";
	return 1;
       }

      def.h_name=argv[2];
      def.h_addr_list=alist;
      def.h_addr=(char *)&defaddr;
      def.h_length=sizeof(struct in_addr);
      def.h_addrtype=AF_INET;
      def.h_aliases=0;
      hp=&def;
     }

    memset(&sn, 0, sizeof(sn));
    sn.sin_family = hp->h_addrtype;

    if(hp->h_length>(int)sizeof(sn.sin_addr))
      hp->h_length = sizeof(sn.sin_addr);

    memcpy(&sn.sin_addr, hp->h_addr, hp->h_length);
    sn.sin_port=htons(atoi(argv[3]));

    if((s=socket(hp->h_addrtype, SOCK_STREAM, 0))<0)
      return 2;

    if(connect(s, (struct sockaddr *)&sn, sizeof(sn))<0) 
     {
      cerr << "Connect failed.\n";
      return 3;
     }

    writestr(s, "GET /nntp_permission_wildmat/");
    writestr(s, argv[1]);
    writestr(s, "\r\n");

    fp=fdopen(s, "r");

    if(!fp)
      return 4;

    while((c=getc(fp))!=EOF) putchar(c);
     
    fclose(fp);
    #else
    cerr << "not implemented\n";
    #endif
   }
  else
    cerr << "Usage: nnrpdgroup client-ip hostname port\n";

  return 0;
 }
