/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "onews.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("aex:lfs:t:s:n:q:") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="onews.log";
    logf.setlogfile(logfile);
   }

  if(cmdline.isset('a'))
    doeintragen();
  else if(cmdline.isset('e'))
    doexpire(&cmdline);
  else if(cmdline.isset('f'))
    doexpirepath("", &cmdline);
  else if(cmdline.isset('s'))
    dostore(cmdline.getval('s'));
  else if(cmdline.isset('x'))
    doexport(cmdline.getval('x'));
  else if(cmdline.isset('l'))
    dobrettliste();
  else
    doonews();

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * ONEWS - DBOX Module for Folder Management - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " onews [-?] [-h]              show help\n"
    " onews -a                     add message boards (stdin)\n"
    " onews -e <expire options>    expire message boards (stdin)\n"
    " onews -x Puffer              export messages in message boards (stdin)\n"
    " onews -l                     generate message board list\n"
    " onews -f <expire options>    expire current directory\n"
    " onews -s file                store messages in file in current directory\n"
    " onews                        spool messages in boards\n"
    "\n"
    "Additonal options:\n"
    "\n"
    "Expire options:\n"
    "  -t +Maxdays-Mindays         number of days to keep message\n"
    "  -s +Maxsize-Minsize         size in kbytes\n"
    "  -n +Maxnumber-Minnumber     total number of messages to keep\n"
    "  -q +Maxsize-Minsize         total disk quota in kbytes\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
