/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <dbox.h>
#include "online.h"
#include "help.h"
#include "internet.h"
#include "archie.h"

class doarchiet:public simpleinternett
 {
 public:
  virtual void docall();
  virtual bool checkarg();
  void doarchie(const char *a);
 };

void doarchiet::docall()
 {
  if(config.archieserver[0]==0)
    execlp("archie", "archie", arg, NULL);
  else
    execlp("archie", "archie", "-h", config.archieserver, "-m20", arg, NULL);
 }

bool doarchiet::checkarg()
 {
  char *tptr;

  if(arg[0]==0) return TRUE;
  tptr=arg;

  while(*tptr!=0)
   {
    if((*tptr!='.' && *tptr!='-' && *tptr!='_' &&
       !isalpha(*tptr) && !isdigit(*tptr)) ||
       (*tptr<0)) *tptr='-';
    tptr++;
   }

  tptr=arg;
  while(*tptr=='-') *(tptr++)='.';
  return FALSE;
 } 

void doarchiet::doarchie(const char *a)
 {
  prompt="Datei:";
  strcpy(helpurl, "internet/archie");
  name="archie";

  if(a==NULL) 
    arg[0]=0;
  else
    strmaxcpy(arg, a, TEXTLEN-1);

  doit();
 }

void dointernet_archie()
 {
  doarchiet doarchie;
  doarchie.doarchie(NULL);
 }
