/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dirent.h>
#include <time.h>

#include <dbox.h>
#include <logf.h>
#include "online.h"
#include "help.h"
#include "menu.h"
#include "openconfig.h"

bool checkuser(const char *username, char *errormsg)
 {
  FILE *infile;
  char kennung[500]="", text[500];

  infile=openconfigfile(status, "username");
  if(infile==NULL) return FALSE;

  if(checkusername(username))
   {
    strmaxcpy(errormsg, "Username enthlt ungltige Zeichen!", TEXTLEN-1);
    return TRUE;
   }

  errormsg[0]=0;

 schleife:
  switch(readconfigline(infile, kennung, text, 499))
   {
   case 0:
    if(stricmp(kennung, "permit")==0 || stricmp(kennung, "deny")==0)
     {
      if(checkjoker(text, username, TRUE))
       {
        fclose(infile);
        return stricmp(kennung, "deny")==0;
       }
     }
    else if(stricmp(kennung, "errormsg")==0)
     {
      strmaxcpy(errormsg, text, TEXTLEN-1);
     }
    else
     {
      logf.printf("checkuser",
        "Unbekannter Eintrag \"%s\" in der username-Datei",
        kennung);
      break;
     }
    goto schleife;

   case 1:
    break;

   default:
    logf.printf("checkuser", "Fehler in der username-Datei");
   }

  fclose(infile);

  return FALSE;
 }
