/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <libdbox.h>
//#include <nls.h>
//#include <netdb.h>
//#include <dboxpath.h>
//#include <logf.h>
//#include <portinfo.h>
//#include <oldtools.h>
//#include <account.h>
//#include "device.h"
//#include "online.h"
//#include "extern.h"
#include "gen_from.h"

void gen_abs(status_baset &status, 
  const char *username, char *abs, char *org,
  bool add_realname)
 {
  char tempstr[TEXTLEN*2], absneu[TEXTLEN*4];

  snprintf(absneu, TEXTLEN*2, "%s@", username);

  status.userprofile.get("abs_host", tempstr);

  if(tempstr[0]!=0)
    strcat(absneu, tempstr);
  else if((status.gruppe|"abs_host")[0]!=0)
    strcat(absneu, status.gruppe|"abs_host");
  else if(config.abs_host[0]!=0)
    strcat(absneu, config.abs_host);
  else
    sprintf(absneu+strlen(absneu), "%s.%s", 
      config.boxname, config.domain);

  if(add_realname)
   {
    if((status.userprofile|"vorname")[0]!=0)
     {
      strcpy(tempstr, status.userprofile|"vorname");

      if((status.userprofile|"nachname")[0]!=0)
        sprintf(tempstr+strlen(tempstr), " %s", 
          status.userprofile|"nachname");
     }
    else
      strcpy(tempstr, status.userprofile|"nachname");

    if(tempstr[0]!=0)
      sprintf(absneu+strlen(absneu), " (%s)", tempstr);
   }

  strmaxcpy(abs, absneu, TEXTLEN-1);

  if((status.userprofile|"firma")[0]!=0)
    strmaxcpy(org, status.userprofile|"firma", TEXTLEN-1);
  else
    strmaxcpy(org, config.organization, TEXTLEN-1);
 }

void gen_from(status_baset &status,
  const string &username, string &from, string &org,
  bool add_realname)
 {
  char _from[TEXTLEN], _org[TEXTLEN];
  gen_abs(status, username.c_str(), _from, _org, add_realname);
  from=_from;
  org=_org;
 }
