/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <errno.h>
#include <netdb.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#include <logf.h>
#include <dboxpath.h>
#include <oldui.h>
#include <oldtools.h>
#include "online.h"
#include "help.h"
#include "internet.h"

static bool exited;

static void sig(int arg)
 {
  exited=TRUE;
 }

bool simpleinternett::reallyabort()
 {
  met mes[3];

  online.setattr(3, FALSE);
  online.box(20, 10, 60, 16, BOXFRAMEDBL, NULL, TRUE);

  online.setcursor(29, 12);
  online.printf("Wirklich abbrechen?");

  mes[0].type=met::COMMANDBUTTON;
  mes[0].x=26;
  mes[0].y=14;
  mes[0].key=Key_C_Ent;
  mes[0].sizex=6;
  mes[0].text="^Ja";

  mes[1].type=met::COMMANDBUTTON;
  mes[1].x=43;
  mes[1].y=14;
  mes[1].key=0;
  mes[1].sizex=6;
  mes[1].text="^Nein";

  mes[2].type=met::END_OF_LIST;

  return domenu(&online, mes, 0, TRUE)==0;
 }

void simpleinternett::doit2()
 {
  pid_t pid;
  int handle;
  byte counter=0;
  bool boxdrawed=FALSE;
  char chars[]="|/-\\";
  bool aborted=FALSE;

  exited=FALSE;
  handle=open(filename, O_TRUNC|O_CREAT|O_WRONLY|O_BINARY, S_IREAD|S_IWRITE);
  if(handle<0) return;

  signal(SIGCHLD, sig);

  pid=fork();
  if(pid<0) return;
  if(pid==0)
   {
    dup2(handle, 1);
    dup2(handle, 2);

    if(html)
     {
     }
    else
     {
      printf("~%s %s~\n\n", name, arg);
      fflush(stdout);
     }
    docall();
    exit(1);
   }

  while(!exited && !aborted && !status.dologout)
   {
    switch(online.doreadkey())
     {
     case 0xffff:
      aborted=TRUE;
      break;

     case Key_Esc:
      if(reallyabort())
        aborted=TRUE;

      if(!status.dologout) drawbox();
     }

    if(!aborted && !status.dologout)
     {
      if(!boxdrawed)
       {
        drawbox();
        boxdrawed=TRUE;
       }
      online.setcursor(40, 15);
      online.setattr(2, FALSE);
      online.printf("%c", chars[counter++]);
      asyncio.flush_output();
      if(chars[counter]==0) counter=0;
     }
   }

  if(!exited)
   {
    kill(pid, 15);
    if(html)
     {
     }
    else
     {
      char text[]="\n\n~Abgebrochen!~\n";
      write(handle, text, strlen(text));
     }
   }

  int status;
  sleep(1);
  waitpid(pid, &status, WNOHANG);

  close(handle);

  signal(SIGCHLD, SIG_IGN);
 }

void simpleinternett::doview()
 {
  FILE *infile;
  char title[TEXTLEN];

  infile=fopen(filename, "rb");
  if(infile!=NULL)
   {
    snprintf(title, TEXTLEN, "Internet Online - %s", name);
    viewtextfile(&online, infile, title, IBM, TRUE);
    fclose(infile);
   }
 }

void simpleinternett::drawbox()
 {
  char title[TEXTLEN];
  online.setattr(2, FALSE);
  snprintf(title, TEXTLEN, "Internet - %s", name);
  online.box(20, 10, 60, 16, BOXFRAMEDBL, title, TRUE);
  snprintf(title, TEXTLEN, "%s luft - drcken Sie die", name);
  online.setcursor(40-strlen(title)/2, 12); online.printf("%s", title);
  online.setcursor(28, 13); online.printf("Taste ESC um abzubrechen");
  online.setattr(1, FALSE);
 }

void simpleinternett::doit3()
 {
  /* drawbox(); */

  doit2();

  if(status.dologout)
   {
    remove(filename);
    return;
   }

  doview();
 }

void simpleinternett::doit()
 {
  snprintf(filename, DIRLEN, DBOXPORTTEMPDIR "%s",
    config.dboxdir, config.port, name);

  if(arg[0]!=0) 
    doit3();
  else
    while(!getarg())
      doit3();
 }

bool simpleinternett::getarg()
 {
  met mes[4];
  char title[TEXTLEN];

  if(status.dologout) return TRUE;

 startover:
  online.setattr(2, FALSE);
  snprintf(title, TEXTLEN, "Internet - %s", name);
  online.box(20, 10, 60, 16, BOXFRAMEDBL, title, TRUE);

  online.setcursor(22, 12);
  online.printf(prompt);

  mes[0].type=met::EDIT;
  mes[0].key=0;
  mes[0].x=22+strlen(prompt)+1;
  mes[0].y=12;
  mes[0].sizex=60-mes[0].x-3;
  mes[0].maxlen=60;
  mes[0].text=arg;

  mes[1].type=met::COMMANDBUTTON;
  mes[1].x=26;
  mes[1].y=14;
  mes[1].key=Key_C_Ent;
  mes[1].sizex=6;
  mes[1].text="O^k";

  mes[2].type=met::COMMANDBUTTON;
  mes[2].x=43;
  mes[2].y=14;
  mes[2].key=0;
  mes[2].sizex=9;
  mes[2].text="^Abbruch";

  mes[3].type=met::END_OF_LIST;

 schleife:
  switch(domenu(&online, mes, 0, TRUE))
   {
   case 1:
    if(checkarg()) goto schleife;
    if(status.dologout) break;
    return FALSE;

   case MENU_HELP:
    displayhelp(helpurl);
    online.clrscr();
    if(status.dologout) break;
    goto startover;
   }

  return TRUE;
 }

