#ifndef DBOX_ONLINE_H

#define DBOX_ONLINE_H

#include <oldterm.h>
#include <keys.h>
#include "ostatus.h"

void drawframe(const char *title);
void drawstatusbar();

class onlinet:public screent
 {
 public:
  consolet console;
  comportt comport;

  virtual int printf(const char *format, ...);

  virtual void putch(char ch)
   {
    console.putch(ch);
    if(status.online2) comport.putch(ch);
   }

  virtual word readkey();
  virtual word doreadkey();
  virtual bool readchar(char *ch);
  virtual void waitkey();

  virtual void flushkeys();
  
  virtual void clrscr()
   {
    console.clrscr();
    if(status.online2) comport.clrscr();
   }

  virtual void setattr(byte type, bool marked)
   {
    console.setattr(type, marked);
    if(status.online2) comport.setattr(type, marked);
   }

  virtual void setcolor(byte v, byte h)
   {
    console.setcolor(v, h);
    if(status.online2) comport.setcolor(v, h);
   }

  virtual void setcursor(byte x, byte y)
   {
    console.setcursor(x, y);
    if(status.online2) comport.setcursor(x, y);
   }

  virtual void setcursorx(byte x)
   {
    console.setcursorx(x);
    if(status.online2) comport.setcursorx(x);
   }

  virtual void movecursor(signed char x, signed char y)
   {
    console.movecursor(x, y);
    if(status.online2) comport.movecursor(x, y);
   }

  virtual void deleteline()
   {
    console.deleteline();
    if(status.online2) comport.deleteline();
   }

  virtual void insertline()
   {
    console.insertline();
    if(status.online2) comport.insertline();
   }

  virtual void cleareol()
   {
    console.cleareol();
    if(status.online2) comport.cleareol();
   }
   
  virtual bool open();
  
  virtual void set_app_out_charset(charsett charset)
   {
    console.set_app_out_charset(charset);
    if(status.online2) comport.set_app_out_charset(charset);
    screent::set_app_out_charset(charset);
   }
   
  virtual void set_hw_charset(charsett charset)
   { 
    if(status.online2)
      comport.set_hw_charset(charset);
    else
      console.set_hw_charset(charset);
      
    screent::set_hw_charset(charset);
   }
   
  virtual void set_usecolor(bool new_usecolor)
   {
    console.set_usecolor(new_usecolor);
    if(status.online2) comport.set_usecolor(new_usecolor);
    screent::set_usecolor(new_usecolor);
   }
   
  virtual void set_screensize(int new_sizex, int new_sizey)
   {
    if(new_sizex>200) new_sizex=200;
    if(new_sizey>100) new_sizey=100;
   
    if(status.online2)
      comport.set_screensize(new_sizex, new_sizey);
    else
      console.set_screensize(new_sizex, new_sizey);
      
    screent::set_screensize(new_sizex, new_sizey);
   }
 };

extern class onlinet online;

void printtimeout();
void printkonto();
void doofflinelogin();

bool startport();
void dologin();

#endif
