/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dirent.h>
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>

#include <dbox.h>
#include <nls.h>
#include <oldui.h>
#include <charsettools.h>
#include <oldtools.h>
#include "online.h"
#include "help.h"
#include "extern.h"
#include "vfolder.h"
#include "readmail.h"
#include "editor.h"
#include "wmail.h"
#include "readnews.h"
#include "readfolder.h"

void readfoldert::readindex()
 {
 }

void readfoldert::freeindex()
 {
  if(marked!=NULL) free(marked);
  marked=NULL;
 }

void readfoldert::draw(bool complete)
 {
  if(mail)
   {
    snprintf(title, TEXTLEN, " Postfach von %s - %ld %s - ? fr Hilfe ",
      folder, anz, anz==1?"Nachricht":"Nachrichten");
   }
  else
   {
    snprintf(title, TEXTLEN, " %s - %ld %s - ? fr Hilfe ", 
      folder, anz, anz==1?"Nachricht":"Nachrichten");
   }

  title[79]=0;
  viewfoldert::draw(complete);
 }

void readfoldert::read()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::view()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::info()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::help()
 {
  displayhelp(mail?"mail":"news");
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::mark()
 {
  if(pos<anz)
   {
    marked[pos]^=1;
    if(pos==(anz-1)) displayline(pos); else key(Key_Dwn);
   }
 }

void readfoldert::unmarkall()
 {
  dword i;
  for(i=0; i<anz; i++) marked[i]=FALSE;
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::extract()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::del()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::del_marked()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::key(word k)
 {
  switch(k)
   {
   case Key_Lft:
    if(!mail)
      ende=TRUE;
    return;

   case Key_Rgt:
    read();
    return;
   }

  bool isup=(isupper(lo(k))!=0);

  switch(tolower(lo(k)))
   {
   case 'd':
    if(isup)
     {
      infobox(&online, nls["online.notavailable"]);
      if(!status.dologout) draw(TRUE);
     }
    else
      dodownload();
    break;

   case 'p':
    if(unzustellbar) break;
    reply(FALSE, FALSE, isup);
    break;

   case 'b':
    if(unzustellbar || mail) break;
    reply(FALSE, TRUE, isup);
    break;

   case 'y':
    if(unzustellbar || mail || isup) break;
    fileinclude();
    break;

   case 'l':
    if(isup)
      del_marked();
    else
      del();
    break;

   case Key_C_P:
    if(unzustellbar) break;
    reply(TRUE, FALSE, FALSE);
    break;

   case Key_C_B:
    if(unzustellbar) break;
    if(mail) break;
    reply(TRUE, TRUE, FALSE);
    break;

   case 'w':
    doweiterleiten();
    break;

   case 'z':
    if(!unzustellbar) break;
    dozurueckschicken();
    break;

   case 'e':
    if(unzustellbar) break;

    if(isup)
     {
      infobox(&online, nls["online.notavailable"]);
      if(!status.dologout) draw(TRUE);
     }
    else
      doedit();
    break;

   case 's':
    if(unzustellbar || isup) break;
    send();
    break;

   case 'f':
    if(unzustellbar || isup) break;
    search();
    break;

   default:
    viewfoldert::key(k);
   }
 }

void readfoldert::search()
 {
  met mes[10];  
  int i;
  char abs[TEXTLEN]="", bet[TEXTLEN]="", 
       eda[TEXTLEN]="", stichwort[TEXTLEN]="";

 startover:
  online.setattr(2, FALSE);
  online.box(10, 8, 70, 19, BOXFRAMEDBL, "Nachricht suchen", TRUE);

  online.setcursor(23, 10);
  online.printf("Absender:");
  online.setcursor(24, 11);
  online.printf("Betreff:");
  online.setcursor(26, 12);
  online.printf("Datum:");
  online.setcursor(21, 13);
  online.printf("Stichworte:");

  mes[0].type=met::EDIT;
  mes[0].key=0;
  mes[0].x=33;
  mes[0].y=10;
  mes[0].sizex=24;
  mes[0].maxlen=TEXTLEN-1;
  mes[0].text=abs;

  mes[1].type=met::EDIT;
  mes[1].key=0;
  mes[1].x=33;
  mes[1].y=11;
  mes[1].sizex=24;
  mes[1].maxlen=TEXTLEN-1;
  mes[1].text=bet;

  mes[2].type=met::EDIT;
  mes[2].key=0;
  mes[2].x=33;
  mes[2].y=12;
  mes[2].sizex=24;
  mes[2].maxlen=TEXTLEN-1;
  mes[2].text=eda;

  mes[3].type=met::EDIT;
  mes[3].key=0;
  mes[3].x=33;
  mes[3].y=13;
  mes[3].sizex=24;
  mes[3].maxlen=TEXTLEN-1;
  mes[3].text=stichwort;

  mes[4].type=met::IGNORE;

  mes[5].type=met::COMMANDBUTTON;
  mes[5].x=26;
  mes[5].y=17;
  mes[5].key=Key_C_Ent;
  mes[5].sizex=6;
  mes[5].text="O^k";

  mes[6].type=met::COMMANDBUTTON;
  mes[6].x=43;
  mes[6].y=17;
  mes[6].key=0;
  mes[6].sizex=9;
  mes[6].text="^Abbruch";

  mes[7].type=met::END_OF_LIST;
 
  i=0;  

  switch(domenu(&online, mes, i, TRUE))
   {    
   case 5:
    break;
  
   case MENU_HELP:
    displayhelp("search.html");
    online.clrscr();
    if(status.dologout) break;
    goto startover;
   }

  if(!status.dologout) draw(TRUE);
 }

void readfoldert::send()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::reply(bool quote, bool followup, bool quoteall)
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::fileinclude()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::dodownload()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::dodownload_marked()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::doedit()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::doweiterleiten()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::dozurueckschicken()
 {
  infobox(&online, nls["online.notavailable"]);
  if(!status.dologout) draw(TRUE);
 }

void readfoldert::formattext(FILE *infile, FILE *outfile, 
  dword laenge, bool quote, bool html, bool iso2ibm)
 {
  dword buffersize, bytestocopy, bytestocopy2, i;
  char *buffer;
 
  buffersize=64000l;
  if((buffer=(char *)malloc(buffersize))==NULL) return;
  bytestocopy=laenge;

  if(quote && bytestocopy!=0) fprintf(outfile, "> ");

  while(bytestocopy!=0)
   {
    bytestocopy2=bytestocopy>buffersize?buffersize:bytestocopy;
    fread(buffer, 1, bytestocopy2, infile);

    if(iso2ibm) ::iso2ibm(buffer, bytestocopy2);

    for(i=0; i<bytestocopy2; i++)
     {
      char data;

      data=buffer[i];
      switch(data)
       {
       case '&': fprintf(outfile, html?"&amp;":"&"); break;
       case '>': fprintf(outfile, html?"&gt;":">");  break;
       case '<': fprintf(outfile, html?"&lt;":"<");  break;

       case '\n':
        fwrite(&data, 1, 1, outfile);
        if(quote && bytestocopy>(i+1)) fprintf(outfile, "> ");
        break;

       default:
        fwrite(&data, 1, 1, outfile);
       }
     }

    bytestocopy-=bytestocopy2;
   }
  free(buffer);
 }

