/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dirent.h>
#include <time.h>

#include <portinfo.h>
#include <keys.h>
#include "selport.h"

void drawports(screent *screen, byte starty, byte page)
 {
  char tempstr[TEXTLEN];
  word port, port2;
  int i;

  for(port2=0; port2<32; port2++)
   {
    port=port2+page*32;
    screen->setcursor(port2%4*18+6, port2/4+starty);
    screen->printf("%2u: ", port);
    
    if(port<MAXPORTS)
     {
      portinfo.read(port);

      portinfo.getstatusstring(tempstr);
      tempstr[12]=0;

      screen->printf(tempstr);

      for(i=12-strlen(tempstr); i>0; i--)
        #ifdef DEBUG
        screen->putch('');
        #else
        screen->putch(' ');
        #endif
     }
   }
 }

word selectport(screent *screen, byte starty, word startval)
 {
  byte x, y, i, oldx, oldy;
  word result;
  bool ende=FALSE;
  byte page;

  page=startval/32;
  x=(startval%32)%4;
  y=(startval%32)/4;

  do
   {
    result=x+y*4+page*32;
    screen->setattr(10, FALSE);
    screen->setcursor(x*18+5, y+starty);
    screen->printf(">%2u:<", result);
    screen->setattr(1, FALSE);
    for(i=0; i<4; i++) screen->putch(8);

    oldx=x;
    oldy=y;

   schleife:
    switch(screen->doreadkey())
     {
     case 0xffff:
      return 0xffff;

     case Key_Esc:
     case Key_C_X:
     case Key_C_C:
      result=0xffff;
      ende=TRUE;
      break;

     case Key_Up:
      if(y==0) goto schleife;
      y--;
      break;

     case Key_Dwn:
      if(y==7) goto schleife;
      y++;
      break;

     case Key_Lft:
      if(x==0) goto schleife;
      x--;
      break;

     case Key_Rgt:
      if(x==3) goto schleife;
      x++;
      break;

     case Key_Home:
      if(x==0 && y==0) goto schleife;
      x=y=0;
      break;

     case Key_PgUp:
      if(y==0) goto schleife;
      y=0;
      break;

     case Key_PgDn:
      if(y==7) goto schleife;
      y=7;
      break;

     case Key_End:
      if(x==3 && y==7) goto schleife;
      y=7; x=3;
      break;

     case Key_Ent:
      ende=TRUE;
      break;

     case Key_F1:
     case 'h':
     case 'H':
     case '?':
      // Hilfe ......
      goto schleife;

     default:
      goto schleife;
     }

    screen->setcursor(oldx*18+5, oldy+starty);
    screen->printf(" %2u: ", oldx+oldy*4);
    screen->setattr(1, FALSE);
   }
  while(!ende);

  return result;
 }
