/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>

#include <dbox.h>
#include <oldui.h>
#include <oldtools.h>
#include "online.h"
#include "verw.h"
#include "selport.h"
#include "settings.h"
#include "help.h"
#include "verw.h"
#include "fibu.h"

void dosettings(const char *args)
 {
  if(args==NULL)
    return; //dosettings_general();
  else
   {
    if(stricmp(args, "VIEW")==0 || stricmp(args, "SCREEN")==0)
      return; // dosettings_view();
    else if(stricmp(args, "POINT")==0)
      return; // dosettings_point();
    else if(stricmp(args, "FIBU")==0 || stricmp(args, "CASH")==0)
      dofibu(NULL);
    else
      return;
      //dosettings_general();
   }
 }

static void dogastsettings1()
 {
  byte y, anz;
  met mes[20];
  int i;

  drawframe("Terminaleinstellungen - Zeichensatz");
  if(status.dologout) return;

  y=6;

   {
    char text[]="Bitte whlen Sie einen Zeichensatz:";
    online.setcursor(40-strlen(text)/2, y);
    online.printf("%s", text),
    y+=2;
   }

  anz=0;
  while(long_charsets[anz]!=NULL)
   {
    mes[anz].type=met::COMMANDBUTTON;
    mes[anz].x=15;
    mes[anz].y=y;
    mes[anz].key=0;
    mes[anz].sizex=50;
    mes[anz].text=long_charsets[anz];
    y+=2;
    anz++;
   }

  mes[anz].type=met::END_OF_LIST;

 schleife:
  switch(i=domenu(&online, mes, 0, TRUE))
   {
   case MENU_HELP:
    goto schleife;

   default:
    if(i>=0 && i<anz)
     {
      char tempstr[TEXTLEN];

      online.set_hw_charset((charsett)i);
      snprintf(tempstr, TEXTLEN, "%d", i);
      status.userprofile.set("charset", tempstr);

      char text[TEXTLEN];
      snprintf(text, TEXTLEN, "Zeichensatz %s eingestellt", charsets[i]);
      if(!status.dologout)
        infobox(&online, text);
     }
   }
 }

static void dogastsettings2()
 {
  byte y;
  met mes[20];
  int i;

  drawframe("Terminaleinstellungen - Farbe");
  if(status.dologout) return;

  y=6;

   {
    char text[]="Wnschen Sie Farbe?";
    online.setcursor(40-strlen(text)/2, y);
    online.printf("%s", text),
    y+=2;
   }

  mes[0].type=met::COMMANDBUTTON;
  mes[0].x=15;
  mes[0].y=y;
  mes[0].key=0;
  mes[0].sizex=50;
  mes[0].text="^Nein, bitte keine Farben verwenden";
  y+=2;

  mes[1].type=met::COMMANDBUTTON;
  mes[1].x=15;
  mes[1].y=y;
  mes[1].key=0;
  mes[1].sizex=50;
  mes[1].text="^Ja, bitte Farben verwenden";
  y+=2;

  mes[2].type=met::END_OF_LIST;

 schleife:
  switch(i=domenu(&online, mes, 0, TRUE))
   {
   case MENU_HELP:
    goto schleife;

   default:
    if(i==0 || i==1)
     {
      char tempstr[TEXTLEN];

      snprintf(tempstr, TEXTLEN, "%d", i);
      status.userprofile.set("usecolor", tempstr);
      online.set_usecolor(i);

      char text[TEXTLEN];
      snprintf(text, TEXTLEN, "Farben %sgeschaltet", i?"ein":"aus");
      if(!status.dologout)
        infobox(&online, text);
     }
   }
 }

void dogastsettings()
 {
  if(!status.dologout)
    dogastsettings1();

  if(!status.dologout)
    dogastsettings2();
 }
