/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <dbox.h>
#include "online.h"
#include "help.h"
#include "internet.h"
#include "trace.h"

class dotracet:public simpleinternett
 {
 public:
  virtual void docall();
  virtual bool checkarg();
  void dotrace(const char *a);
 };

void dotracet::docall()
 {
  execlp("traceroute", "traceroute", arg, NULL);
 }

bool dotracet::checkarg()
 {
  char *tptr;

  if(arg[0]==0) return TRUE;

  tptr=arg;
  while(*tptr!=0)
   {
    if((*tptr!='.' && *tptr!='-' && !isalpha(*tptr) && !isdigit(*tptr)) || 
       (*tptr<0)) *tptr='-';
    tptr++;
   }

  tptr=arg;
  while(*tptr=='-') *(tptr++)='.';
  return FALSE;
 } 

void dotracet::dotrace(const char *a)
 {
  prompt="Host:";
  strmaxcpy(helpurl, "internet/traceroute", TEXTLEN-1);
  name="traceroute";

  if(a==NULL)
    arg[0]=0;
  else
    strmaxcpy(arg, a, TEXTLEN-1);

  doit();
 }

void dointernet_traceroute(const char *adresse)
 {
  dotracet dotrace;
  dotrace.dotrace(adresse);
 }
