/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <dboxpath.h>
#include <logf.h>
#include "userlog.h"

int userlogprintf1(status_baset &status, 
  const char *module, const char *format, ...)
 {
  FILE *logfile;

  if((logfile=fopen(status.userlogfile, "at"))==NULL)
   {
    logf.printf("userlogprintf1",
      "FATAL: failed to open logfile \"%s\"",
      status.userlogfile);
    return 0;
   }

  va_list arglist;
  logf.timefprintf(logfile);
  fprintf(logfile, "%u: %s: ", config.port, module);
  va_start(arglist, format);
  vfprintf(logfile, format, arglist);

   {
    char tempstr[1000];
    vsnprintf(tempstr, 1000, format, arglist);
    logf.printf(module, "%s: %s", status.username, tempstr);
   }

  va_end(arglist);
  fprintf(logfile, "\n");

  fclose(logfile);
  return 1;
 }

int userlogprintf2(status_baset &status,
                   const char *username, const char *module,
                   const char *format, ...)
 {
  FILE *logfile;
  char tempstr[DIRLEN];

  snprintf(tempstr, DIRLEN, BOXUSERDIR "logfile", config.boxdir, username);

  if((logfile=fopen(tempstr, "at"))==NULL)
   {
    logf.printf("userlogprintf2",
      "FATAL: failed to open logfile \"%s\"",
      tempstr);
    return 0;
   }

  va_list arglist;
  logf.timefprintf(logfile);
  fprintf(logfile, "%u: %s: ", config.port, module);
  va_start(arglist, format);
  vfprintf(logfile, format, arglist);

   {
    char tempstr[1000];
    vsnprintf(tempstr, 1000, format, arglist);
    logf.printf(module, "%s: %s", username, tempstr);
   }

  va_end(arglist);
  fprintf(logfile, "\n");

  fclose(logfile);
  return 1;
 }

