/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dirent.h>
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>

#include <dboxpath.h>
#include <nls.h>
#include <folder.h>
#include <oldui.h>
#include <mtoolzc.h>
#include <sfolderzc.h>
#include <logf.h>
#include <tools.h>
#include <zconnect.h>
#include <oldtools.h>
#include <messageid.h>
#include "online.h"
#include "gen_from.h"
#include "help.h"
#include "folder.h"
#include "wmail.h"
#include "editor.h"

static void dospoolnews(const char *filename)
 {
  FILE *infile;
  zcmessaget m;
  char *puffer;
  dword len;

  infile=fopen(filename, "rb");
  if(infile==NULL) return;

  len=filelength(fileno(infile));

  puffer=(char *)malloc(len);
  if(puffer==NULL) { free(infile); return; }

  fread(puffer, 1, len, infile);

  m.data=puffer;
  m.endoffile=puffer+len;

  if(!m.parse())
   {
    const char *dataptr, *inhalt, *tptr;
    char tempstr[1000];

    dataptr=m.data;
    while(!m.findheader(&dataptr, "EMP", &inhalt))
     {
      m.copyheadertext(tempstr, inhalt, 999);
      dnstring(tempstr);
      tptr=strchr(tempstr, '@');
      if(tptr==NULL)
       {
        folderpt fp(tempstr);

        if(!fp.read())
          spoolinfolder(m, tempstr, atoi(fp|"forceextern"), NULL);
       }
     }
   }

  free(puffer);

  fclose(infile);
 }

void dowritemail(const char *e, const char *b, const char *bez,
                 FILE *quotefile)
 {
  char bet[TEXTLEN]="", emp[TEXTLEN]="", tempstr[DIRLEN];
  met mes[10];
  FILE *infile, *outfile;
  bool news=FALSE;
  char antwort_an[TEXTLEN]="", diskussion_in[TEXTLEN]="",
       zusammenfassung[TEXTLEN]="";
  bool eb=FALSE;
  int i;

  if(e==NULL || e[0]==0)
   {
   }
  else
   {
    strmaxcpy(emp, e, TEXTLEN-1);
    if(strchr(emp, '@')==NULL) 
     {
      if(emp[0]=='/')
       {
        news=TRUE;
        upstring(emp);
       }
      else
       {
        emp[40]=0;
        snprintf(emp+strlen(emp), TEXTLEN-strlen(emp),
          "@%s.%s", config.boxname, config.domain);
       }
     }
   }

  if(b!=NULL)
    strmaxcpy(bet, b, TEXTLEN-1);

 startover:
  online.setattr(2, FALSE);
  online.box(10, 10, 70, 18, BOXFRAMEDBL, "Internet - EMAIL", TRUE);

  online.setcursor(12, 12);
  online.printf("Empfnger:");
  online.setcursor(14, 14);
  online.printf("Betreff:");

  if(e==NULL || e[0]==0)
   {
    mes[0].type=met::EDIT;
    mes[0].key=0;
    mes[0].x=23;
    mes[0].y=12;
    mes[0].sizex=44;
    mes[0].maxlen=60;
    mes[0].text=emp;
   }
  else
   {
    mes[0].type=met::IGNORE;
    strmaxcpy(tempstr, emp, 44);
    online.setattr(2, TRUE);
    online.setcursor(23, 12);
    online.printf("%s", tempstr);
    online.setattr(2, FALSE);
   }

  mes[1].type=met::EDIT;
  mes[1].key=0;
  mes[1].x=23;
  mes[1].y=14;
  mes[1].sizex=44;
  mes[1].maxlen=TEXTLEN-1;
  mes[1].text=bet;

  mes[2].type=met::COMMANDBUTTON;
  mes[2].x=22;
  mes[2].y=16;
  mes[2].key=Key_C_Ent;
  mes[2].sizex=6;
  mes[2].text="O^k";

  mes[3].type=met::COMMANDBUTTON;
  mes[3].x=31;
  mes[3].y=16;
  mes[3].key=0;
  mes[3].sizex=9;
  mes[3].text="^Abbruch";

  mes[4].type=met::COMMANDBUTTON;
  mes[4].x=43;
  mes[4].y=16;
  mes[4].key=0;
  mes[4].sizex=14;
  mes[4].text="^Fileupload";

  mes[5].type=met::END_OF_LIST;

  switch(domenu(&online, mes, emp[0]==0?0:1, TRUE))
   {
   case 2:
    char filename[DIRLEN], title[TEXTLEN*2];
 
    if(strchr(emp, '@')==NULL && emp[0]!='/' && !news)
     {
      emp[40]=0;
      snprintf(emp+strlen(emp), TEXTLEN-strlen(emp),
        "@%s.%s", config.boxname, config.domain);
     }
    else if(emp[0]=='/')
      news=TRUE;

    snprintf(filename, DIRLEN, DBOXPORTTEMPDIR "mail.tmp", 
      config.dboxdir, config.port);

    outfile=fopen(filename, "wb");
    if(outfile==NULL) break;

    if(quotefile!=NULL)
      filecopy(quotefile, outfile, filelength(fileno(quotefile)));

    snprintf(tempstr, TEXTLEN*2, BOXUSERDIR "sig", 
      config.boxdir, status.username);

    infile=fopen(tempstr, "rb");
    if(infile!=NULL)
     {
      fprintf(outfile, "\r\n");
      filecopy(infile, outfile, filelength(fileno(infile)));
      fclose(infile);
     }

    fclose(outfile);

    snprintf(title, TEXTLEN, "Nachricht an %s", emp);
    title[79]=0;
    if(doedit(filename, title))
     {
      if(status.dologout) break;
      infobox(&online, "Nachricht nicht abgeschickt.");
     }
    else
     {
      if(status.dologout) break;

      snprintf(title, TEXTLEN, "%s wirklich absenden?", 
        news?"Artikel":"Mail");

      online.setattr(2, FALSE);
      online.box(10, 8, 70, news?19:19, BOXFRAMEDBL, title, TRUE);

      online.setcursor(22, 10);
      online.printf("Empfnger:");
      online.setcursor(24, 12);
      online.printf("Betreff:");

      online.setcursor(16, 13);
      online.printf("Zusammenfassung:");
      online.setcursor(21, 14);
      online.printf("Antwort an:");

      if(news)
       {
        online.setcursor(18, 15);
        online.printf("Diskussion in:");
       }
      else
       {
        online.setcursor(12, 15);
        online.printf("Empfangsbesttigung:");
       } 

       {
        char tempstr[TEXTLEN];
        strmaxcpy(tempstr, emp, 26);
        online.setcursor(33, 10);
        online.setattr(2, TRUE);
        online.printf("%s", tempstr);
        online.setattr(2, FALSE);
       }
 
      mes[0].type=met::EDIT;
      mes[0].key=0;
      mes[0].x=33;
      mes[0].y=12;
      mes[0].sizex=24;
      mes[0].maxlen=60;
      mes[0].text=bet;

      mes[1].type=met::EDIT;
      mes[1].key=0;
      mes[1].x=33;
      mes[1].y=13;
      mes[1].sizex=24;
      mes[1].maxlen=TEXTLEN-1;
      mes[1].text=zusammenfassung;

      mes[2].type=met::EDIT;
      mes[2].key=0;
      mes[2].x=33;
      mes[2].y=14;
      mes[2].sizex=24;
      mes[2].maxlen=60;
      mes[2].text=antwort_an;

      if(news)
       {
        mes[3].type=met::EDIT;
        mes[3].key=0;
        mes[3].x=33;
        mes[3].y=15;
        mes[3].sizex=24;
        mes[3].maxlen=40;
        mes[3].text=diskussion_in;

        mes[4].type=met::IGNORE;
       }
      else
       {
        mes[3].type=met::COMMANDBUTTON;
        mes[3].x=33;
        mes[3].y=15;
        mes[3].sizex=4;
        mes[3].key=0;
        mes[3].text=(char *)noyes1(eb);

        mes[4].type=met::IGNORE;
       }

      mes[5].type=met::COMMANDBUTTON;
      mes[5].x=26;
      mes[5].y=news?17:17;
      mes[5].key=Key_C_Ent;
      mes[5].sizex=6;
      mes[5].text="O^k";

      mes[6].type=met::COMMANDBUTTON;
      mes[6].x=43;
      mes[6].y=news?17:17;
      mes[6].key=0;
      mes[6].sizex=9;
      mes[6].text="^Abbruch";

      mes[7].type=met::END_OF_LIST;

      i=5;

     schleife3:
      switch(domenu(&online, mes, i, TRUE))
       {
       case 3:
        eb=!eb;
        i=3;
        mes[3].text=(char *)noyes1(eb);
        goto schleife3;

       case 5:
        dword len;
        char outfilename[DIRLEN], abs[TEXTLEN], org[TEXTLEN];

        gen_abs(status, status.username, abs, org, TRUE);

        infile=fopen(filename, "rb");
        len=filelength(fileno(infile));

        snprintf(outfilename, DIRLEN, DBOXPORTTEMPDIR "msg.tmp", 
          config.dboxdir, config.port);

        outfile=fopen(outfilename, "wb");
        if(outfile==NULL)
         {
          logf.printf("dowritemail", "Failed to create \"%s\"", outfilename);
          return;
         }

        fprintf(outfile, "ABS:\t%s\r\n", abs);

        if(antwort_an[0]!=0)
          fprintf(outfile, "ANTWORT-AN:\t%s\r\n",
            antwort_an);

        fprintf(outfile, "BET:\t%s\r\n", bet);

        if(bez!=NULL)
          fprintf(outfile, "BEZ:\t%s\r\n", bez);

        if(diskussion_in[0]!=0)
          fprintf(outfile, "DISKUSSION-IN:\t%s\r\n",
            diskussion_in);

        fprintf(outfile, "EDA:\t%s\r\n", make_eda_localtime().c_str());

        fprintf(outfile, "EMP:\t%s\r\n", emp);

        fprintf(outfile, "LEN:\t%lu\r\n", len);

        fprintf(outfile, "MAILER:\tDBOX Mailer\r\n");

        if(eb) fprintf(outfile, "EB:\r\n");

        fprintf(outfile, "MID:\t%s\r\n",
          gen_message_id("mailer").c_str());

        if(org[0]!=0)
          fprintf(outfile, "ORG:\t%s\r\n", org);

        fprintf(outfile, "ROT:\r\n");

        if(zusammenfassung[0]!=0)
          fprintf(outfile, "ZUSAMMENFASSUNG:\t%s\r\n",
            zusammenfassung);

        fprintf(outfile, "\r\n");

        filecopy(infile, outfile, len);

        fclose(outfile);
        fclose(infile);

        remove(filename);

        if(news)
          dospoolnews(outfilename);

        if(news)
          snprintf(filename, DIRLEN, BOXSPOOLINZCNEWSDIR "%s.%lu-%lu-%u",
            config.boxdir, news?config.boxname:status.username,
            status.midcounter++, time(NULL), config.port);
        else
          snprintf(filename, DIRLEN, BOXSPOOLINZCMAILDIR "%s.%lu-%lu-%u",
            config.boxdir, news?config.boxname:status.username,
            status.midcounter++, time(NULL), config.port);

        rename(outfilename, filename);

        infobox(&online, "Nachricht verschickt!");
        break;
       }
     }
    break;

   case 4:
    infobox(&online, nls["online.notavailable"]);
    break;

   case MENU_HELP:
    /*
    displayhelp();
    */
    online.clrscr();
    if(status.dologout) break;
    goto startover;
   }
 }
