/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <strstream.h>
#include <fstream.h>

#include <dboxpath.h>
#include <tools.h>
#include "online.h"
#include "url.h"
#include "www.h"
#include "basic_www.h"
#include "../webonline/webonline.h"

class do_wwwt:public do_basic_wwwt
 {
 public:
  do_wwwt();
  virtual ~do_wwwt();

 protected:
  virtual bool get_and_format_internal();
  virtual string get_dbox_help();
 };

do_wwwt::do_wwwt()
 {
 }

do_wwwt::~do_wwwt()
 {
 }

string do_wwwt::get_dbox_help()
 {
  string filename;

  if(path=="") return "";

  if(path[path.size()-1]=='/')
   {
    getboxhtmldir(filename, config.boxdir);
    filename+="help"+path+"index.html";
    if(access(filename.c_str(), 00)==0)
      return filename;

    getdboxhtmldir(filename, config.dboxdir);
    filename+="help"+path+"index.html";
    if(access(filename.c_str(), 00)==0)
      return filename;

    return "";
   }

  getboxhtmldir(filename, config.boxdir);
  filename+="help"+path+DIRCHAR+"index.html";
  if(access(filename.c_str(), 00)==0)
   {
    url+="/";
    path+="/";
    return filename;
   }

  getdboxhtmldir(filename, config.dboxdir);
  filename+="help"+path+DIRCHAR+"index.html";
  if(access(filename.c_str(), 00)==0)
   {
    url+="/";
    path+="/";
    return filename;
   }

  getboxhtmldir(filename, config.boxdir);
  filename+="help"+path;
  if(access(filename.c_str(), 00)==0)
    return filename;

  getdboxhtmldir(filename, config.dboxdir);
  filename+="help"+path;
  if(access(filename.c_str(), 00)==0)
    return filename;

  return "";
 }

bool do_wwwt::get_and_format_internal()
 {
  if(host=="webonline")
   {
    strstream out;
    dowebonline(path, out);
    bool result=format_http(string(out.str(), out.tellp()));
    out.freeze(0);
    return result;
   }
  else if(host=="help")
   {
    if(strstr(path.c_str(), "..")!=NULL) return TRUE;
    string filename=get_dbox_help();
    if(filename=="") return TRUE;

    ifstream in(filename.c_str());
    htmlformat=new htmlformatt;
    htmlformat->set_width(online.sizex);
    htmlformat->format(in);
    return FALSE;
   }

  return do_basic_wwwt::get_and_format_internal();
 }

void dointernet_www(const char *url)
 {
  do_www(url==NULL?"":url);
 }

void do_www(const string &url)
 {
  do_wwwt do_www;
  do_www.do_www(url);
 }

