#ifndef DBOX_NETZ_H

#define DBOX_NETZ_H

#include <userdb.h>
#include <radius.h>
#include <logins.h>

bool checknetlogin(const char *login);

byte getnettype(userpt &up);

class netlogint
 {
 public:
  char ip[TEXTLEN];
  userpt up;
  check_login1t check_login1;
  check_login2t check_login2;
  byte login;
  char loginname[TEXTLEN], protocol[TEXTLEN],
       logintype[TEXTLEN], loginstring[TEXTLEN];
  clientpt cp;
  radiust rclient;
  grouppt gp;
  time_t starttime;
  bool local;

  virtual FILE *open_login();
  virtual FILE *open_charge();
  virtual void del_port_temp_dir();
  virtual void handle_local()=0;
  virtual void handle_remote() { }
  virtual bool verifylogin(const char *password, char *message);
  virtual void init();
  virtual void donetlogin()=0;
  virtual void accounting_start();
  virtual void accounting_stop();
  virtual bool radiuslogin(const char *password);

  netlogint() { }
  virtual ~netlogint() { }
 };

#endif
