/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <dirent.h>

#include <logf.h>
#include <portinfo.h>
#include "../online/extern.h"
#include "../online/online.h"
#include "ppp.h"

void autoppplogin(const char *loginname)
 {
  char ip[TEXTLEN];

  logf.printf("autoppplogin", "Anruf");

  portinfo.owninfo.status=portinfot::infot::SLIP;
  strmaxcpy(portinfo.owninfo.username, "", TEXTLEN-1);
  portinfo.write(config.port);

  if(config.slipaddr!=0)
    makeinternetdotaddress(config.slipaddr, ip);
  else
    snprintf(ip, TEXTLEN, "192.168.21.%u", config.port);

  doextern("/home/dbox/bin/doslip", ip, "-p");
 }

#if 0
class pppt
 {
 public:
  byte hdlc_status, ppp_status, lcp_code, lcp_id;
  bool hangup, escape;
  word protocol, lcp_length;

  void init();

  void lcp_processbyte(byte data);
  void hdlc_processbyte(byte data);
 };

void pppt::init()
 {
  hdlc_status=0;
  ppp_status=0;
  hangup=escape=FALSE;
  protocol=0;
 }

void pppt::lcp_processbyte(byte data)
 {
  switch(ppp_status)
   {
   case 0:
    lcp_code=data;
    ppp_status++;
    break;

   case 1:
    lcp_id=data;
    ppp_status++;
    break;

   case 2:
    lcp_length=mword(data, 0);
    ppp_status++;
    break;

   case 3:
    lcp_length|=data;
    ppp_status++;
    break;

   case 4:
    logf.printf("ppp", "lcp: %d", lcp_code);
    break;
   }
 }

void pppt::hdlc_processbyte(byte data)
 {
  if(data==0x7d)
   {
    escape=TRUE;
    return;
   }

  if(escape)
   {
    if(data<0x40)
      data-=0x20;
    else
      data+=0x20;

    escape=FALSE;
   }

  switch(hdlc_status)
   {
   case 0:
    if(data==0x7e)
      hdlc_status++;
    else if(data==0xff)
      hdlc_status+=2;
    break;

   case 1:
    if(data==0xff)
      hdlc_status++;
    else if(data==0x7e)
      hdlc_status=1;
    else
      hdlc_status=0;
    break;

   case 2:
    if(data==0x03)
      hdlc_status++;
    else
      hdlc_status=0;
    break;

   case 3:  
    protocol=mword(data, 0);
    hdlc_status++;
    break;

   case 4:
    protocol|=data;
    hdlc_status++;
    ppp_status=0;
    if(status.online2)
      online.console.printf("HDLC: %04x\r\n", protocol);
    break;

   case 5:
    if(data==0x7e)
      hdlc_status=1;
    else
     {
      switch(protocol)
       {
       case 0xc021:   // LCP
        lcp_processbyte(data);
        break;

       case 0xc023:   // PAP 
        break;

       case 0xc223:   // CHAP
        break;

       default:
        logf.printf("ppp", "Ignoriere Protokoll %04x", protocol);
       }
     }
    break;
   }
 }

void autoppplogin(const char *loginname)
 {
  pppt ppp;

  ppp.init();

  logf.printf("autoppplogin", "Anruf");

  if(status.online2)
    online.console.printf("\r\nPPP: Start\r\n");

  while(TRUE)
   {
    char ch;

    if(status.online2 && !online.comport.dcd()) 
     {
      logf.printf("autoppplogin", "Carrier lost");
      return;
     }

    if(ppp.hangup)
     {
      logf.printf("autoppplogin", "PPP: Auflegen");
      return;
     }

    if(status.online2)
     {
      online.waitkey();
      if(online.comport.readchar(&ch))
        ppp.hdlc_processbyte(ch);

      if(online.console.readchar(&ch))
        if(ch==27)
         {
          online.console.printf("PPP: Abbruch\r\n");
          logf.printf("autoppplogin", "PPP: Abbruch");
          return;
         }
     }
    else
     {
      online.console.waitkey();
      if(online.console.readchar(&ch))
        ppp.hdlc_processbyte(ch);
     }
   }
 }
#endif
