/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/time.h>
#include <errno.h>

#include <dbox.h>
#include <radius.h>
#include <md5.h>
#include <config.h>
#include <oldtools.h>
#include "../online/online.h"

void radius_test()
 {
  char username[TEXTLEN], password[TEXTLEN], tempstr[TEXTLEN];
  radiust r;
  time_t t;

  time(&t);

  makeinternetdotaddress(config.radius_auth_server, tempstr);  
  printf("Radius-Auth-Server: %s\r\n", tempstr);
  makeinternetdotaddress(config.radius_acct_server, tempstr);  
  printf("Radius-Acct-Server: %s\r\n", tempstr);
  printf("Radius-Secret: %s\r\n", config.radius_secret);
  
  printf("\nUsername: ");
  fflush(stdout);
  readline(&online.console, username, FALSE, FALSE, FALSE, FALSE);
  if(username[0]==0) return;
  printf("Passwort: ");
  fflush(stdout);
  readline(&online.console, password, TRUE, FALSE, FALSE, FALSE);
  
  r.radius_auth_server=config.radius_auth_server;
  r.radius_acct_server=config.radius_acct_server;
  strmaxcpy(r.username, username, TEXTLEN-1);
  strmaxcpy(r.secret, config.radius_secret, TEXTLEN-1);
  snprintf(r.session_id, TEXTLEN, "%ld", t);
  r.nas_ip_address=config.radius_ip_address;
  r.identifier=(time(NULL)&255);
  printf("\r\nIdentifier: %d\r\n", r.identifier);

  printf("\nFuehre Authorisierung durch...\r\n");

  printf("\nFertig! Ergebnis: %d\r\n", 
    r.authenticate(password, tempstr));
 
  printf("Nachricht: >%s<\r\n\n", tempstr);
 }
