/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <dirent.h>

#include <dbox.h>
#include <netdefs.h>
#include <logins.h>
#include <logf.h>
#include <oldtools.h>
#include "../online/extern.h"
#include "../online/online.h"
#include "netz.h"
#include "uucp.h"

class uucpnetlogint:public netlogint
 {
 public:
  virtual void handle_local();
  virtual void donetlogin();
 };

void uucpnetlogint::handle_local()
 {
  doextern("/home/dbox/bin/douucico", "-q", "-u", up.name);
 }

void uucpnetlogint::donetlogin()
 {
  char password[TEXTLEN], message[TEXTLEN];

  init();

  online.printf("\r\nYou are connected to %s.%s running DBOX\r\n\r\n",
    config.boxname, config.domain);

  online.flushkeys();
  online.printf("%s login:", config.boxname);

  if(readline(&online, loginname, FALSE, FALSE, TRUE, FALSE))
   {
   timeout:
    logf.printf("uucplogin", "Timeout");
    return;
   }

  dnstring(loginname);

  online.flushkeys();
  online.printf("Password:");
  if(readline(&online, password, TRUE, FALSE, TRUE, TRUE)) goto timeout;

  if(verifylogin(password, message))
   {
    if(message[0]!=0)
      online.printf("%s\r\n", message);

    online.printf("\r\nYou are unknown to me, please go away.\r\n");
    return;
   }
 }

void uucplogin(const char *login)
 {
  uucpnetlogint uucpnetlogin;

  strmaxcpy(uucpnetlogin.loginstring, login, TEXTLEN-1);
  uucpnetlogin.login=NETZ_UUCP;
  uucpnetlogin.donetlogin();
 }
