/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>

#include <dbox.h>
#include <oldtools.h>
#include <dboxversion.h>
#include <dboxpath.h>
#include <portinfo.h>
#include <logf.h>
#include <userdb.h>
#include <oldui.h>
#include "fax.h"
#include "terminal.h"
#include "caller.h"
#include "../online/online.h"
#include "waitcall.h"

static void netcall()
 {
  char systemname[TEXTLEN]="";
  met mes[4];

  online.console.setattr(2, FALSE);
  online.console.box(20, 10, 60, 16, BOXFRAMEDBL,
    "Netcall auslsen", TRUE);

  online.console.setcursor(27, 12);
  online.console.printf("Systemname:");

  mes[0].type=met::EDIT;
  mes[0].key=0;
  mes[0].x=39;
  mes[0].y=12;
  mes[0].sizex=10;
  mes[0].maxlen=8;
  mes[0].text=systemname;

  mes[1].type=met::COMMANDBUTTON;
  mes[1].x=26;
  mes[1].y=14;
  mes[1].key=Key_C_Ent;
  mes[1].sizex=6;
  mes[1].text="O^k";

  mes[2].type=met::COMMANDBUTTON;
  mes[2].x=43;
  mes[2].y=14;
  mes[2].key=0;
  mes[2].sizex=9;
  mes[2].text="^Abbruch";

  mes[3].type=met::END_OF_LIST;

 schleife:
  switch(domenu(&online.console, mes, 0, TRUE))
   {
   case 1:
    if(systemname[0]==0) return;

    dnstring(systemname);

     {
      userpt up(systemname);

      if(up.read())
       {
        errorbox(&online.console, "System nicht gefunden!");
        return;
       }

      if((up|"telefon_data")[0]==0)
       {
        errorbox(&online.console, "Keine Telefonnummer eingetragen!");
        return;
       }

      if(!atoi(up|"system"))
       {
        errorbox(&online.console, "Dies ist ein Point!");
        return;
       }
     }

    docall(systemname, "");
    break;

   case MENU_HELP:
    goto schleife;
   }
 }

static int waitforstring(char **strings, byte timeout)
 {
  byte counter[20], anzstrings, i;
  char ch;
  time_t starttime=time(NULL);

  anzstrings=0;
  while(strings[anzstrings]!=NULL) anzstrings++;
  for(i=0; i<anzstrings; i++) counter[i]=0;

  while(TRUE)
   {
    do
     {
      status.online2=TRUE;
      online.waitkey();
      status.online2=FALSE;

      ch=online.console.readkey();
      if(ch==Key_Esc) return -1;

      if(time(NULL)>starttime+timeout*60) return -2;
      ch=online.comport.readkey();
     }
    while(ch==0);

    for(i=0; i<anzstrings; i++)
      if(toupper(strings[i][counter[i]])!=ch)
        counter[i]=0;

    for(i=0; i<anzstrings; i++)
      if(toupper(strings[i][counter[i]])==ch)
       {
        counter[i]++;
        if(strings[i][counter[i]]==0)
          return i;
       }
   }
 }

#if 0
static int waitforstring(char *string, byte timeout)
 {
  char *strings[2];
  strings[0]=string;
  strings[1]=NULL;
  return waitforstring(strings, timeout);
 }
#endif

static void printstatus(const char *s)
 {
  online.console.setcursor(4, online.console.sizey-2);
  online.console.printf("STATUS: %s", s);
  for(int i=67-strlen(s); i!=0; i--)
    online.console.putch(' ');

  online.console.setcursor(4, online.console.sizey-2);
  asyncio.flush_output();
 }

static bool getconnect(char *connect)
 {
  char string[TEXTLEN*2], *tptr=string;
  int i=(TEXTLEN*2)-2;
  char ch;

  time_t starttime;
  time(&starttime);

  do
   {
    ch=online.comport.readkey();
    if(ch==0)
      online.comport.waitkey();
    else
     {
      if(ch=='\r' || ch=='\n')
       {
        strmaxcpy(connect, string, (TEXTLEN*2)-1);
        return FALSE;
       }

      if(tptr!=string || ch!=' ')
       {
        *tptr=ch;
        tptr++;
        *tptr=0;
        i--;
        if(i==0) return TRUE;
       }
     }
   }
  while(time(NULL)<starttime+10);
  return TRUE;
 }

static bool processring()
 {
  bool erg=FALSE;
 
  char *s1[]=
   {
    "CONNECT ",
    "NO CARRIER",
    "ERROR",
    NULL
   };

  printstatus("Anruf erkannt!");
  logf.printf("processring", "Anruf erkannt");
  portinfo.owninfo.status=portinfot::infot::RING;
  portinfo.owninfo.lastcall=time(NULL);
  portinfo.write(config.port);

  online.comport.flushkeys();
  online.comport.printf("%s\r", status.deviceconfig|"abheben");

  switch(waitforstring(s1, 2))
   {
   case -2:
    printstatus("Timeout");
    break;

   case -1:
    printstatus("Abbruch");
    break;

   case 0:
     {
      char connect[TEXTLEN*2];
      if(getconnect(connect))
       {
       error:
        printstatus("Fehler!");
        logf.printf("processring", "ungltige Connect-Meldung: \"%s\"",
          connect);
       }
      else if(strncmp(connect, "FAX", 3)==0)
       {
        logf.printf("processring", "Fax-Anruf erkannt: %s", connect);
        dofax();
        erg=TRUE;
       }
      else
       {
        status.linespeed=atol(connect);
        if(status.linespeed==0) goto error;
        printstatus("Verbindung hergestellt!");
        logf.printf("processring", "CONNECT %lu", status.linespeed);

        if(!online.comport.dcd())
         {
          printstatus("Warte auf DCD...");
          sleep(1);

          if(!online.comport.dcd())
           {
            printstatus("Warte auf DCD......");
            sleep(1);
            if(!online.comport.dcd())
              logf.printf("processring", "WARNING: NO DCD!");
           }
         }

        status.online2=TRUE;
        online.console.clrscr();
        drawstatusbar();
        online.console.setcursor(1, 1);
        dologin();
        status.online2=FALSE;
        erg=TRUE;
       }
     }
    break;

   case 1:
    logf.printf("processring", "NO CARRIER");
    printstatus("NO CARRIER");
    sleep(1);
    erg=TRUE;
    break;

   case 2:
    logf.printf("processring", "ERROR");
    printstatus("Modem Fehler!");
    break;
   }
  return erg;
 }

static void doofflinelogin2()
 {
  online.console.clrscr();
  online.console.setcursor(1, 1);
  online.console.printf("-- Port %u --\r\n\n", config.port);
  status.linespeed=0;
  dologin();
 }

static void drawwaitscreen()
 {
  char tempstr[TEXTLEN];

  online.console.setattr(0xff, FALSE);

  snprintf(tempstr, TEXTLEN, "Wartemaske Port %u", config.port);
  drawscreen(&online.console, tempstr, 
    "Version " DBOXVERSIONNR " vom " DBOXVERSION);

  online.console.setcursor(4, 11);
  online.console.printf("Mailboxname:      %s.%s", config.boxname, config.domain);

  online.console.setcursor(65, 11);
  online.console.printf("Systemport: %u", config.port);

  online.console.setcursor(65, 12);
  strmaxcpy(tempstr, config.console, 5);
  online.console.printf("Konsole: %4s", tempstr);

  if(config.comport[0]!=0)
   {
    online.console.setcursor(65, 13);
    online.console.printf("Comport: %4s\r\n", config.comport);
   }

  online.console.setcursor(1, 12);

  if(config.organization[0]!=0)
    online.console.printf("  Organisation:     %s\r\n", config.organization);

  if(status.lastcall[0]!=0)
    online.console.printf("  letzter Anruf:    %s\r\n", status.lastcall);

  if(config.telefon[0]!=0)
    online.console.printf("  Telefon:          %s\r\n", config.telefon);

  if((status.deviceconfig|"modemname")[0]!=0)
    online.console.printf("  Modemname:        %s\r\n", status.deviceconfig|"modemname");

  //online.console.printf("  registriert fr:  %s (Ser. %s, %u Ports)\r\n",
  //  license.registriert, license.seriennummer, license.ports);
 }

static void nowoffline()
 {
 }

bool docheckevent()
 {
  char tempstr[DIRLEN];
 
  snprintf(tempstr, TEXTLEN, BOXTODODIR "netcall.%u", config.boxdir, config.port);
  if(access(tempstr, 00)==0)
   {
    doautomaticcall();
    return TRUE;
   }

  return FALSE;
 }

#define MAXINITIALISIEREN 3

void waitforcall()
 {
  bool ende=FALSE, error=FALSE;
  time_t nochmalinitialisieren=0, checkevent, modem_init=0;
  byte maxinitialisieren=MAXINITIALISIEREN;

  if(startport()) return;
  logf.setport(config.port);

  time(&checkevent);
  checkevent+=20;

  do
   {
    char tempstr[100], ch;
    char ring[]="RING\r";
    byte ringpos=0;
    int i;

    status.dologout=FALSE;
    status.killed=FALSE;
    portinfo.owninfo.status=portinfot::infot::WORKING;
    portinfo.write(config.port);
    snprintf(status.deviceconfig.name, TEXTLEN, "%u", config.port);

    if(status.deviceconfig.read())
     {
      ende=TRUE;
      logf.printf("waitforcall", "Fatal: Deviceconfig nicht gefunden.");
      errorbox(&online.console, "Fatal: Deviceconfig nicht gefunden!");
      online.console.clrscr();
      online.console.setcursor(1, 1);
     }
    else
     {
      online.console.close();
      online.console.assign(config.console);
      online.console.open();

      online.set_app_out_charset(IBM);
      online.console.set_hw_charset(config.console_charset);

      drawwaitscreen();

      nochmalinitialisieren=0;

      if(config.comport[0]!=0)
       {
        if(online.comport.assign(config.comport))
         {
          printstatus("Fatal: Device konnte nicht geffnet werden!");
         }

        online.comport.open();
        online.comport.setparms(config.dte, 'N', 8);

        if((status.deviceconfig|"init")[0]!=0)
         {
          online.console.setcursor(4, online.console.sizey-2);
          online.console.printf("STATUS: Initialisiere Modem ... ");

          // online.comport.dtrtoggle();
          sleep(1);
          //online.comport.putch('\r');
          //sleep(1);
          // online.comport.printf("AT");
          // online.comport.putch('\r');
          online.comport.printf("%s", status.deviceconfig|"init");
          asyncio.flush_output();
          online.comport.flushkeys();
          //sleep(1);
          online.comport.putch('\r');
          asyncio.flush_output();
          sleep(1);
          i=0;
          while((ch=online.comport.readkey())!=0)
            if(i<90) tempstr[i++]=upcase(ch);
          tempstr[i]=0;
          if(strstr(tempstr, "OK")==NULL)
           {
            online.console.printf("fehlgeschlagen!");
            logf.printf("waitforcall", "Warnung: Modeminitialisierung fehlgeschlagen!");
            if(maxinitialisieren==0)
             {
              error=TRUE;
              portinfo.owninfo.status=portinfot::infot::ERROR;
             }
            else
             {
              maxinitialisieren--;
              nochmalinitialisieren=time(NULL)+20;
             }
           }
          else
           {
            online.console.printf("Ok");
            maxinitialisieren=MAXINITIALISIEREN;
            modem_init=time(NULL)+1800;
            error=FALSE;
           }
         }
       }

     schleife1:
      online.console.setcursor(4, online.console.sizey-5);
      online.console.printf("Tasten:  Ctrl-X: Offline-Login   Ctrl-Z: Port beenden   Ctrl-N: Netcall");
      online.console.setcursor(4, online.console.sizey-4);
      online.console.printf("         Ctrl-T: Terminal        Ctrl-?:                    F1: Hilfe");

      printstatus(error?"Hardwarefehler!":"Warte auf Anruf.");

      strmaxcpy(portinfo.owninfo.telefon, config.telefon, TEXTLEN-1);
      strmaxcpy(portinfo.owninfo.modemname, status.deviceconfig|"modemname", TEXTLEN-1);
      portinfo.owninfo.status=error?portinfot::infot::ERROR:portinfot::infot::FREE;
      portinfo.write(config.port);

     schleife2:
      if(config.comport[0]!=0) status.online2=TRUE;
      online.waitkey();
      status.online2=FALSE;

      if(nochmalinitialisieren!=0 && time(NULL)>nochmalinitialisieren)
        goto docontinue;

      if(config.comport[0]!=0)
       {
        if((ch=online.comport.readkey())!=0)
         {
          if(ch=='\n') ch='\r';
          if(ch==ring[ringpos])
           {
            ringpos++;
            if(ring[ringpos]==0) // RING!
             {
              processring();
              goto docontinue; // Modem initialisieren...
             }
           }
          else
            ringpos=0;
         }
       }

      switch(online.console.readkey())
       {
       case Key_C_X:
        logf.printf("waitforcall", "Offline Anruf");
        nowoffline();
        doofflinelogin2();
        sleep(1);
        break;

       case Key_C_Z:
       //case Key_Esc:
        nowoffline();
        ende=TRUE;
        break;

       case Key_C_N:
        if(config.comport[0]==0)
         {
          printstatus("Es wurde kein Gert zugewiesen!");
          goto schleife2;
         }

        portinfo.owninfo.status=portinfot::infot::WORKING;
        portinfo.write(config.port);
        netcall();
        break;

       case Key_C_R:
       redraw:
        drawwaitscreen();
        goto schleife1;

       case Key_Spa:
        online.flushkeys();
        break;

       case Key_C_T:
        if(config.comport[0]==0)
         {
          printstatus("Es wurde kein Gert zugewiesen!");
          goto schleife2;
         }

        portinfo.owninfo.status=portinfot::infot::WORKING;
        portinfo.write(config.port);
        doterminal();
        break;

       case Key_F1:
       case '?':
       case 'h':
       case 'H':
        portinfo.owninfo.status=portinfot::infot::WORKING;
        portinfo.write(config.port);
        // displayhelp(M_WAITCALL_HELP);
        goto redraw;

       case 0:
        if(time(NULL)>checkevent)
         {
          char tempstr1[DIRLEN], tempstr2[DIRLEN], tempstr3[DIRLEN];

          snprintf(tempstr1, DIRLEN, BOXTODODIR "shutdown.%u", config.boxdir, config.port);
          snprintf(tempstr2, DIRLEN, BOXTODODIR "shutdown", config.boxdir);
          snprintf(tempstr3, DIRLEN, BOXTODODIR "restart.%u", config.boxdir, config.port);

          if(access(tempstr1, 00)==0 || access(tempstr2, 00)==0)
           {
            ende=TRUE;
            online.console.clrscr();
            online.console.setcursor(1, 1);
            online.console.printf("Shutdown!\r\n");
            goto docontinue;
           }
          else if(access(tempstr3, 00)==0)
           {
            remove(tempstr3);
            ende=status.restart=TRUE;
            online.console.clrscr();
            online.console.setcursor(1, 1);
            online.console.printf("Restarting...\r\n");
            goto docontinue;
           }
          else
           {
            bool didit=docheckevent();
            checkevent=time(NULL)+25;
            if(didit) goto docontinue;
           }
         }
        else if(time(NULL)>modem_init)
         {
          modem_init=time(NULL)+1800;
          goto docontinue;
         }
        goto schleife2;

       default:
        goto schleife2;
       }

      online.console.clrscr();
      online.console.setcursor(1, 1);

     docontinue:
      online.console.close();
      online.console.assign("/dev/null");
      online.console.open();

      if(config.comport[0]!=0)
       {
        online.comport.dtrtoggle();
        online.comport.close();
       }
     }
   }
  while(!ende);

  portinfo.owninfo.status=portinfot::infot::OFFLINE;
  portinfo.write(config.port);

  logf.setport(0);
 }

void public_terminal()
 {
  bool ende=FALSE;
  time_t checkevent;

  if(startport()) return;
  logf.setport(config.port);

  time(&checkevent);
  checkevent+=20;

  do
   {
    status.dologout=FALSE;
    status.killed=FALSE;
    portinfo.owninfo.status=portinfot::infot::WORKING;
    portinfo.write(config.port);
    snprintf(status.deviceconfig.name, TEXTLEN, "%u", config.port);

    online.console.close();
    online.console.assign(config.console);
    online.console.open();

    online.set_app_out_charset(IBM);
    online.console.set_hw_charset(config.console_charset);

    drawwaitscreen();

   schleife1:
    strmaxcpy(portinfo.owninfo.telefon, config.telefon, TEXTLEN-1);
    strmaxcpy(portinfo.owninfo.modemname, status.deviceconfig|"modemname", TEXTLEN-1);
    portinfo.owninfo.status=portinfot::infot::FREE;
    portinfo.write(config.port);

    printstatus("Enter: Login");

   schleife2:
    online.waitkey();

    switch(online.console.readkey())
     {
     case Key_C_X:
     case Key_Ent:
      logf.printf("waitforcall", "Offline Anruf");
      nowoffline();
      doofflinelogin2();
      break;

     //case Key_C_Z:
     //case Key_Esc:
     // nowoffline();
     // ende=TRUE;
     // break;

     case Key_C_R:
     redraw:
      drawwaitscreen();
      goto schleife1;

     case Key_F1:
     case '?':
     case 'h':
     case 'H':
      portinfo.owninfo.status=portinfot::infot::WORKING;
      portinfo.write(config.port);
      // displayhelp(M_WAITCALL_HELP);
      goto redraw;

     case 0:
      if(time(NULL)>checkevent)
       {
        char tempstr1[DIRLEN], tempstr2[DIRLEN], tempstr3[DIRLEN];

        snprintf(tempstr1, DIRLEN, BOXTODODIR "shutdown.%u", config.boxdir, config.port);
        snprintf(tempstr2, DIRLEN, BOXTODODIR "shutdown", config.boxdir);
        snprintf(tempstr3, DIRLEN, BOXTODODIR "restart.%u", config.boxdir, config.port);

        if(access(tempstr1, 00)==0 || access(tempstr2, 00)==0)
         {
          ende=TRUE;
          online.console.clrscr();
          online.console.setcursor(1, 1);
          online.console.printf("Shutdown!\r\n");
          goto docontinue;
         }
        else if(access(tempstr3, 00)==0)
         {
          remove(tempstr3);
          ende=status.restart=TRUE;
          online.console.clrscr();
          online.console.setcursor(1, 1);
          online.console.printf("Restarting...\r\n");
          goto docontinue;
         }
        else
         {
          bool didit=docheckevent();
          checkevent=time(NULL)+25;
          if(didit) goto docontinue;
         }
       }
      goto schleife2;

     default:
      goto schleife2;
     }

    online.console.clrscr();
    online.console.setcursor(1, 1);

   docontinue:
    online.console.close();
    online.console.assign("/dev/null");
    online.console.open();
   }
  while(!ende);

  portinfo.owninfo.status=portinfot::infot::OFFLINE;
  portinfo.write(config.port);

  logf.setport(0);
 }
