/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <dirent.h>

#include <dbox.h>
#include <radius.h>
#include <netdefs.h>
#include <logf.h>
#include <oldtools.h>
#include "../online/extern.h"
#include "../online/online.h"
//#include <oserv/logins.h>
#include "netz.h"
#include "puffer.h"
#include "z38.h"

bool z38netlogint::doz38login(char *password)
 {
  sleep(1);
  online.flushkeys();

  switch(login)
   {
   case NETZ_ALPHABOX:
    online.printf("Nodename:");
    break;

   default:
    online.printf("Systemname:");
    break;
   }

  if(readline(&online, loginname, FALSE, FALSE, FALSE, FALSE)) return TRUE;
  dnstring(loginname);

  online.flushkeys();
  online.printf("Passwort:");
  if(readline(&online, password, TRUE, FALSE, FALSE, FALSE)) return TRUE;
  dnstring(password);

  return FALSE;
 }

bool z38netlogint::transfersinglefile(bool upload, const char *filename)
 {
  char tempstr[TEXTLEN*2];
  char prot_char;

  switch(config.netprotocoldb.index(up|"protokoll"))
   {
   case -1: // Default
   case PROTOKOLL_ZMODEM: prot_char='Z'; break;
   case PROTOKOLL_YMODEM: prot_char='Y'; break;
   case PROTOKOLL_XMODEM: prot_char='X'; break;
   default: prot_char=' ';
   }

  switch(config.netprotocoldb.index(up|"protokoll"))
   {
   case -1: // Default
   case PROTOKOLL_ZMODEM:
   case PROTOKOLL_YMODEM:
   case PROTOKOLL_XMODEM:
    snprintf(tempstr, TEXTLEN*2, "%spuffer von %s", 
      upload?"Eingangs":"Ausgangs", up.name);

    if(upload)
     {
      if(doupload_specialfile(prot_char, filename, tempstr, logintype))
        return TRUE;
     }
    else
     {
      if(dodownload(prot_char, filename, tempstr, logintype))
        return TRUE;
     }

    break;

   case PROTOKOLL_HYDRA:

    break;
   }

  return FALSE;
 }

void z38netlogint::donetlogin()
 {
  char password[TEXTLEN], message[TEXTLEN];
  byte trials=3;

  if(checklicense())
   {
    online.printf("Lizenz nicht gefunden!\r\n");
    return;
   }
 
  init();

  while(TRUE)
   {
    if(doz38login(password))
     {
      logf.printf("donetlogin", "timeout");
      return;
     }
   
    if(!verifylogin(password, message))
      return;

    switch(login)
     {
     case NETZ_ALPHABOX:
      online.printf("\r\n!!!UNBEKANNT!!!\r\n");
      break;

     default:
      online.printf("\r\nLogin failed!\r\n");
      if(message[0]!=0)
        online.printf("%s\r\n", message);
      online.printf("\r\n");
      break;
     }

    trials--;
    if(trials==0)
     {
      online.printf("\r\nNetzzugriff verweigert\r\n");
      return;
     }
   }
 }

