/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dirent.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/stat.h>
#include <time.h>
#include <stdio.h>
#include <sys/types.h>

#include <dbox.h>
#include <tools.h>
#include <dboxpath.h>
#include <config.h>
#include "msgid.h"

#ifndef __MSDOS__
#define O_BINARY 0
#endif

void docrunchmsgid(bool repair)
 {
  int fd;
  char filename1[DIRLEN], n_filename1[DIRLEN], 
       filename2[DIRLEN], n_filename2[DIRLEN];
  dword m_size=10000000;

  msgidbaset::dataentryt dataentry;
  dword pos, size, target, startpos;
  byte oldpercent=0xff, percent;

  if(repair)
   {
    char tempstr[1000];
    printf("Size: ");
    fgets(tempstr, 900, stdin);
    m_size=atol(tempstr);
    if(m_size>20000000 || m_size<1000000) return;
   }

  snprintf(filename1, DIRLEN, DBOXSYSTEMDIR "msgid", config.dboxdir);
  snprintf(filename2, DIRLEN, DBOXSYSTEMDIR "msgid.idx", config.dboxdir);
  snprintf(n_filename1, DIRLEN, DBOXSYSTEMDIR "msgid.tmp", config.dboxdir);
  snprintf(n_filename2, DIRLEN, DBOXSYSTEMDIR "msgid2.tmp", config.dboxdir);

  fd=::open(filename1, O_RDONLY|O_BINARY);

  size=filelength(fd);
  if(size<(m_size+1000))
   {
    printf("MSG-ID-Base zu klein.\n");
    close(fd);
    return;
   }

  target=size-m_size;

  do
   {
    if(read(fd, &dataentry, sizeof dataentry)!=sizeof dataentry)
     {
      printf("\nDatenbank-Fehler!\n");
      close(fd);
      return;
     }

    if(dataentry.next<target)
      pos=lseek(fd, dataentry.next, SEEK_SET);
    else
      pos=lseek(fd, dataentry.len, SEEK_CUR);

    percent=dword(100.0*double(pos)/target);

    if(percent!=oldpercent)
     {
      printf("Suche Startpunkt: %u%%\n", percent);
      oldpercent=percent;
     }
   }
  while(pos<target);
  close(fd);

  printf("Startpunkt gefunden: %lu\n", pos);
  startpos=pos;

  remove(n_filename1);
  remove(n_filename2);
  rename(filename1, n_filename1);
  rename(filename2, n_filename2);

  if(msgidbase.open())
   {
    printf("Fehler!\n");
    remove(filename1); remove(filename2);
    rename(n_filename1, filename1);
    rename(n_filename2, filename2);
    return;
   }

  fd=::open(n_filename1, O_RDONLY|O_BINARY);
  lseek(fd, pos, SEEK_SET);

  oldpercent=0xff;

  while(pos!=size)
   {
    #define MSGID_S 10000
    char msgid[MSGID_S];

    if(read(fd, &dataentry, sizeof dataentry)!=sizeof dataentry)
     {
     error:
      #if 0
      if(repair)
       {
        printf("Warnung: Datenbank-Fehler ignoriert!\n");
        close(fd);
        msgidbase.close();
        return;
       }
      #endif

      printf("\nDatenbank-Fehler!\n");
      msgidbase.close();
      close(fd);
      remove(filename1); remove(filename2);
      rename(n_filename1, filename1);
      rename(n_filename2, filename2);
      return;
     }

    if(dataentry.len<(MSGID_S+1))
     {
      if(read(fd, msgid, dataentry.len)!=dataentry.len) goto error;
      msgid[dataentry.len]=0;
      if(msgidbase.add(msgid)) goto error;
      pos=lseek(fd, 0, SEEK_CUR);
     }
    else
      pos=lseek(fd, dataentry.len, SEEK_CUR);

    percent=dword(100.0*double(pos-startpos)/(size-startpos));

    if(percent!=oldpercent)
     {
      printf("Kopiere: %u%%\n", percent);
      oldpercent=percent;
     }
   }
  
  close(fd);
  msgidbase.close();
 }
