#include "emailtab.h"

template <class T>
class deliver_mailt
 {
 public:
  T &m;
  userpt &up, dest_up;
  const string &envelope_to, &envelope_from;
  string userlogfile;
  grouppt gp;

  bool deliver_mail();
  bool match_mail(textprofilet &profile);
  bool doit(textprofilet &profile);
  void doalias(const string &alias);

  dword get_folder_quota(const string &user);

  deliver_mailt(T &_m, 
                userpt &_up,
                const string &_envelope_to,
                const string &_envelope_from);
 };

template <class T>
dword deliver_mailt<T>::get_folder_quota(const string &user)
 {
  return 0;
 }

template <class T>
deliver_mailt<T>::deliver_mailt(
  T &_m,
  userpt &_up,
  const string &_envelope_to,
  const string &_envelope_from):
  m(_m), up(_up),
  envelope_to(_envelope_to),
  envelope_from(_envelope_from)
 {
 }

template <class T>
bool deliver_mailt<T>::match_mail(textprofilet &profile)
 {
  for(unsigned i=0; i<profile.size(); i++)
   {
    if(strncasecmp(profile.data[i].id, "header.", 7)==0)
     {
      if(!match_header(m, profile.data[i].id+7, profile.data[i].data))
        return FALSE;
     }
    else if(stringcasecmp(profile.data[i].id, "envelope.to")==0)
     {
      if(!checkjoker(profile.data[i].data, envelope_to.c_str(), TRUE))
        return FALSE;
     }
    else if(stringcasecmp(profile.data[i].id, "envelope.from")==0)
     {
      if(!checkjoker(profile.data[i].data, envelope_from.c_str(), TRUE))
        return FALSE;
     }
   }
  
  return TRUE; 
 }

template <class T>
void deliver_mailt<T>::doalias(const string &alias)
 {
  userpt aliasp;
  aliasp.setname(alias);

  if(aliasp.read())
   {
    logf.fileprintf(userlogfile.c_str(), "deliver", 
      "failed to deliver mail to alias "
      "\"%s because alias does not exist", alias.c_str());
    return;
   }

  deliver_mailt<T> deliver_mail(m, aliasp, envelope_to, envelope_from);
  deliver_mail.deliver_mail(); // TODO: loops
 }

template <class T>
bool deliver_mailt<T>::doit(textprofilet &profile)
 {
  bool do_break;

  do_break=(atoi(profile.get("break"))!=0);

  string alias=profile.get("alias");

  if(alias!="")
   {
    doalias(alias);
    return do_break;
   }

  string mailbox_name=profile.get("mailbox"),
         folder_owner=profile.get("owner"),
         subfolder;

  if(folder_owner=="")
    folder_owner=dest_up.name;  // default is destination user

  if(mailbox_name=="")
    return do_break;

  if(get_subfolder(folder_owner, mailbox_name, subfolder))
    return do_break;
 
  if(mailfolderalias(folder_owner, subfolder))
    return do_break;

  if(folder_owner!=up.name &&
     folder_owner!=dest_up.name)
   {
    folder_grantst grants;
    ::get_folder_grants(folder_owner, subfolder, 
      up, gp, grants);

    if(!grants.write)
     {
      logf.fileprintf(userlogfile.c_str(),
        "deliver", "failed to deliver mail to folder "
        "\"%s@%s because of missing write grant",
        mailbox_name.c_str(),
        folder_owner.c_str());

      return do_break;
     }
   }

  string folder=subfolder+"@"+folder_owner;

  spool_in_folder(m, folder, FALSE, envelope_to);

  return do_break;
 }

template <class T>
bool deliver_mailt<T>::deliver_mail()
 {
  grouppt gp(up|"gruppe");
  gp.read();

  userlogfile=up.getpath();
  userlogfile+="logfile";

  map_emailtab(up, envelope_to, dest_up);

  textprofilet profile;
  ifstream in((string(dest_up.getpath())+"mfilter").c_str());

  if(!in)
    spool_in_folder(m, dest_up.name, FALSE, envelope_to);
  else
   {
    while(in && !in.eof())
      if(!profile.readline(in))
        if(match_mail(profile))
          if(doit(profile))
            break;
   }

  return FALSE;
 }

