#include <fstream.h>

#include <sfolderrfc.h>
#include <stringtools.h>
#include <rfc1522.h>
#include <logf.h>

#include "deliverrfc.h"

bool match_header(const rfcmessaget &m,
                  const string &header,
                  const string &pattern)
 {
  const char *start=m.data, *text;
  bool mime_decode=FALSE;

  if(stringcasecmp(header, "From")==0 ||
     stringcasecmp(header, "Subject")==0)
    mime_decode=TRUE;

  while(!m.findheader(&start, header.c_str(), &text))
   {
    string header_text;
    m.copyheadertext(header_text, text);

    if(mime_decode)
      header_text=decode_rfc1522(header_text);

    if(check_joker(pattern, header_text, TRUE))
      return TRUE;
   }

  return FALSE;
 }

#include "deliver.t"

typedef deliver_mailt<rfcmessaget> rfc_deliver_mailt;

bool deliver_mail(rfcmessaget &m,
                  userpt &up,
                  const string &envelope_to,
                  const string &envelope_from)
 {
  rfc_deliver_mailt deliver_mail(m, up, envelope_to, envelope_from);

  return deliver_mail.deliver_mail();
 }

