#include <fstream.h>

#include <sfolderzc.h>
#include <stringtools.h>
#include <logf.h>

#include "deliverzc.h"

bool match_header(const zcmessaget &m,
                  const string &header,
                  const string &pattern)
 {
  const char *start=m.data, *text;
  string new_header;

  if(stringcasecmp(header, "Subject")==0)
    new_header="BET";
  else if(stringcasecmp(header, "Message-Id")==0)
    new_header="MID";
  else if(stringcasecmp(header, "Organization")==0)
    new_header="ORG";
  else if(stringcasecmp(header, "Reply-To")==0)
    new_header="ANTWORT-AN";
  else
    new_header="U-"+header;
 
  while(!m.findheader(&start, header.c_str(), &text))
   {
    string header_text;
    m.copyheadertext(header_text, text);
    ibm2iso(header_text);

    if(check_joker(pattern, header_text, TRUE))
      return TRUE;
   }

  return FALSE;
 }

#include "deliver.t"

typedef deliver_mailt<zcmessaget> zc_deliver_mailt;

bool deliver_mail(zcmessaget &m,
                  userpt &up,
                  const string &envelope_to)
 {
  string envelope_from;

  if(m.findsingleheader(envelope_from, "WAB"))
    m.findsingleheader(envelope_from, "ABS");

  ibm2iso(envelope_from);

  zc_deliver_mailt deliver_mail(m, up, envelope_to, envelope_from);

  return deliver_mail.deliver_mail();
 }


