/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <stdio.h>
#include <stdio.h>

#include <config.h>
#include <mtoolzc.h>
#include <junkerr.h>
#include <dboxversion.h>
#include <zconnect.h>
#include "junk2.h"

void dojunkposting(bool mail, zcmessaget *m, junkerrort junkerror, 
                   const char *junktext, const char *junkfrom,
                   const char *junkemp, FILE *outfile)
 {
  char tempstr[1000];

  fprintf(outfile, "ABS:\t%s@%s.%s\r\n", junkfrom, config.boxname, config.domain);

  fprintf(outfile, "BET:\t");

  if(junktext[0]!=0)
    fprintf(outfile, "%s", junktext);
  else
    fprintf(outfile, "%s", junkerrors[junkerror]);

  if(m->bet!=NULL)
   {    
    m->copyheadertext(tempstr, m->bet, 999);
    fprintf(outfile, " (war: %s)", tempstr);
   }

  fprintf(outfile, "\r\n");

  fprintf(outfile, "X-" X_DBOX "-JUNKERROR:\t%u\r\n", junkerror);

  if(junktext!=NULL && junktext[0]!=0)
    fprintf(outfile, "X-" X_DBOX "-JUNKERROR-TEXT:\t%s\r\n", junktext);

  if(junkemp!=NULL && junkemp[0]!=0)
    fprintf(outfile, "X-" X_DBOX "-JUNKERROR-EMP:\t%s\r\n", junkemp);

  if(junkfrom!=NULL && junkfrom[0]!=0)
    fprintf(outfile, "X-" X_DBOX "-JUNKERROR-FROM:\t%s\r\n", junkfrom);

  fprintf(outfile, "EDA:\t%s\r\n", make_eda_localtime().c_str());

  fprintf(outfile, "EMP:\t%s\r\n",
    mail?config.prvunzustellbar:config.brtunzustellbar);

  fprintf(outfile, "LEN:\t%lu\r\n", m->headerlen+m->len);

  fprintf(outfile, "MAILER:\tDBOX Spool vom " DBOXVERSION "\r\n");

  fprintf(outfile, "MID:\tspool.%lu.%lu@%s.%s\r\n", time(NULL),
    config.midcount, config.boxname, config.domain);

  if(config.organization[0]!=0)
    fprintf(outfile, "ORG:\t%s\r\n", config.organization);

  fprintf(outfile, "ROT:\t%s.%s\r\n", config.boxname, config.domain);

  fprintf(outfile, "STAT:\tCTL\r\n");

  fprintf(outfile, "KOM:\t%lu\r\n", m->headerlen);

  if(m->typ!=NULL)
   {
    m->copyheadertext(tempstr, m->typ, 999);
    fprintf(outfile, "TYP:\t%s\r\n", tempstr);
   }

  fprintf(outfile, "\r\n");
  m->copy(outfile);
 }
