/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <stdio.h>
#include <stdio.h>

#include <dbox.h>
#include <mtoolzc.h>
#include <junkerr.h>
#include <logf.h>
#include "spoolzcn.h"
#include "dowrite.h"
#include "junkzcn.h"

static systemt *getjunksystem()
 {
  dword nr=0;

  while(nr!=anzsystems && 
        (strcmp(systems[nr].name, config.boxname)!=0 ||
        strcmp(boxen[systems[nr].box].name, config.boxname)!=0))
    nr++;

  if(nr==anzsystems)
    return NULL;

  return systems+nr;
 }

void junkposting(zcmessaget *m, junkerrort junkerror,
                 const char *junktext, systemt *s,
                 const char *junkemp)
 {
  FILE *outfile;
  systemt *junksystem;

  junksystem=getjunksystem();
  if(junksystem==NULL)
   {
    logf.printf("junkposting", "Kein %s-Spoolverzeichnis vorhanden!",
      config.boxname);
    return;
   }

  outfile=dowrite.openfile(junksystem);
  if(outfile==NULL)
   {
    logf.printf("junkposting", "Fehler beim ffnen der Spoolfile!");
    return;
   }

  dojunkposting(FALSE, m, junkerror, junktext, s->name, junkemp, outfile);

  dowrite.closefile(outfile);
 }
