/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dbox.h>
#include <mtoolzc.h>
#include <logf.h>
#include "logmail.h"

void logmail(FILE *outfilefrom, FILE *outfileto, 
             const char *from, const char *to, 
             zcmessaget *m, const char *emp)
 {
  char text[1000], *tptr;

  if(outfilefrom==NULL) from=NULL;

  if(from!=NULL)
   {
    logf.timefprintf(outfilefrom);
    fprintf(outfilefrom, "I ");
   }

  logf.timefprintf(outfileto);
  fprintf(outfileto, "O ");

  if(from==NULL)
    fprintf(outfileto, "-intern-\t");
  else
   {
    fprintf(outfileto, "%s\t", from);
    fprintf(outfilefrom, "%s\t", to);
   }

  if(m->wab==NULL)
    m->copyheadertext(text, m->abs, 999);
  else
    m->copyheadertext(text, m->wab, 999);

  tptr=strchr(text, ' ');
  if(tptr!=NULL) *tptr=0;

  fprintf(outfileto, "%s\t", text);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", text);

  fprintf(outfileto, "%s\t", emp);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", emp);

  m->copyheadertext(text, m->mid, 999);
  fprintf(outfileto, "%s\t", text);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", text);

  fprintf(outfileto, "%lu\n", m->len+m->headerlen);
  if(from!=NULL) fprintf(outfilefrom, "%lu\n", m->len+m->headerlen);
 }
