/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dbox.h>
#include <mtoolzc.h>
#include <keys.h>
#include <asyncio.h>
#include "sdisp.h"

displayt display;

void displayt::open()
 {
  console.assign("");
  console.open();
 }

void displayt::close()
 {
  console.close();
 }

void displayt::filterstring(char *s)
 {
  while(*s!=0)
   {
    if(*s<' ' && *s>=0) *s=' ';
    s++;
   }
 }

bool displayt::checkabort()
 {
  if(console.readkey()==Key_Esc)
   {
    char ch;
    console.setcursor(1, console.sizey-2);
    console.cleareol();
    console.setcursor(1, console.sizey-1);
    console.cleareol();
    console.printf("Einsortieren wirklich abbrechen? (J/N)? ");
    do ch=upcase(lo(console.doreadkey())); while(ch!='J' && ch!='N');
    if(ch=='J') 
     {
      console.printf("J\r\n");
      return TRUE;
     }
   }
  return FALSE;
 }

bool displayt::waitload()
 {
  time_t t, starttime;
  char ch;

  console.setcursor(1, console.sizey-2);
  console.cleareol();
  console.setcursor(1, console.sizey-1);
  console.cleareol();
  console.printf("Spool angehalten wegen zu hoher Systemlast.");
  asyncio.flush_output();

  time(&starttime);

  do
   { 
    ch=upcase(lo(console.doreadkey()));
    time(&t);
   }
  while(ch!=' ' && (t-starttime)<10);

  return ch==' ';
 }

void displayt::startmail(const char *boxname, const char *username, zcmessaget *m, dword pos)
 {
  char tempstr[100];

  console.clrscr();
  console.setcursor(1, 1);

  console.printf("Daten von:  %s@%s\r\n", username, boxname);

  console.printf("Position:   %lu\r\n", pos);

  if(m->bet!=NULL)
   {
    m->copyheadertext(tempstr, m->bet, 60);
    filterstring(tempstr);
    console.printf("Betreff:    %s\r\n", tempstr);
   }

  console.printf("Gre:      %lu Bytes\r\n", m->len);

  if(m->eda!=NULL)
   {
    m->copyheadertext(tempstr, m->eda, 60);
    filterstring(tempstr);
    console.printf("Datum:      %s\r\n", tempstr);
   }

  if(m->mid!=NULL)
   {
    m->copyheadertext(tempstr, m->mid, 60);
    filterstring(tempstr);
    console.printf("Message-ID: %s\r\n", tempstr);
   }

  if(m->rot!=NULL)
   {
    m->copyheadertext(tempstr, m->rot, 60);
    filterstring(tempstr);
    console.printf("Routweg:    %s\r\n", tempstr);
   }

  if(m->abs!=NULL)
   {
    m->copyheadertext(tempstr, m->abs, 60);
    filterstring(tempstr);
    console.printf("Absender:   %s\r\n", tempstr);
   }

  console.printf("\r\n");
  console.printf("Empfnger:\r\n\r\n");

  x=1;
  first=TRUE;

  asyncio.flush_output();
 }

void displayt::docrlf()
 {
  console.printf("\r\n");
  x=1;
 }

void displayt::versenden(const char *boxname, 
                         const char *username,
                         const char *target)
 {
  char name[TEXTLEN];
  byte len;

  snprintf(name, TEXTLEN, "%s@%s", username, boxname);
  if(target!=NULL && target[0]!=0)
    snprintf(name+strlen(name), TEXTLEN-strlen(name), " (%s)", target);

  len=strlen(name);

  if(first)
    first=FALSE;
  else
   {
    console.printf(",");
    x++;
    if(x==console.sizex-3)
      docrlf();
    else
     {
      console.printf(" ");
      x++;
     }
   }

  if((x+len)>=console.sizex-3) docrlf();
  console.printf("%s", name);
  x+=len;

  asyncio.flush_output();
 }
