/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dboxpath.h>
#include <mtoolzc.h>
#include <cmdline.h>
#include <userdb.h>
#include <logf.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include "spool.h"
#include "spoolzcm.h"

static void help()
 {
  fprintf(stderr,
    "\n"
    "* * SPOOLZCM - DBOX Modul ZConnect Mail - Version " DBOXVERSIONNR " vom " DBOXVERSION " * *\n"
    "\n"
    "Aufruf:                      Aktion:\n"
    "\n"
    " spoolzcm                     Mails verteilen\n"
    "\n"
    "Weitere Optionen:\n"
    "  -b   Boxname\n"
    "  -l   Maximale Systemlast\n"
    "\n"
   );
 }

static void aufruf()
 {
  fprintf(stderr, "Falscher Aufruf!\n");
  help();
 }

static bool parseoptions(int argc, char **argv)
 {
  cmdlinet cmdline;
  const char *boxname, *maxloadarg;

  if(cmdline.parse(argc, argv, "?hb:l:"))
   {
    aufruf();
    return TRUE;
   }

  if(cmdline.isset('?') ||
     cmdline.isset('h'))
   {
    help();
    return FALSE;
   }

  boxname=cmdline.getval('b');
  if(boxname==NULL) boxname="";

  maxloadarg=cmdline.getval('l');
  if(maxloadarg!=NULL) maxload=atoi(maxloadarg);

  if(config.read(boxname))
    return TRUE;

   {
    char logfilename[DIRLEN];
    snprintf(logfilename, DIRLEN, BOXLOGDIR "spoolzcm.log", config.boxdir);
    logf.setlogfile(logfilename);
   }

  if(cmdline.argcount==0)
    dospoolzcm();
  else
    aufruf();

  return FALSE;
 }


int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR) || config.read(""))
    return 1;

  parseoptions(argc, argv);

  return 0;
 }
