/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dbox.h>
#include <dboxpath.h>
#include <config.h>
#include <logf.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <mtoolzc.h>
#include "spool.h"
#include "spoolzcn.h"
#include "crmsgid.h"

static bool parseoptions(int argc, char **argv)
 {
  int i;
  bool showconfig=FALSE, test=FALSE, crunchmsgid=FALSE, brettbestell=FALSE,
       repairmsgid=FALSE;

  for(i=1; i<argc; i++)
   {
    if(argv[i][0]!='-') goto aufruf;

    switch(tolower(argv[i][1]))
     {
     case '?':
     case 'h':
      goto help;

     case 'd':
      showconfig=TRUE;
      break;

     case 'm':
      crunchmsgid=TRUE;
      break;

     case 't':
      test=TRUE;
      break;

     case 'b':
      brettbestell=TRUE;
      break;

     case 'r':
      repairmsgid=TRUE;
      break;

     case 'l':
      maxload=atoi(argv[i]+2);
      break;

     default:
      goto aufruf;
     }
   }

   {
    char logfile[DIRLEN];
    snprintf(logfile, DIRLEN-1, DBOXSYSTEMDIR "spoolzcn.log", config.dboxdir);
    logf.setlogfile(logfile);
   }

  if(test)
    dotest();
  else if(showconfig)
    doshowconfig();
  else if(crunchmsgid)
    docrunchmsgid(FALSE);
  else if(brettbestell)
    dobrettbestell();
  else if(repairmsgid)
    docrunchmsgid(TRUE);
  else
    dospoolzcn();

  return FALSE;

 aufruf:
  fprintf(stderr, "Falscher Aufruf!\n");

 help:
  fprintf(stderr,
    "\n"
    "* * SPOOLZCN - DBOX Modul ZConnect News - Version " DBOXVERSIONNR 
    " vom " DBOXVERSION " * *\n"
    "\n"
    "Aufruf:                      Aktion:\n"
    "\n"
    " spoolzcn [-?] [-h]           Hilfe ausgeben\n"
    " spoolzcn -d                  Konfiguration anzeigen\n"
    " spoolzcn -t                  Test\n"
    " spoolzcn -m                  MSG-ID-Datenbank crunchen\n"
    " spoolzcn -r                  MSG-ID-Datenbank reparieren\n"
    " spoolzcn -b                  Brettbestellungen anzeigen\n"
    " spoolzcn                     spool/zcnews/* verteilen\n"
    "\n"
    "Weitere Optionen:\n"
    //"  -i   IBM Zeichensatz\n"
    //"  -d   Debugging on\n"
    "  -l   Maximale Systemlast\n"
    "\n"
   );

  return TRUE;
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR) || config.read(""))
    return 1;

  parseoptions(argc, argv);

  return 0;
 }
