/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include <vector.h>
#include <iterator.h>

#include <logf.h>
#include <flags.h>
#include <charsettools.h>
#include <account.h>
#include <stringtools.h>
#include <dboxpath.h>
#include <userdb.h>
#include <htmltools.h>
#include "../online/online.h"
#include "../webonline/webtools.h"

void printuserline(const userpt &up, ostream &out)
 {
  out << "<TD><A HREF=\"/admin?action=edituser&user=" << up.name
      << "\">" << up.name << "</A></TD>\n";

  out << "<TD>";

  if((up|"alias")[0]!=0)
    out << "<i>" << (up|"alias") << "</i>";
  else
   {
    string name;

    if((up|"firma")[0]!=0)
      name=up|"firma";
    else if((up|"vorname")[0]!=0)
     {
      name=up|"nachname";
      if(name!="") name+=", ";
      name+=up|"vorname";
     }
    else
      name=up|"nachname";

    htmlize_string(name);
    ibm2iso(name);
    if(name=="") out << "-"; else out << name;
   }

  out << "</TD>";

   {
    out << "<TD>";
    string address=up|"strasse";
    if((up|"ort")[0]!=0)
     {
      if(address!="") address+=", ";
      address+=up|"ort";
     }
    htmlize_string(address);
    ibm2iso(address);
    if(address=="") out << "-"; else out << address;
    out << "</TD>";
   }

  out << "</TR>\n";
 }

void printuserline(const string &user, ostream &out)
 {
  userpt up;
  up.setname(user);
  up.read();
  printuserline(up, out);
 }

bool usermatch(const userpt &up, const string &mask)
 {
  string name;
  if(checkjoker(mask.c_str(), up.name, TRUE)) return TRUE;
  name+=up|"firma";
  name+=' ';
  name+=up|"vorname";
  name+=' ';
  name+=up|"nachname";
  if(checkjoker(mask.c_str(), name.c_str(), TRUE)) return TRUE;
  if(checkjoker(mask.c_str(), up|"Strasse", TRUE)) return TRUE;
  if(checkjoker(mask.c_str(), up|"Ort", TRUE)) return TRUE;
  return FALSE;
 }

void finduser(httpt &http, ostream &out)
 {
  startpage(out, "Userliste");

  out << 
    "<CENTER><TABLE>\n"
    "<TR bgcolor=\"" << config.webonline_thbgcolor << "\">"
    "<TH><font color=\"" << config.webonline_thfcolor << "\">Benutzername</font>"
    "<TH><font color=\"" << config.webonline_thfcolor << "\">Name/Alias</font>"
    "<TH><font color=\"" << config.webonline_thfcolor << "\">Anschrift</font>"
    "\n";

  bool bg=FALSE, fulltext=FALSE;
  unsigned long max;
  string mask;

   {
    const char *max_ptr=http.getparameter("max");
    const char *mask_ptr=http.getparameter("mask");
    if(max_ptr==NULL) max=100; else max=atol(max_ptr);
    if(mask_ptr==NULL) mask_ptr="*";
    mask="*";
    if(mask_ptr[0]=='*')
      mask+=(mask_ptr+1);
    else
      mask+=mask_ptr;
    if(mask[mask.size()-1]!='*') mask+='*';
   }

  if(http.getparameter("fulltext")!=NULL)
    fulltext=TRUE;

  vector<string> user;

  getuserlist(user, fulltext?"*":mask);

  if(fulltext)
   {
    for(vector<string>::iterator it=user.begin();
        it!=NULL && max>0; it++)
     {
      userpt up;
      up.setname(*it);
      up.read();
      if(usermatch(up, mask))
       {
        out << "<TR bgcolor=\"" << 
          (bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2) <<
          "\">";

        bg^=1;
        max--;

        printuserline(up, out);
       }
     }
   }
  else
   {
    for(vector<string>::iterator it=user.begin();
        it!=NULL && max>0; it++, max--, bg^=1)
     {
      out << "<TR bgcolor=\"" << 
        (bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2) <<
        "\">";
      printuserline(*it, out);
     }
   }

  out << "</TABLE></CENTER>\n";

  endpage(out);
 }


