/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "webadmin.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="webadmin.log";
    logf.setlogfile(logfile);
   }

  dowebadmin();
 
  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * WEBADMIN - DBOX Module - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " webadmin [-?] [-h]           Display help\n"
    " webadmin                     Webadmin server\n"
    "\n"
    "Additional options:\n"
    " -bboxname\r\n"
    "\r\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
