#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>

#include <account.h>
#include <dboxpath.h>
#include <logf.h>
#include "../../online/userlog.h"
#include "../ostatus.h"
#include "../webtools.h"
#include "handshake.h"

void doeinstellungen(httpt &http)
 {
  char title[TEXTLEN*2];
  const char *tarif;

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  printf("<table>\n");
  printf("<tr><td colspan=2><hr>\n");

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, "pauschal")==0 ||
     stricmp(tarif, "2dm")==0)
   {
    printf("<tr><td>Rufnummer:<td>0681-3897272 (geeignet fr Sondertarife)\n");
    printf("<tr><td>Proxy:<td>www-proxy.hs-sb.handshake.de Port 80\n");
    printf("<tr><td><td>no proxy: handshake.de\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.hs-sb.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");

    printf("<tr><td colspan=2><hr>\n");
    printf("<tr><td>Rufnummer:<td>01024-01924671 (bundesweit Citytarif, nicht geeignet fr Sondertarife)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.hs-sb.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, "saarsurf")==0)
   {
    printf("<tr><td>Rufnummer:<td>0681-9506 (geeignet fr Sondertarife)\n");
    printf("<tr><td>          <td>06824-931940 (geeignet fr Sondertarife)\n");
    printf("<tr><td>Proxy:<td>kein Proxy\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.hs-sb.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, "5plusGDI")==0)
   {
    printf("<tr><td>Rufnummer 5PlusGDI:<td>0800-6383220 (bundesweit, gebhrenfrei)\n");
    printf("<tr><td>Rufnummer 5PlusSAAR:<td>01033-0192378 (nur im Saarland, gebhrenfrei)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, "ipstd0800")==0)
   {
    printf("<tr><td>Rufnummer:<td>0800-6383220 (bundesweit, gebhrenfrei)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, "10plus")==0 ||
          stricmp(tarif, "ipstdafod")==0)
   {
    printf("<tr><td>Rufnummer:<td>01033-0192378 (nur im Saarland, gebhrenfrei im Netz der Telekom)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }
  else if(stricmp(tarif, "5plus")==0 ||
          stricmp(tarif, "55pf")==0)
   {
    printf("<tr><td>Rufnummer:<td>01033-0192378 (gebhrenfrei, nur im Saarland)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.hs-sb.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");

    printf("<tr><td colspan=2><hr>\n");
    printf("<tr><td>Rufnummer:<td>0800-6383220 (bundesweit, gebhrenfrei)\n");
    printf("<tr><td>Proxy:<td>kein Proxy (direkte Internetverbindung)\n");
    printf("<tr><td>Mail:<td>mail.handshake.de\n");
    printf("<tr><td>News:<td>news.hs-ffm.handshake.de\n");
    printf("<tr><td>POP3:<td>pop3.handshake.de\n");
   }

  printf("<tr><td colspan=2><hr>\n");
  printf("</table>\n");

  printf("<a href=\"/handshake?action=tarif\"><p>Zurck\n");

  endpage();
 }

void doanmeldung2(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  const char *tarif, *action2;
  byte tarifnr;  // 0 pauschal 1 5plus 2 Saarsurf 3 5PlusGDI 4 10Plus
  bankpt bp(status.username);

  bp.read();

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, "pauschal")==0)
    tarifnr=0;
  else if(stricmp(tarif, "5plus")==0)
    tarifnr=1;
  else if(stricmp(tarif, "saarsurf")==0)
    tarifnr=2;
  else if(stricmp(tarif, "5plusGDI")==0)
    tarifnr=3;
  else if(stricmp(tarif, "10plus")==0)
    tarifnr=4;
  else if(stricmp(tarif, "hs_std55_tarif")==0)
    tarifnr=5;
  else
    return;

  printf("Hinweis: ");

  switch(tarifnr)
   {
   case 0:
    printf("Pauschaltarif");
    status.userprofile.get("hs_tarif", hs_tarif);
    status.userprofile.get("hs_tarif_neu", hs_tarif_neu);
    break;
 
   case 1:
    printf("5Plus");
    status.userprofile.get("hs_5plus_tarif", hs_tarif);
    status.userprofile.get("hs_5plus_tarif_neu", hs_tarif_neu);
    break;

   case 2:
    printf("SaarSurf");
    status.userprofile.get("hs_saarsurf_tarif", hs_tarif);
    hs_tarif_neu[0]=0;
    break;

   case 3:
    printf("5PlusGDI");
    status.userprofile.get("hs_5plusGDI_tarif", hs_tarif);
    status.userprofile.get("hs_5plusGDI_tarif_neu", hs_tarif_neu);
    break;

   case 4:
    printf("10Plus");
    status.userprofile.get("hs_10plus_tarif", hs_tarif);
    status.userprofile.get("hs_10plus_tarif_neu", hs_tarif_neu);
    break;

   case 5:
    status.userprofile.get("hs_std55_tarif", hs_tarif);
    status.userprofile.get("hs_std55_tarif", hs_tarif_neu);
    break;
   }

  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  printf("\n");

  action2=http.getparameter("action2");
  if(action2==NULL) return;

  if(stricmp(action2, "anmelden")==0)
   {
    if(atoi(hs_tarif_neu))
      printf(" ist bereits angemeldet!\n");
    else
     {
      if(!atoi(bp|"automatisch_abbuchen") || !atoi(bp|"einzugsermaechtigung"))
        printf(" konnte nicht angemeldet werden, da uns noch keine "
               "Einzugsermchtigung vorliegt!<p>\n"
               "Bitte senden Sie uns das entsprechende Formular.\n");
      else
       {
        if(!status.userprofile.lock())
         {
          switch(tarifnr)
           {
           case 0: status.userprofile.set("hs_tarif_neu", "1"); break;
           case 1: status.userprofile.set("hs_5plus_tarif_neu", "1"); break;
           case 3: status.userprofile.set("hs_5plusGDI_tarif_neu", "1"); break;
           case 4: status.userprofile.set("hs_10plus_tarif_neu", "1"); break;
           }
 
          status.userprofile.write();
          status.userprofile.unlock();

          printf(" ist zum nchsten Monatsersten angemeldet!\n");

          userlogprintf1(status, "handshake", "%s angemeldet", tarif);
         }
        else
          printf(": Vorgang fehlgeschlagen\n");
       } 
     }
   }
  else if(stricmp(action2, "sofortanmelden")==0)
   {
    if(atoi(hs_tarif))
      printf(" ist bereits aktiv!\n");
    else
     {
      if(!atoi(bp|"automatisch_abbuchen") || !atoi(bp|"einzugsermaechtigung"))
        printf(" konnte nicht angemeldet werden, da uns noch keine "
               "Einzugsermchtigung vorliegt!<p>\n"
               "Bitte senden Sie uns das entsprechende Formular.\n");
      else
       {
        if(!status.userprofile.lock())
         {
          switch(tarifnr)
           {
           case 0: status.userprofile.set("hs_tarif_neu", ""); 
                   status.userprofile.set("hs_tarif", "1"); break;
           case 1: status.userprofile.set("hs_5plus_tarif_neu", "");
                   status.userprofile.set("hs_5plus_tarif", "1"); break;
           case 2: status.userprofile.set("hs_saarsurf_tarif", "1"); break;
           case 3: status.userprofile.set("hs_5plusGDI_tarif_neu", "");
                   status.userprofile.set("hs_5plusGDI_tarif", "1"); break;
           case 4: status.userprofile.set("hs_10plus_tarif_neu", "");
                   status.userprofile.set("hs_10plus_tarif", "1"); break;
           }

          status.userprofile.write();
          status.userprofile.unlock();

          if(tarifnr!=2)
           {
            char command[1000];
            snprintf(command, 1000, "export HOME=%s; echo %s | "
                             "~/tools/hs_beitrag -t%d "
                             "> /dev/null", 
                             config.dboxdir,
                             status.username, tarifnr);
            system(command);
           }

          printf(" ist ab sofort nutzbar!\n");

          userlogprintf1(status, "handshake", "%s sofort angemeldet", tarif);
         }
        else
          printf(": Vorgang fehlgeschlagen\n");
       }
     }
   }
  else if(stricmp(action2, "abmelden")==0)
   {
    if(!atoi(hs_tarif_neu))
      printf(" ist bereits abgemeldet!\n");
    else
     {
      if(!status.userprofile.lock())
       {
        switch(tarifnr)
         {
         case 0: status.userprofile.set("hs_tarif_neu", "0"); break;
         case 1: status.userprofile.set("hs_5plus_tarif_neu", "0"); break;
         case 3: status.userprofile.set("hs_5plusGDI_tarif_neu", "0"); break;
         case 4: status.userprofile.set("hs_10plus_tarif_neu", "0"); break;
         case 5: status.userprofile.set("hs_std55_tarif", "0"); break;
         }

        status.userprofile.write();
        status.userprofile.unlock();

        if(tarifnr==5)
          printf("Sie sind ab sofort umgemeldet!\n");
        else  
          printf(" ist zum nchsten Monatsersten abgemeldet!\n");

        userlogprintf1(status, "handshake", "%s abgemeldet", tarif);
       }
      else
        printf(": Vorgang fehlgeschlagen!\n");
     }
   }
  else
   {
    printf("?\n");
   }

  printf("<a href=\"/handshake?action=tarif\"><p>Zurck\n");

  endpage();
 }

#if 0
void flatrate_bed()
 {
  printf("<b>Nutzungsbedingungen:</b>\n"
         "<ul>\n"
         "<li>Das Angebot ist befristet bis zum <b>30.9.99</b>. Es \n"
         "    wird in jedem Fall der volle Monatsbetrag von 75 DM,\n"
         "    auch nach Anmeldung nach dem 1.9.99.<p>\n"
         "\n"
         "<li>Das Angebot steht nur Vereinsmitgliedern zur Verfgung,\n"
         "    die auch den Mitgliedsbeitrag vollstndig bezahlen.\n"
         "    Bei Anmeldung zur Flatrate im September ist keine \n"
         "    Rckerstattung des Mitgliedsbeitrags mglich. Wenn Sie \n"
         "    die Rckerstattung des Mitgliedsbeitrags wnschen, drfen \n"
         "    Sie sich nicht anmelden.<p>\n"
         "\n"
         "<li>Es besteht das Risiko, da wir durch regulatorische \n"
         "    Eingriffe das Angebot kurzfristig vor dem 30.9.99 \n"
         "    einstellen mssen. In diesem Fall wird die Monatspauschale \n"
         "    von 75 DM anteilig zurckerstattet. Der Mitgliedsbeitrag \n"
         "    wird jedoch nach Anmeldung generell nicht zurckerstattet.<p>\n"
         "\n"
         "<li>Die Pauschale gilt in der Zeit von 21-9 Uhr. Wenn die \n"
         "    Verbindung nach 9 Uhr bestehen bleibt, werden fr die \n"
         "    Einwahl 5.5 Pf/Min berechnet.<p>\n"
         "\n"
         "<li>Die Flatrate gilt nur bei Einwahl ber die Rufnummer \n"
         "    01804-192378, nicht ber andere Rufnummern. Auf anderen \n"
         "    werden der Rufnummer entsprechende Telefongebhren \n"
         "    berechnet. Weiterhin ist zu beachten, da der Tarif von \n"
         "    48 Pf pro Verbindung nur bei Einwahl ber die Telekom \n"
         "    gilt. Erkundigen Sie sich bei Ihrer \n"
         "    Telefongesellschaft ber die aktuellen Tarife.<p>\n"
         "\n"
         "<li>Um eine berlastung zu vermeiden, ist die Zahl der Nutzer \n"
         "    begrenzt. Die Zugnge werden in der Reihenfolge der \n"
         "    Anmeldung vergeben.<p>\n"
         "\n"
         "<li><b>Die Anmeldung kann nicht widerrufen werden</b>, bitte \n"
         "    die Bedingungen vor der Anmeldung grndlich lesen.<p>\n"
         "</ul><p>\n");
 }
#endif

void doanmeldung(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  const char *tarif;
  byte tarifnr;  // 0 pauschal 1 5plus 2 saarsurf 3 5plusGDI 4 10plus
  char link[1000];

  tarif=http.getparameter("tarif");
  if(stricmp(tarif, "pauschal")==0)
    tarifnr=0;
  else if(stricmp(tarif, "5plus")==0)
    tarifnr=1;
  else if(stricmp(tarif, "saarsurf")==0)
    tarifnr=2;
  else if(stricmp(tarif, "5plusGDI")==0)
    tarifnr=3;
  else if(stricmp(tarif, "10plus")==0)
    tarifnr=4;
  else if(stricmp(tarif, "hs_std55_tarif")==0)
    tarifnr=5;
  else
    return;

  snprintf(link, 1000, "/handshake?action=tarifanmeldung2&tarif=%s", tarif);

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  printf("<table>\n"
         "<tr><th>Tarif:<td>");

  switch(tarifnr)
   {
   case 0:
    printf("Pauschal");
    status.userprofile.get("hs_tarif", hs_tarif);
    status.userprofile.get("hs_tarif_neu", hs_tarif_neu);
    break;
 
   case 1:
    printf("5Plus");
    status.userprofile.get("hs_5plus_tarif", hs_tarif);
    status.userprofile.get("hs_5plus_tarif_neu", hs_tarif_neu);
    break;

   case 2:
    printf("SaarSurf");
    status.userprofile.get("hs_saarsurf_tarif", hs_tarif);
    hs_tarif_neu[0]=0;
    break;

   case 3:
    printf("5PlusGDI");
    status.userprofile.get("hs_5plusGDI_tarif", hs_tarif);
    status.userprofile.get("hs_5plusGDI_tarif_neu", hs_tarif_neu);
    break;

   case 4:
    printf("10Plus");
    status.userprofile.get("hs_10plus_tarif", hs_tarif);
    status.userprofile.get("hs_10plus_tarif_neu", hs_tarif_neu);
    break;
   }

  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  printf("\n");

  if(tarifnr==2)
   {
    printf("</table>\n");

    if(atoi(hs_tarif))
     {
      printf("<p>Sie sind bereits angemeldet. Der Zugang kann ab sofort "
             "genutzt werden.<p>\n");
     }
    else
     {
      printf("<a href=\"%s&action2=sofortanmelden\">Anmelden</a><p>\n",
             link);
     }

    endpage();
    return;
   }

  printf("<tr><td colspan=2><hr><tr><th>Status:<td>");

  if(atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("aktiv");
  else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("gekndigt zum Monatsende");     
  else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("beantragt zum nchsten Monatsanfang");
  else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("nicht aktiv");

  printf("<tr><td colspan=2><hr><tr><th>Aktionen:<td>");

  printf("<a href=\"/handshake?action=tarif\">a) Zurck</a><br>\n");

  if(atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("<a href=\"%s&action2=abmelden\">b) Abmelden</a>", link);
  else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("<a href=\"%s&action2=anmelden\">b) Wieder anmelden</a>", link);
  else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
   {
    printf("<a href=\"%s&action2=sofortanmelden\">b) Sofort Anmelden</a> "
           "(der volle Monatsbetrag wird <b>sofort belastet</b>,<br><b>keine Rckerstattung</b> von Teilbetrgen!)<br>", link);

    printf("<a href=\"%s&action2=abmelden\">c) Wieder abmelden</a>", link);
   }
  else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
   {
    printf("<a href=\"%s&action2=sofortanmelden\">b) Sofort Anmelden</a> "
           "(der volle Monatsbetrag wird <b>sofort belastet</b>,<br><b>keine Rckerstattung</b> von Teilbetrgen!)<br>", link);

    printf("<a href=\"%s&action2=anmelden\">c) Zum nchsten Monatsanfang anmelden</a>", link);
   }

  printf("\n");

  printf("</table>\n");

  printf("<p>Achtung: Die Grundgebhr wird auch bei \"angebrochenen\" Monaten voll berechnet.<br>"
         "Beantragen Sie daher im Zweifelsfall den jeweiligen Tarif zum nchsten Monatsersten.<p>");

  endpage();
 }

void dotarif(httpt &http)
 {
  char title[TEXTLEN*2], hs_tarif[TEXTLEN], hs_tarif_neu[TEXTLEN];
  bool bg=FALSE;

  snprintf(title, TEXTLEN*2, "Tarifmanager fr User %s", status.username);
  startpage(title);
  printf("<h2>%s</h2><p>\n\n", title);

  printf("<table>\n"
         "<tr bgcolor=\"%s\">\n"
         "<th><font color=\"%s\">Tarif</font>\n"
         "<th><font color=\"%s\">Status</font>\n"
         "<th><font color=\"%s\">Grundgebhr<br>pro Monat\n"
         "<th><font color=\"%s\">Beschreibung</font>\n",
         config.webonline_thbgcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor,
         config.webonline_thfcolor);

  //
  // 5.5 Pf
  //

  status.userprofile.get("hs_std55_tarif", hs_tarif);
  if(atoi(hs_tarif))
   {
    printf("<tr bgcolor=\"%s\">",
      bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

    bg^=1;

    printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/zeittarif.html\">5.5 Pf/Min</a>\n");
    printf("<td align=center><img src=\"/html/icons/ok.gif\"> verfgbar\n");
    printf("<td align=center>gratis\n");
    printf("<td>Zeittarif, 5.5 Pf/Min ganztags inkl. Telefongebhren<br>\n"
           "(gebhrenfreie Rufnummer, bundesweit verfgbar)<br>\n"
           "<a href=\"/handshake?action=einstellungen&tarif=55pf\">Einstellungen</a>\n");
   }

  //
  // 2.9 + 5 Pf/Einwahl
  //

  status.userprofile.get("hs_std55_tarif", hs_tarif);

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/zeittarif.html\">2.9 Pf/Min</a>\n");

  printf("<td align=center>\n");

  if(!atoi(hs_tarif))
    printf("<img src=\"/html/icons/ok.gif\"> aktiv");
  else 
   {
    printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");
    printf("<br><a href=\"/handshake?action=tarifanmeldung2&tarif=hs_std55_tarif&action2=abmelden\">jetzt anmelden</a>\n");
   }

  printf("<td align=center>gratis\n");
  printf("<td>Zeittarif, 2.9 Pf/Min ganztags inkl. Telefongebhren<br>\n"
         "zzgl. 5 Pf pro Einwahl<br>"
         "(gebhrenfreie Rufnummer, saarlandweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=ipstdafod\">Einstellungen</a>\n");

  //
  // 3.9 + 5 Pf/Einwahl
  //

  status.userprofile.get("hs_std55_tarif", hs_tarif);

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/zeittarif.html\">3.9 Pf/Min</a>\n");

  printf("<td align=center>\n");

  if(!atoi(hs_tarif))
    printf("<img src=\"/html/icons/ok.gif\"> aktiv");
  else 
   {
    printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");
    printf("<br><a href=\"/handshake?action=tarifanmeldung2&tarif=hs_std55_tarif&action2=abmelden\">jetzt anmelden</a>\n");
   }

  printf("<td align=center>gratis\n");
  printf("<td>Zeittarif, 3.9 Pf/Min ganztags inkl. Telefongebhren<br>\n"
         "zzgl. 5 Pf pro Einwahl<br>\n"
         "(gebhrenfreie 0800 Rufnummer, bundesweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=ipstd0800\">Einstellungen</a>\n");

  //
  // 2 DM/h
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center>2 DM/Stunde\n");
  printf("<td align=center><img src=\"/html/icons/ok.gif\"> verfgbar\n");
  printf("<td align=center>gratis\n");
  printf("<td>Zeittarif, 2 DM pro Stunde ganztags zzgl. Telefongebhren<br>\n"
         "(Abrechnung sekundengenau, bundesweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=2dm\">Einstellungen</a>\n");

  //
  // Pauschal
  //

  status.userprofile.get("hs_tarif", hs_tarif);
  status.userprofile.get("hs_tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  if(atoi(hs_tarif))
   {
    printf("<tr bgcolor=\"%s\">",
      bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

    bg^=1;

    printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/pauschaltarif.html\">Pauschal</a>\n");
    printf("<td align=center>");

    if(atoi(hs_tarif) && atoi(hs_tarif_neu))
      printf("<img src=\"/html/icons/ok.gif\"> aktiv");
    else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
      printf("gekndigt zum<br>Monatsende");     
    else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
      printf("beantragt zum<br>nchsten Monatsanfang");
    else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
      printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");

    printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=pauschal\">An/Abmeldung</a>\n");

    printf("<td align=center>19 DM\n");

    printf("<td>Zeittarif zzgl. Telefongebhren<br>"
           "19 DM monatlich fr 50 Freistunden, jede weitere Stunde 2 DM<br>"
           "(Abrechnung sekundengenau, bundesweit verfgbar)<br>\n"
           "<a href=\"/handshake?action=einstellungen&tarif=pauschal\">Einstellungen</a>\n");
   }
 
  //
  // SaarSurf
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/local/aktuell/21pfg.html\">SaarSurf</a>\n");

  printf("<td align=center>\n");

  status.userprofile.get("hs_saarsurf_tarif", hs_tarif);

  if(atoi(hs_tarif))
   {
    printf("<img src=\"/html/icons/ok.gif\"> aktiv");
    printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=saarsurf\">Status</a>\n");
   }
  else 
   {
    printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");
    printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=saarsurf\">Anmeldung</a>\n");
   }

  printf("<td align=center>gratis\n");

  printf("<td>Internet mit Abrechnung ber Telefonrechnung<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=saarsurf\">Einstellungen</a>\n");

  //
  // 5Plus
  //

  status.userprofile.get("hs_5plus_tarif", hs_tarif);
  status.userprofile.get("hs_5plus_tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  if(atoi(hs_tarif))
   {
    printf("<tr bgcolor=\"%s\">",
      bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

    bg^=1;

    printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/5plus.html\">5Plus</a>\n");

    printf("<td align=center>\n");

    if(atoi(hs_tarif) && atoi(hs_tarif_neu))
      printf("<img src=\"/html/icons/ok.gif\"> aktiv");
    else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
      printf("gekndigt zum<br>Monatsende");     
    else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
      printf("beantragt zum<br>nchsten Monatsanfang");
    else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
      printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");

    printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=5plus\">An/Abmeldung</a>\n");

    printf("<td align=center>5 DM\n");

    printf("<td>Zeittarif, <b>3.9 Pf/Min</b> ganztags inkl. Telefongebhren<br>\n"
           "(gebhrenfreie Rufnummer, bundesweit verfgbar)<br>\n"
           "<a href=\"/handshake?action=einstellungen&tarif=5plus\">Einstellungen</a>\n");
   }

  //
  // 5PlusGDI / 5PlusSAAR
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/5plussaar.html\">5PlusSAAR</a>\n");
  printf("<br><hr>\n");
  printf("<a href=\"http://www.handshake.de/handshake/angebot/5plusgdi.html\">5PlusGDI</a>\n");

  printf("<td align=center>\n");

  status.userprofile.get("hs_5plusGDI_tarif", hs_tarif);
  status.userprofile.get("hs_5plusGDI_tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  if(atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("<img src=\"/html/icons/ok.gif\"> aktiv");
  else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("gekndigt zum<br>Monatsende");     
  else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("beantragt zum<br>nchsten Monatsanfang");
  else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");

  printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=5plusGDI\">An/Abmeldung</a>\n");

  printf("<td align=center>5 DM\n");

  printf("<td><b>5PlusSAAR</b>: Zeittarif, <b>2.9 Pf/Min</b> rund um die Uhr inkl. Telefongebhren<br>\n"
         "(gebhrenfreie Rufnummer, saarlandweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=5plusGDI\">Einstellungen</a>\n"
         "<hr>\n"
         "<b>5PlusGDI</b>: Zeittarif, <b>2.9 Pf/Min</b> 18-6 Uhr, 3.9 Pf/Min 6-18 Uhr, inkl. Telefongebhren<br>\n"
         "(gebhrenfreie Rufnummer, bundesweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=5plusGDI\">Einstellungen</a>\n");

  //
  // 10Plus
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/10plus.html\">10Plus</a>\n");

  printf("<td align=center>\n");

  status.userprofile.get("hs_10plus_tarif", hs_tarif);
  status.userprofile.get("hs_10plus_tarif_neu", hs_tarif_neu);
  if(hs_tarif_neu[0]==0) strmaxcpy(hs_tarif_neu, hs_tarif, TEXTLEN-1);

  if(atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("<img src=\"/html/icons/ok.gif\"> aktiv");
  else if(atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("gekndigt zum<br>Monatsende");     
  else if(!atoi(hs_tarif) && atoi(hs_tarif_neu))
    printf("beantragt zum<br>nchsten Monatsanfang");
  else if(!atoi(hs_tarif) && !atoi(hs_tarif_neu))
    printf("<img src=\"/html/icons/notok.gif\"> nicht aktiv");

  printf("<br><a href=\"/handshake?action=tarifanmeldung&tarif=10plus\">An/Abmeldung</a>\n");

  printf("<td align=center>10 DM\n");

  printf("<td>Zeittarif, <b>1.9 Pf/Min</b> rund um die Uhr inkl. Telefongebhren<br>\n"
         "(gebhrenfreie Rufnummer, saarlandweit verfgbar)<br>\n"
         "<a href=\"/handshake?action=einstellungen&tarif=10plus\">Einstellungen</a>\n"
         "\n");

  //
  // Pulsaar Flatrate
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/flatrate.html\">Flatrate</a>\n");

  printf("<td align=center>\n");

  printf("-");

  printf("<td align=center>69 DM\n");

  printf("<td>Flatrate, inkl. Telefongebhren<br>\n"
         "1 Jahr Mindestlaufzeit<br>\n"
         "(gebhrenfreie Rufnummer, verfgbar im Pulsaar Netz)\n");

  //
  // Pulsaar Flatrate
  //

  printf("<tr bgcolor=\"%s\">",
    bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

  bg^=1;

  printf("<td align=center><a href=\"http://www.handshake.de/handshake/angebot/flatrate.html\">Flatrate</a>\n");

  printf("<td align=center>\n");

  printf("-");

  printf("<td align=center>99 DM\n");

  printf("<td>Flatrate, inkl. Telefongebhren<br>\n"
         "1 Monat Mindestlaufzeit<br>\n"
         "(gebhrenfreie Rufnummer, verfgbar im Pulsaar Netz)\n");

  //
  // Ende
  //

  printf("</table>\n");

  printf("<p>");

  endpage();
 }

void doflatrate(httpt &http)
 {
  startpage("Handshake Flatrate");

  cout << "<center><h2><u>Handshake Flatrate</u></h2></center><p>\n\n";

  if(strncmp(status.userprofile|"telefon", "0681", 4)!=0)
   {
    cout << "Fehler:<p>\n"
            "Eine Registrierung ist nur dann mglich, wenn Sie\r\n" 
            "einen Telefonanschlu im Stadtgebiet Saarbrcken\r\n"
            "(Vorwahl 0681) haben.\r\n";
   }
  else
   {
    cout << "Vielen Dank fr Ihre Registrierung.<p>\r\n" 
            "Wir werden Ihnen die Flatrate-Unterlagen per Post\r\n"
            "zusenden.\r\n";

    char logfilename[DIRLEN];
    snprintf(logfilename, DIRLEN, BOXLOGDIR "flatrate.log", config.boxdir);
    logf.fileprintf(logfilename, "flatrate", "%s", status.username);
   }

  endpage();
 }

void dohandshake(httpt &http)
 {
  const char *action;

  action=http.getparameter("action");
  if(action==NULL) return;

  if(stricmp(action, "tarif")==0)
    dotarif(http);
  else if(stricmp(action, "tarifanmeldung")==0)
    doanmeldung(http);
  else if(stricmp(action, "tarifanmeldung2")==0)
    doanmeldung2(http);
  else if(stricmp(action, "einstellungen")==0)
    doeinstellungen(http);
  else if(stricmp(action, "flatrate")==0)
    doflatrate(http);
  else if(stricmp(action, "test")==0)
   { startpage("Test"); cout << config.webonline_thbgcolor; }
 }

