/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>

#include <dboxpath.h>
#include <tools.h>
#include <folder.h>
#include <charsettools.h>
#include <stringtools.h>
#include <htmltools.h>
#include <nls.h>

#include "ostatus.h"
#include "webtools.h"
#include "webmail.h"
#include "challenge.h"

void webmailt::delete_mail()
 {
  if(verify_challenge(http.getparameter("challenge"), status.userprofile))
    return;

  if(getrfc.fp.lock())
   {
    startpage(out, nls.get("webonline.mail.delete"));
    out << nls.get("webonline.mailbox.notavailable") << "\n";
    showcopyright();
    endpage();
    return;
   }

  dword nr;
  string msg_id;

  if(get_msg_nr(nr, msg_id))
    return;

  lseek(getrfc.index, nr*sizeof getrfc.fi, SEEK_SET);
  read(getrfc.index, &getrfc.fi, sizeof getrfc.fi);

  getrfc.fi.flags.deleted^=1;

  lseek(getrfc.index, nr*sizeof getrfc.fi, SEEK_SET);
  write(getrfc.index, &getrfc.fi, sizeof getrfc.fi);

  getrfc.fp.unlock();

   {
    const char *ptr;
    string url=http.url;

    if((ptr=http.getparameter("sort"))!=NULL)
      url+="?sort="+string(ptr);
    else
      url+="?sort=date";

    if((ptr=http.getparameter("start_nr"))!=NULL)
      url+="&start_nr="+string(ptr);
    if((ptr=http.getparameter("end_nr"))!=NULL)
      url+="&end_nr="+string(ptr);
    if((ptr=http.getparameter("mailbox"))!=NULL)
      url+="&mailbox="+string(ptr);
    if((ptr=http.getparameter("reverse"))!=NULL)
      url+="&reverse="+string(ptr);
    
    redirect(out, url);
   }
 }
