/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>

#include <account.h>
#include <charsettools.h>
#include <oldtools.h>
#include "ostatus.h"
#include "webtools.h"
#include "http.h"

void dokonto(httpt &http)
 {
  char title[TEXTLEN*2], tempstr[TEXTLEN], filename[DIRLEN];
  const char *filter;
  buchungt buchung;
  bool bg=FALSE;
  FILE *infile;
  struct tm *tm;
  word jahr=0, monat=0;

  snprintf(filename, DIRLEN, "%skonto", status.userprofile.getpath());
  infile=fopen(filename, "rt");

  snprintf(title, TEXTLEN*2, "Kontoausz&uuml;ge von User %s", status.username);
  startpage(title);
  printf("<H1>%s</H1><p>\n", title);
  
  filter=http.getparameter("Jahr");  if(filter!=NULL) jahr=atoi(filter);
  filter=http.getparameter("Monat"); if(filter!=NULL) monat=atoi(filter);

  if(jahr!=0 && monat!=0)
   {
    currency_string(tempstr, getbalance(&status.userprofile), TRUE);

    printf("<table>\n"
           "<tr><td align=right>Aktueller Kontostand:<td>%s\n", tempstr);
    printf("<tr><td align=right>Konto&uuml;berzug erlaubt:<td>%s\n", 
           noyes1(atoi(status.userprofile|"kontoueberzug")));
    printf("</table>\n");

    printf("<table cellpadding=\"2\" cellspacing=\"0\">\n"
           "<tr bgcolor=\"%s\">"
           "<th><font color=\"%s\">Nr.</font>"
           "<th><font color=\"%s\">Datum</font>"
           "<th><font color=\"%s\">Betrag</font>"
           "<th><font color=\"%s\">MwSt</font>"
           "<th><font color=\"%s\">Verwendungszweck</font>\n",
           config.webonline_thbgcolor,
           config.webonline_thfcolor,
           config.webonline_thfcolor,
           config.webonline_thfcolor,
           config.webonline_thfcolor,
           config.webonline_thfcolor);
  
    if(infile!=NULL)
     {
      while(!buchung.read(infile))
       {
        tm=localtime(&buchung.datum);

        if((tm->tm_mon+1)==monat && (tm->tm_year+1900)==jahr)
         {
          printf("<tr bgcolor=\"%s\">", 
            bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

          bg^=1;

          printf("<td align=right>%lu<td align=center>%02u.%02u.%u",
               buchung.number,
               tm->tm_mday, tm->tm_mon+1, tm->tm_year+1900);
        
          currency_string(tempstr, buchung.amount, TRUE);

          printf("<td align=right>%c%s", buchung.haben?'+':'-', 
            tempstr);
 
          printf("<td align=right>%lu,%lu%%", buchung.mwstsatz/10, buchung.mwstsatz%10);
 
          ibm2iso(buchung.verwendungszweck, strlen(buchung.verwendungszweck));

          printf("<td>%s\n", buchung.verwendungszweck);
         }
       }
     }

    printf("</table>\n");
   }
  else
   {
    cout << "<center>\n";
    printf("<table cellpadding=\"2\" cellspacing=\"0\">\n"
           "<tr bgcolor=\"%s\">"
           "<th><font color=\"%s\">Jahr</font>"
           "<th><font color=\"%s\">Monat</font>"
           "\n",
           config.webonline_thbgcolor,
           config.webonline_thfcolor,
           config.webonline_thfcolor);
  
    if(infile!=NULL)
     {
      while(!buchung.read(infile))
       {
        tm=localtime(&buchung.datum);

        if((tm->tm_mon+1)!=monat || (tm->tm_year+1900)!=jahr)
         {
          monat=tm->tm_mon+1;
          jahr=tm->tm_year+1900;
          printf("<tr bgcolor=\"%s\">",
            bg?config.webonline_tablebgcolor1:config.webonline_tablebgcolor2);

          bg^=1;

          printf("<td align=center>%u"
                 "<td align=center><a href=\"/konto?jahr=%u&monat=%u\">%u</a>\n", 
                 jahr, jahr, monat, monat);
         }
       }
     }
    cout << "</table>\n";
    cout << "</center>\n";
   }

  if(infile!=NULL) fclose(infile);

  showcopyright();
  endpage();
 }
