/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "webonline.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();

  parseoptionst():parseoptions_baset("(secure)(preauth):") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="webonline.log";
    logf.setlogfile(logfile);
   }

  dowebonline(cmdline);
 
  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * WEBONLINE - DBox Module - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " webonline [-?] [-h]          Display help\n"
    " webonline                    Webonline server\n"
    "\n"
    "Additional options:\n"
    " --secure                     secure-mode: disable all functions\n"
    "                              which require authentication\n"
    " --allow SERVICE              only allow the given services\n"
    " --preauth user               pre-authenticate as the given user\n"
    " -b boxname\r\n"
    "\r\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
