/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: change password of main account

*/

#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include <dboxpath.h>
#include <logf.h>
#include <charsettools.h>
#include <account.h>
#include "../online/userlog.h"
#include "ostatus.h"
#include "challenge.h"
#include "webonline.h"
#include "webtools.h"

void dopassword(httpt &http, ostream &out)
 {
  const char *newpass1, *newpass2;

  newpass1=http.getparameter("newpass1");
  newpass2=http.getparameter("newpass2");
 
  startpage("Passwort ndern");

  out << "<h1>Passwort ndern</h1>\n\n";

  if(newpass1!=NULL && newpass2!=NULL)
   {
    if(verify_challenge(http.getparameter("challenge"), 
       status.userprofile))
     {
      out << "Fehler: Sicherheitsverletztung\n";
     }
    else if(stricmp(newpass1, newpass2)!=0)
     {
      out << "Fehler: Die eingegebenen Passwrter sind verschieden!\n";
     }
    else if(strlen(newpass1)<4)
     {
      out << "Fehler: Das eingegebene Passwort ist zu kurz!\n";
     }
    else
     {
      const char *tptr;

      tptr=newpass1;

      while(*tptr!=0 && isascii(*tptr) && isalnum(*tptr)) tptr++;

      if(*tptr!=0)
       {
        printf("Fehler: Das eingegebene Passwort enthlt ungltige Zeichen!\n");
       }
      else
       {
        if(!status.userprofile.lock())
         {
          cryptpassword(newpass1, status.userprofile.get_ptr("cryptedpassword"));
          status.userprofile.set("lastpasswordchange", time(NULL));
          status.userprofile.write();
          status.userprofile.unlock();
          userlogprintf1(status, "webonline", "Passwort geaendert!");
          out << "Die nderung wurde gespeichert!\n";
         }
        else
          out << "Fehler: Vorgang fehlgeschlagen!\n";
       }
     }
   }
  else
   {
    out << "No form data\n";
   }

  showcopyright();
  endpage();
 }

