/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include <algorithm>

#include <dboxpath.h>
#include <tools.h>
#include <folder.h>
#include <charsettools.h>
#include <stringtools.h>
#include <getrfczc.h>
#include <newsdb.h>
#include <htmltools.h>

#include "ostatus.h"
#include "webtools.h"
#include "formatmessage.h"
#include "challenge.h"
#include "attachment.h"

void read_web_news(httpt &http, ostream &out,
                   const string &group,
                   getrfct &getrfc)
 {
  string title="Nachricht aus ";
  title+=group;

  const char *uid_ptr=http.getparameter("uid");
  if(uid_ptr==NULL)
   {
    startpage(out, title);
    out << "<p>no uid</p>\n";
    endpage(out);
    return;
   }

  dword uid=atol(uid_ptr), nr;

  if(getrfc.search_uid(uid, nr))
   {
    startpage(out, title);
    out << "<p>no such message</p>\n";
    endpage(out);
    return;
   }

  const char *attachment=http.getparameter("attachment");
  if(attachment==NULL)
   {
    string msg_id="&uid="+i2string((unsigned int)uid)+
                  "&group="+urlize_string(group);

    startpage(out, title);
    getrfc.get_structure(nr);
    format_message(out, 
                   http.getparameter("mimestruct")!=NULL,
                   http.getparameter("source")!=NULL,
                   msg_id,
                   *getrfc.mimestruct,
                   getrfc.rfcm);
    endpage(out);
   }
  else
    read_attachment(out, getrfc, nr, attachment);
 }

