/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

#include <algorithm>

#include <dboxpath.h>
#include <tools.h>
#include <folder.h>
#include <stringtools.h>
#include <newsdb.h>
#include <nls.h>
#include <htmltools.h>

#include "ostatus.h"
#include "webgetrfc.h"
#include "webtools.h"
#include "webnews.h"
#include "readwebnews.h"
#include "webfolder.h"
#include "challenge.h"

string rfc2zc_folder(const string &group)
 {
  string zc_folder="/";
  for(unsigned i=0; i<group.size(); i++)
    if(group[i]=='.')
      zc_folder+='/';
    else
      zc_folder+=tolower(group[i]);

  return zc_folder;
 }

void donews(httpt &http, ostream &out)
 {
  const char *group=http.getparameter("group");

  if(group==NULL)
   {
    startpage(out, "Error");
    out << "no group\n";
    showcopyright(out);
    endpage(out);
    return;
   }
  else
   {
    getrfczct getrfc;
    string title="Nachricht aus ";
    title+=group;

    string zc_folder=rfc2zc_folder(group);

    if(get_news_folder_grants(zc_folder.c_str(), 
       status.userprofile, status.gruppe, TRUE, FALSE, FALSE) ||
       strstr(zc_folder.c_str(), "..")!=NULL)
     {
      startpage(out, title);
      out << "<p>" 
          << nls.get("webonline.news.permission")
          << "</p>\n";
      showcopyright(out);
      endpage(out);
      return;
     }

    if(getrfc.open_news(zc_folder))
     {
      startpage(out, title);
      out << "Ordner " << htmlize_string(group)
          << " nicht verf&uuml;gbar!\n";
      showcopyright(out);
      endpage(out);
      return;
     }

    const char *ptr=http.getparameter("action");
    if(ptr==NULL)
      read_web_folder(http, out, group, getrfc, FALSE, FALSE, FALSE);
    else
     {      
      if(stricmp(ptr, "read")==0)
        read_web_news(http, out, group, getrfc);
      else if(stricmp(ptr, "delete")==0)
       {
        if(!verify_challenge(http.getparameter("challenge"), status.userprofile))
         {
         }
        return;
       }
      else
       {
        startpage(out, title);
        out << "<p>action unknown</p>\n";
        showcopyright(out);
        endpage(out);
       }
     }
   }
 }
