/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "check_quota.h"
#include "list_quota.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();

  parseoptionst():parseoptions_baset("u:vl") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="webquota.log";
    logf.setlogfile(logfile);
   }

  if(cmdline.isset('u'))
    check_webquota(cmdline.getval('u'), cmdline.isset('v'));
  else if(cmdline.isset('l'))
    list_webquota();
  else
    check_webquota(cmdline.isset('v'));
 
  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * WEBQUOTA - DBOX Module - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " webquota [-?] [-h]           Display help\n"
    " webquota -u name             check homepage quotas of given user/alias\n"
    " webquota -l                  list quota usage (stdin)\n"
    " webquota                     check homepage quotas\n"
    "\n"
    "Additional options:\n"
    " -bboxname\r\n"
    " -v verbose\r\n"
    "\r\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
