#include <iostream.h>
#include <fstream.h>

#include <mtoolerfc.h>
#include <spoolf.t>
#include <mtoolzc.h>
#include <zc2rfc.h>

#include "g_zc2rfc.h"

class spool_gate_z2rt:public spoolft<zcmessaget>
 {
 public:
  virtual void spoolf3();

  spool_gate_z2rt(ofstream &_out):out(_out) { }

  ofstream &out;
 };

static void strip_realname(char *address)
 {
  char *tptr=strchr(address, ' ');
  if(tptr!=NULL) *tptr=0;
 }

void spool_gate_z2rt::spoolf3()
 {
   {
    char envelope_from[TEXTLEN];
    m.findsingleheader(envelope_from, "WAB", TEXTLEN-1);
    if(envelope_from[0]==0)
      m.findsingleheader(envelope_from, "ABS", TEXTLEN-1);

    strip_realname(envelope_from);
    out << "FROM: " << envelope_from << "\n";
   }

   {
    const char *start=m.data, *text;

    while(!m.findheader(&start, "EMP", &text))
     {
      char envelope_to[TEXTLEN];
      m.copyheadertext(envelope_to, text, TEXTLEN-1);
      strip_realname(envelope_to);
      out << "RCPT: " << envelope_to << "\n";
     }
   }

  streampos msg_len_pos=out.tellp();
  out.form("LEN: %20lu\n", 0L);

  out << "\n";

  streampos msg_start_pos=out.tellp();
  if(zc2rfc(m, out, FALSE, FALSE))
   {
    cerr << "zc2rfc: conversion error\n";
    return;
   }

  streampos msg_end_pos=out.tellp();
  streampos msg_len=msg_end_pos-msg_start_pos;

  out.seekp(msg_len_pos);
  out.form("LEN: %20lu\n", msg_len);
  out.seekp(msg_end_pos);
 }

bool gate_z2r(const string &infilename, const string &outfilename)
 {
  ofstream outfile(outfilename.c_str(), ios::out|ios::bin);

  outfile.seekp(0, ios::end);

  if(!outfile)
   {
    cerr << "failed to open " << outfilename << "\n";
    return TRUE;
   }

  spool_gate_z2rt spool(outfile);

  if(spool.spoolf(infilename.c_str(), FALSE))
   {
    cerr << "conversion error\n";
    return TRUE;
   }

  return FALSE;
 }

