/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <logf.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "g_rfc2zc.h"
#include "g_zc2rfc.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("(z2r)(r2z)") { }
 };

int parseoptionst::doit()
 {
   { 
    string logfile;
    getboxlogdir(logfile, config.boxdir);
    logfile+="zcgate.log";
    logf.setlogfile(logfile);
   }

  if(cmdline.isset("z2r"))
   {
    if(cmdline.argcount!=2) { usage_error(); return 1; }
    gate_z2r(cmdline.args[0], cmdline.args[1]);
   }
  else if(cmdline.isset("r2z"))
   {
    if(cmdline.argcount!=2) { usage_error(); return 1; }
    gate_r2z(cmdline.args[0], cmdline.args[1]);
   }
  else
    help();

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * ZCGATE - DBOX Module for Message Conversion - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " zcgate [-?] [-h]             show help\n"
    " zcgate --z2r infile outfile  convert from zconnect to rfc\n"
    " zcgate --r2z infile outfile  convert form rfc to zconnect\n"
    "\n"
    "Additonal options:\n"
    "\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
